
  #INCLUDE "_intestazione.bas"

  ' ----------------------------------------
  ' ---------- RECUPERO VARIABILI ----------
  ' ----------------------------------------

  DIM x, y, z, n, w, k, i, q AS UBYTE

  DIM nn, qq, xx, zz, temp AS UINTEGER

  DIM naz AS UBYTE
  naz = PEEK (@memo)

  DIM fondi AS INTEGER
  fondi = PEEK (UINTEGER, @memo + 1)

  DIM stru(3,9) AS UBYTE
  x = 1
  DO
    stru(1,x) = PEEK (@memo + 10 + x)
    stru(2,x) = PEEK (@memo + 19 + x)
    stru(3,x) = PEEK (@memo + 28 + x)
    x = x + 1
  LOOP UNTIL x = 10

  DIM strt$(4)
  strt$(1) = "LAUNCH PAD "
  strt$(2) = " TRAIN.FAC."
  strt$(3) = "ASSEMB.FAC. "
  strt$(4) = " R&D LAB."

  rigav$ = "                                "
  sce1$ = "\{i7}\{b1} 1 "
  sce0$ = "\{i7}\{b1} 0 "
  ind$ = "(0=BACK)"
  disp$ = "AVAIL."
  incostr$ = "TURNS: "
  fond$ = "FUNDS: "
  st$ = "\{i7}\{b1} FACILITIES "

  ' Strutture
  ' ---------

  ' stru(3,9)

  ' stru(1,x) = valore
  ' stru(2,x) = tempo di costruzione/riparazione
  ' stru(3,x) = costo

  ' 1: Rampa di lancio 1. Presente dall'inizio
  ' 2: Rampa di lancio 2. TDC: 2. Costo: 30
  ' 3: Rampa di lancio 3. TDC: 2. Costo: 30
  ' 4: Addestramento piloti base. TDC: 3. Costo: 55
  ' 5: Addestramento piloti avanzato. TDC: 4. Costo: 80
  ' 6: Assemblaggio veicoli piccoli/medi. Presente dall'inizio
  ' 7: Assemblaggio veicoli grandi. TDC: 3. Costo: 60
  ' 8: Centro R&S base. Presente dall'inizio
  ' 9: Centro R&S avanzato. TDC: 3. Costo: 70

  ' Valori rampe di lancio
  ' 0: non costruita
  ' 1: disponibile
  ' 2: occupata
  ' 3: in costruzione
  ' 4: in riparazione

  ' Valori altre strutture:
  ' 0: non costruita
  ' 1: disponibile
  ' 3: in costruzione

  ' --------------------------------------
  ' ---------- INIZIO PROGRAMMA ----------
  ' --------------------------------------

  dzx7AgileRCS(@strutture0,16384)

  ' Valori di x per disegnare il cantiere
  ' 10 = prima rampa
  ' 5  = seconda rampa
  ' 0  = terza rampa
  ' 87 = addestramento avanzato
  ' 67 = assemblaggio grande
  ' 23 = laboratorio avanzato

  ' Disegna le rampe

  x = 11 : i = 1
  DO
  ' Rampa in costruzione/riparazione
  IF stru(1,i) > 2 THEN
    z = 4
    y = 4
    cantierebasso()
  END IF
  ' Rampa attiva
  IF stru(1,i) = 1 OR stru(1,i) = 2 THEN
    z = 3
    y = 4
    qq = 18432+x
    temp = @rampap
    disepix()
    qq = 22784+x
    temp = @rampaa
    diseatt()
  END IF
  ' Rampa occupata
  IF stru(1,i) = 2 THEN
    q = x
    x = x+32
    y = 2
    z = 1
    qq = 18432+x
    temp = @razzop
    disepix()
    x = q
  END IF
    i = i + 1
    x = x - 5
  LOOP UNTIL i = 4

  ' Disegna il centro addestramento avanzato in costruzione

  IF stru(1,5) = 3 THEN
    x = 87
    cantierealto()
  END IF

  ' Disegna il centro addestramento avanzato

  IF stru(1,5) = 1 THEN
    x = 86
    y = 4
    z = 6
    qq = 16384+x
    temp = @addavp
    disepix()
    qq = 22528+x
    temp = @addava
    diseatt()
  END IF

  ' Disegna il centro assemblaggio grande in costruzione

  IF stru(1,7) = 3 THEN
    x = 67
    cantierealto()
  END IF

  ' Disegna il centro assemblaggio grande

  IF stru(1,7) = 1 THEN
    x = 34
    y = 6
    z = 5
    qq = 16384+x
    temp = @assgrp
    disepix()
    qq = 22528+x
    temp = @assgra
    diseatt()
  END IF

  ' Disegna il laboratorio avanzato in costruzione

  IF stru(1,9) = 3 THEN
    x = 23
    cantierebasso()
  END IF

  ' Disegna il laboratorio avanzato
  
  IF stru(1,9) = 1 THEN
    x = 22
    y = 4
    z = 7
    qq = 18432+x
    temp = @labavp
    disepix()
    qq = 22784+x
    temp = @labava
    diseatt()
  END IF

  PRINT AT 16,10; PAPER naz; st$

  premitasto()

  diss()

strutture:

  CLS

  PRINT AT 1,10; PAPER naz; st$

  ' Stampa l'elenco delle strutture

  n = 1
  DO
    PRINT AT n+2,1; n; "."
	n = n + 1
  LOOP UNTIL n = 10

  PRINT AT 3,3; strt$(1)+"1"; AT 4,3; strt$(1)+"2"; AT 5,3; strt$(1)+"3"; AT 6,3; "BASIC";strt$(2); AT 6,22; disp$; AT 7,3; "ADV.";strt$(2); AT 8,3; strt$(3)+"S/M"; AT 8,22; disp$; AT 9,3; strt$(3)+"LARGE"; AT 10,3; "BASIC";strt$(4); AT 10,22; disp$; AT 11,3; "ADV.";strt$(4); AT 18,1; "BUILD A FACILITY?"; AT 19,1; ind$; AT 13,1; INK naz; fond$; fondi; 

  ' Stampa le condizioni delle strutture

  n = 1
  DO
    IF stru(1,n) = 0 THEN PRINT AT n+2,22; INK naz; "COST: ";stru(3,n)
    IF stru(1,n) = 1 THEN PRINT AT n+2,22; disp$
    IF stru(1,n) = 2 THEN PRINT AT n+2,22; "OCCUPIED"
    IF stru(1,n) = 3 THEN PRINT AT n+2,22; incostr$; stru(2,n)
    IF stru(1,n) = 4 THEN PRINT AT n+2,22; "IN REPAIR"
	n = n + 1
  LOOP UNTIL n = 10

  ' Chiedi quale struttura costruire

chiedicostr:

  inp()

  IF i = 0 THEN GOTO backup

  IF i > 9 THEN GOTO chiedicostr

  ' Controlla se la struttura è già stata costruita

  IF stru(1,i) <> 0 THEN GOTO chiedicostr

  ' Verifica se abbiamo fondi a sufficienza

  IF stru(3,i) > fondi THEN nofondi() : GOTO strutture

  ' Stabilisce i costi

  PRINT AT 19,1; "N.";i;" - TURNS: "; stru(2,i)

  ' Chiede conferma

  conferma()

  IF k = 0 THEN GOTO strutture

  ' In caso di conferma, scala i fondi necessari e segna la struttura come "in costruzione"

  fondi = fondi - stru(3,i): stru(1,i) = 3: GOTO strutture

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

  ' Vengono salvate solo le variabili modificate dal programma

backup:

  POKE UINTEGER @memo + 1, fondi

  x = 1
  DO
    POKE @memo + 10 + x, stru(1,x)
    POKE @memo + 19 + x, stru(2,x)
    POKE @memo + 28 + x, stru(3,x)
    x = x + 1
  LOOP UNTIL x = 10

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------

  POKE @segue,1

  END

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Mostra il messaggio "premi un tasto" e mette il gioco in pausa finché non si preme un tasto

SUB premitasto()

  FLASH 0: PRINT AT 22,8; "\{p3}\{i7}\{b1} PRESS ANY KEY ": INK 0: PAUSE 0
  bip()

END SUB

  ' Inserisce un valore numerico. Il valore è conservato in i

SUB inp()

   v$=""
   cancerig()
   PRINT AT 21,2; "CHOICE: "; "\{f1} "; "\{f0}  "

10 PAUSE 0
   
   IF CODE INKEY$ = 13 THEN GOTO 20
   IF CODE INKEY$ = 12 AND LEN v$ > 0 THEN v$ = v$(TO LEN (v$)-1) :	 GOTO 15
   IF CODE INKEY$ < 48 OR CODE INKEY$ > 57 THEN GOTO 10
   IF LEN v$ < 2 THEN v$ = v$+INKEY$
   
15 PRINT AT 21,10; v$; "\{f1} "; "\{f0} "
   GOTO 10

20 IF v$ = "" THEN GOTO 10

   cancerig()
   i = VAL(v$) 

END SUB

  ' Conferma/annulla

SUB conferma()

  PRINT AT 21,8; "CONFIRM"; AT 23,8; "CANCEL"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

attendiconf:

  PAUSE 0

  IF INKEY$ = "1" THEN LET k = 1: GOTO esci
  IF INKEY$ = "0" THEN LET k = 0: GOTO esci
 
  GOTO attendiconf

esci:

  bip()

  cancerig()

END SUB

  ' Cancella le ultime tre righe dello schermo

SUB cancerig()

  n = 21
  DO
    PRINT AT n,0; rigav$
    n = n + 1
 LOOP UNTIL n = 24

END SUB

  ' Stampa l'avviso "fondi insufficienti"

SUB nofondi()

  CLS
  POKE UINTEGER indir,@nofond
  stampa()
  premitasto()

END SUB

  ' Disegna la struttura, il cantiere e il razzo
  ' --------------------------------------------
  ' x = scostamento disegno rispetto all'angolo superiore sinistro
  ' 16384 = inizio pixel primo terzo
  ' 16384+2048 = 18432 inizio pixel secondo terzo
  ' 22528 = inizio attributi primo terzo
  ' 22528+256 = 22784 inizio attributi primo terzo
  ' y = numero di righe -1
  ' z = larghezza in blocchi attributi -1
  ' xx = fine attributi
  ' temp = inizio dei dati

  ' Richiama gli attributi

SUB diseatt()

  ' m va sempre da 0 a 7
  ' nn va da zz a zz + il numero di righe (caratteri) totali -1

  xx = qq+32*y

ATTRIBUTI:

  zz = qq
  FOR nn = zz TO zz + z
    POKE nn, PEEK temp
	temp = temp + 1
  NEXT nn
    qq = qq + 32
  IF qq <= xx THEN GOTO ATTRIBUTI

END SUB

  ' Richiama i pixel

SUB disepix()

  xx = qq+32*y

PIXEL:

  zz = qq
  FOR m = 0 TO 7
    FOR nn = zz TO zz + z
      POKE nn, PEEK temp
      temp = temp + 1
    NEXT nn
    zz = zz + 256
  NEXT m
  qq = qq + 32
  IF qq <= xx THEN GOTO PIXEL

END SUB

  ' Disegna il cantiere nel primo terzo dello schermo

SUB cantierealto()
  y = 4
  z = 4
  qq = 16384+x
  temp = @cantierep 
  disepix()
  qq = 22528+x
  temp = @cantierea
  diseatt()

END SUB

  ' Disegna il cantiere nel secondo terzo dello schermo

SUB cantierebasso()
 
  y = 4
  z = 4
  qq = 18432+x
  temp = @cantierep 
  disepix()
  qq = 22784+x
  temp = @cantierea
  diseatt()

END SUB

  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

nofond:
ASM
  DEFB 22, 11, 7
  DEFB 18, 1
  DEFB 32, 195
  DEFM "ENOUGH FUNDS "
  DEFB 255
END ASM

  ' -----------------------------
  ' ---------- GRAFICA ----------
  ' -----------------------------

strutture0:
ASM
  INCBIN "strutture0-ZX7.bin"
END ASM

rampap:
ASM
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 63, 255, 224
  DEFB 0, 36, 164, 96, 0, 42, 74, 160, 0, 63
  DEFB 253, 32, 0, 0, 2, 160, 0, 0, 2, 96
  DEFB 0, 0, 2, 160, 0, 0, 3, 32, 0, 0
  DEFB 2, 160, 0, 0, 2, 96, 0, 0, 2, 160
  DEFB 0, 0, 3, 32, 0, 0, 254, 160, 0, 0
  DEFB 170, 96, 0, 0, 254, 160, 0, 0, 3, 32
  DEFB 0, 0, 2, 160, 0, 0, 2, 96, 0, 0
  DEFB 2, 160, 0, 0, 3, 32, 255, 255, 2, 160
  DEFB 128, 1, 2, 96, 128, 1, 2, 160, 128, 1
  DEFB 3, 32, 128, 1, 2, 160, 128, 1, 2, 96
  DEFB 128, 1, 14, 184, 128, 1, 11, 232, 128, 1
  DEFB 8, 8, 128, 1, 15, 248, 128, 1, 0, 0
  DEFB 128, 1, 0, 0, 255, 255, 0, 0, 170, 171
  DEFB 0, 0, 213, 85, 0, 0, 255, 255, 0, 0
END ASM

addavp:
ASM
  DEFB 0, 254, 0, 0, 0, 127, 0, 0, 252, 0
  DEFB 0, 0, 63, 0, 0, 248, 0, 60, 0, 31
  DEFB 0, 0, 240, 1, 235, 128, 15, 0, 0, 224
  DEFB 7, 95, 224, 7, 0, 0, 192, 10, 255, 240
  DEFB 3, 0, 0, 128, 21, 255, 248, 1, 0, 0
  DEFB 0, 43, 255, 252, 0, 0, 0, 0, 85, 255
  DEFB 254, 0, 0, 0, 0, 107, 255, 254, 0, 0
  DEFB 0, 0, 215, 255, 255, 0, 0, 0, 0, 171
  DEFB 255, 255, 0, 0, 0, 0, 87, 255, 254, 0
  DEFB 0, 0, 0, 106, 255, 254, 0, 0, 0, 0
  DEFB 53, 127, 252, 0, 0, 0, 0, 42, 191, 252
  DEFB 0, 0, 255, 128, 29, 85, 248, 1, 255, 1
  DEFB 192, 3, 235, 192, 2, 128, 85, 224, 0, 60
  DEFB 0, 5, 170, 85, 240, 0, 0, 0, 10, 170
  DEFB 1, 248, 0, 0, 0, 21, 128, 85, 252, 0
  DEFB 0, 0, 42, 170, 85, 254, 0, 0, 0, 85
  DEFB 170, 1, 255, 0, 0, 0, 170, 128, 255, 128
  DEFB 255, 255, 255, 85, 255, 1, 64, 128, 129, 1
  DEFB 170, 128, 85, 32, 170, 189, 85, 85, 170, 85
  DEFB 16, 170, 165, 85, 170, 170, 1, 8, 128, 189
  DEFB 1, 85, 128, 85, 4, 170, 129, 85, 170, 170
  DEFB 85, 2, 170, 189, 85, 85, 170, 1, 1, 128
  DEFB 165, 1, 170, 128, 0, 128, 255, 189, 255, 85
  DEFB 0, 0, 192, 136, 0, 17, 170, 0, 0, 224
  DEFB 170, 60, 85, 84, 0, 0, 240, 170, 195, 85
  DEFB 168, 0, 0, 248, 136, 153, 17, 80, 0, 0
  DEFB 252, 170, 165, 85, 160, 0, 0, 254, 170, 165
  DEFB 85, 64, 0, 0, 255, 136, 165, 17, 128, 0
END ASM

assgrp:
ASM
  DEFB 0, 255, 255, 255, 255, 0, 0, 128, 0, 0
  DEFB 1, 0, 0, 128, 0, 0, 1, 0, 0, 128
  DEFB 0, 0, 1, 0, 0, 128, 0, 0, 1, 0
  DEFB 0, 128, 0, 0, 1, 0, 0, 128, 0, 0
  DEFB 1, 0, 0, 128, 0, 0, 1, 0, 255, 128
  DEFB 0, 0, 1, 255, 128, 128, 0, 0, 1, 1
  DEFB 128, 128, 0, 0, 1, 1, 128, 128, 0, 0
  DEFB 1, 1, 128, 128, 0, 0, 1, 1, 128, 128
  DEFB 0, 0, 1, 1, 128, 128, 0, 0, 1, 1
  DEFB 128, 128, 0, 0, 1, 1, 128, 128, 0, 0
  DEFB 1, 1, 128, 128, 0, 0, 1, 1, 128, 128
  DEFB 0, 0, 1, 1, 128, 128, 0, 0, 1, 1
  DEFB 128, 128, 0, 0, 1, 1, 128, 128, 0, 0
  DEFB 1, 1, 128, 128, 0, 0, 1, 1, 128, 255
  DEFB 255, 255, 255, 1, 255, 128, 0, 0, 1, 255
  DEFB 128, 128, 0, 0, 1, 1, 128, 128, 0, 0
  DEFB 1, 1, 128, 128, 0, 0, 1, 1, 128, 128
  DEFB 0, 0, 1, 1, 128, 128, 0, 0, 1, 1
  DEFB 128, 128, 0, 0, 1, 1, 128, 128, 0, 0
  DEFB 1, 1, 128, 128, 255, 255, 1, 1, 128, 128
  DEFB 255, 255, 1, 1, 128, 128, 225, 135, 1, 1
  DEFB 128, 128, 209, 139, 1, 1, 128, 128, 201, 147
  DEFB 1, 1, 128, 128, 197, 163, 1, 1, 128, 128
  DEFB 195, 195, 1, 1, 128, 128, 197, 163, 1, 1
  DEFB 128, 128, 201, 147, 1, 1, 128, 128, 209, 139
  DEFB 1, 1, 128, 128, 239, 247, 1, 1, 128, 128
  DEFB 209, 139, 1, 1, 128, 128, 201, 147, 1, 1
  DEFB 128, 128, 197, 163, 1, 1, 128, 128, 195, 195
  DEFB 1, 1, 255, 128, 197, 163, 1, 255, 0, 128
  DEFB 201, 147, 1, 0, 0, 128, 209, 139, 1, 0
  DEFB 0, 128, 239, 247, 1, 0, 0, 128, 209, 139
  DEFB 1, 0, 0, 128, 201, 147, 1, 0, 0, 128
  DEFB 197, 163, 1, 0, 0, 128, 195, 195, 1, 0
  DEFB 0, 255, 255, 255, 255, 0
END ASM

labavp:
ASM
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 15, 240, 0
  DEFB 0, 0, 0, 0, 0, 63, 252, 0, 0, 0
  DEFB 60, 0, 0, 127, 254, 0, 0, 60, 126, 0
  DEFB 0, 255, 255, 0, 0, 126, 255, 0, 0, 255
  DEFB 255, 0, 0, 255, 126, 0, 0, 255, 255, 0
  DEFB 0, 126, 60, 0, 0, 255, 255, 0, 0, 60
  DEFB 0, 0, 0, 127, 254, 0, 0, 0, 0, 0
  DEFB 0, 63, 252, 0, 0, 0, 0, 0, 0, 15
  DEFB 240, 0, 0, 0, 60, 0, 0, 0, 0, 0
  DEFB 0, 60, 126, 0, 0, 0, 0, 0, 0, 126
  DEFB 255, 0, 0, 0, 0, 0, 0, 255, 126, 0
  DEFB 0, 16, 8, 0, 0, 126, 60, 0, 0, 18
  DEFB 72, 0, 0, 60, 0, 102, 102, 2, 64, 102
  DEFB 102, 0, 24, 68, 68, 16, 8, 68, 68, 24
  DEFB 0, 0, 0, 18, 72, 0, 0, 0, 24, 102
  DEFB 102, 2, 64, 102, 102, 24, 0, 68, 68, 16
  DEFB 8, 68, 68, 0, 24, 0, 0, 18, 72, 0
  DEFB 0, 24, 0, 102, 102, 2, 64, 102, 102, 0
  DEFB 24, 68, 68, 16, 8, 68, 68, 24, 0, 0
  DEFB 0, 18, 72, 0, 0, 0, 24, 102, 102, 2
  DEFB 64, 102, 102, 24, 0, 68, 68, 16, 8, 68
  DEFB 68, 0, 24, 0, 0, 18, 72, 0, 0, 24
  DEFB 0, 0, 0, 2, 64, 0, 0, 0, 24, 0
  DEFB 0, 0, 0, 0, 0, 24, 126, 0, 0, 124
  DEFB 62, 0, 0, 126, 60, 0, 0, 61, 188, 0
  DEFB 0, 60, 0, 0, 0, 13, 176, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
END ASM

razzop:
ASM
  DEFB 1, 128, 1, 128, 3, 192, 3, 192, 2, 64
  DEFB 2, 64, 2, 64, 2, 64, 3, 192, 2, 64
  DEFB 2, 64, 2, 99, 2, 92, 2, 64, 3, 192
  DEFB 3, 192, 254, 127, 130, 65, 130, 65, 133, 161
  DEFB 133, 161, 141, 177, 143, 241, 129, 129
END ASM

cantierep:
ASM
  DEFB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 15, 0, 0, 0, 0
  DEFB 0, 0, 0, 0, 0, 15, 0, 0, 0, 0
  DEFB 233, 85, 128, 0, 0, 239, 42, 192, 0, 0
  DEFB 192, 0, 72, 8, 8, 13, 0, 8, 8, 8
  DEFB 11, 0, 72, 8, 8, 13, 0, 168, 8, 8
  DEFB 11, 0, 237, 88, 8, 13, 0, 10, 168, 8
  DEFB 11, 0, 13, 88, 8, 13, 0, 10, 168, 8
  DEFB 11, 15, 255, 255, 248, 13, 8, 10, 168, 8
  DEFB 11, 9, 93, 93, 8, 13, 10, 170, 170, 136
  DEFB 11, 9, 93, 93, 8, 13, 10, 170, 170, 136
  DEFB 11, 9, 93, 93, 8, 13, 10, 170, 170, 136
  DEFB 31, 255, 255, 255, 248, 26, 170, 170, 170, 168
  DEFB 21, 93, 93, 93, 88, 26, 170, 170, 170, 168
  DEFB 21, 93, 93, 93, 88, 26, 170, 170, 170, 168
  DEFB 21, 93, 93, 93, 88, 255, 255, 255, 255, 255
  DEFB 170, 170, 170, 170, 171, 170, 170, 170, 170, 171
  DEFB 170, 170, 170, 170, 171, 170, 170, 170, 170, 171
  DEFB 170, 170, 170, 170, 171, 170, 170, 170, 170, 171
  DEFB 170, 170, 170, 170, 171, 255, 255, 255, 255, 255
END ASM

rampaa:
ASM
  DEFB 32, 35, 35, 35, 32, 32, 35, 35, 32, 32
  DEFB 35, 35, 120, 120, 35, 35, 120, 120, 35, 35
END ASM

addava:
ASM
  DEFB 32, 44, 41, 41, 41, 44, 32, 40, 40, 41
  DEFB 41, 41, 40, 40, 112, 46, 41, 41, 41, 46
  DEFB 112, 112, 48, 112, 120, 112, 38, 112, 32, 52
  DEFB 120, 120, 120, 38, 32
END ASM

assgra:
ASM
  DEFB 32, 112, 112, 112, 112, 32, 112, 112, 112, 112
  DEFB 112, 48, 112, 112, 112, 112, 112, 48, 120, 120
  DEFB 120, 120, 120, 56, 120, 120, 105, 105, 120, 56
  DEFB 120, 120, 105, 105, 120, 56, 32, 120, 105, 105
  DEFB 120, 32
END ASM

labava:
ASM
  DEFB 34, 32, 34, 35, 35, 32, 34, 34, 50, 72
  DEFB 72, 59, 59, 72, 72, 50, 50, 104, 104, 56
  DEFB 56, 104, 104, 50, 50, 104, 104, 56, 56, 104
  DEFB 104, 50, 38, 32, 38, 39, 39, 32, 38, 38
END ASM

cantierea:
ASM
  DEFB 38, 38, 38, 32, 32, 38, 32, 32, 32, 32
  DEFB 38, 32, 32, 32, 32, 32, 32, 32, 32, 32
  DEFB 104, 104, 104, 104, 104
END ASM