  #INCLUDE "_intestazione.bas"

  ' Immagine sala di controllo missione

  CONST adfont AS UINTEGER = 25044
  CONST salacm AS UINTEGER = 34033
  CONST animfont AS UINTEGER = 36550

  DECLARE FUNCTION FASTCALL time() as uLong 
  DECLARE FUNCTION FASTCALL randomBase AS UBYTE
  DECLARE FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE

  ' ----------------------------------------
  ' ---------- RECUPERO VARIABILI ----------
  ' ----------------------------------------

  DIM x, y, z, n, w, k, i, q AS UBYTE

  DIM nn, qq, zz, temp AS UINTEGER

  DIM naz AS UBYTE
  naz = PEEK (@memo)

  DIM prestigio AS INTEGER
  prestigio = PEEK (UINTEGER, @memo + 3)

  DIM modif AS BYTE
  modif = PEEK (@memo + 10)

  DIM stru(3,9) AS UBYTE
  x = 1
  DO
    stru(1,x) = PEEK (@memo + 10 + x)
    stru(2,x) = PEEK (@memo + 19 + x)
    stru(3,x) = PEEK (@memo + 28 + x)
    x = x + 1
  LOOP UNTIL x = 10

  DIM abi(8,10) AS UBYTE
  x = 1
  DO
    abi(1,x) = PEEK (@memo + 37 + x)
    abi(2,x) = PEEK (@memo + 47 + x)
    abi(3,x) = PEEK (@memo + 57 + x)
    abi(4,x) = PEEK (@memo + 67 + x)
    abi(5,x) = PEEK (@memo + 77 + x)
    abi(6,x) = PEEK (@memo + 87 + x)
    abi(7,x) = PEEK (@memo + 97 + x)
    abi(8,x) = PEEK (@memo + 107 + x)
    x = x + 1
  LOOP UNTIL x = 11

  ' Descrizione materiale:
  ' Ogni materiale è contraddistinto da un numero, che serve da guida
  ' per tutte le variabili relative a esso.
  
  '  1 - Satellite orbitale terrestre
  '  2 - Satellite orbitale lunare
  '  3 - Sonda lunare
  '  4 - Capsula monoposto
  '  5 - Capsula biposto
  '  6 - Capsula triposto
  '  7 - Mini navetta riutilizzabile
  '  8 - Veicolo lunare
  '  9 - Modulo lunare monoposto  
  ' 10 - Modulo lunare biposto
  ' 11 - Modulo aggancio
  ' 12 - Tuta AEV
  ' 13 - Razzo vettore leggero
  ' 14 - Razzo vettore medio
  ' 15 - Razzo vettore pesante
  ' 16 - Razzo vettore super
  ' 17 - Parte ausiliaria
  ' 18 - Modulo servizio A
  ' 19 - Modulo servizio B

  DIM rsmax(19) AS UBYTE
  DIM effmax(19) AS UBYTE
  DIM qt(19) AS UBYTE
  DIM rsatt(19) AS UBYTE
  DIM effatt(19) AS BYTE
  x = 1
  DO
    rsmax(x) = PEEK (@memo + 173 + x)
    effmax(x) = PEEK (@memo + 192 + x)
    qt(x) = PEEK (@memo + 230 + x)
    rsatt(x) = PEEK (@memo + 249 + x)
    effatt(x) = PEEK (@memo + 268 + x)
    x = x + 1
  LOOP UNTIL x = 20

  DIM miss(16,3) AS UBYTE
  DIM effmis(3) AS BYTE
  DIM totalmis(3) AS UBYTE
  x = 1
  DO
    miss(1,x) = PEEK (@memo + 330 + x)
    miss(2,x) = PEEK (@memo + 333 + x)
    miss(3,x) = PEEK (@memo + 336 + x)
    miss(4,x) = PEEK (@memo + 339 + x)
    miss(5,x) = PEEK (@memo + 342 + x)
    miss(6,x) = PEEK (@memo + 345 + x)
    miss(7,x) = PEEK (@memo + 348 + x)
    miss(8,x) = PEEK (@memo + 351 + x)
    miss(9,x) = PEEK (@memo + 354 + x)
    miss(10,x) = PEEK (@memo + 357 + x)
    miss(11,x) = PEEK (@memo + 360 + x)
    miss(12,x) = PEEK (@memo + 363 + x)
    miss(13,x) = PEEK (@memo + 366 + x)
    miss(14,x) = PEEK (@memo + 369 + x)
    miss(15,x) = PEEK (@memo + 372 + x)
    miss(16,x) = PEEK (@memo + 375 + x)
    effmis(x) = PEEK (@memo + 378 + x)
    totalmis(x) = PEEK (@memo + 381 + x)
    x = x + 1
  LOOP UNTIL x = 4

  DIM mpr(16) AS UBYTE

  DIM pm(6) AS UBYTE
  x = 1
  DO
    pm(x) = PEEK (@memo + 400 + x)
    x = x + 1
  LOOP UNTIL x = 7

  DIM pmbon(6) AS UBYTE => {12,16,8,10,12,20}

  DIM bonuspre AS BYTE
  ' bonuspre = PEEK (@memo + 407)

  DIM bonabi AS UBYTE
  ' bonabi = PEEK (@memo + 410)

  DIM pen AS UBYTE
  pen = PEEK (@memo + 415)

  DIM pilost$(10)
  x = 1
  DO
    pilost$(x) = CHR$(PEEK(@memo + 415 + x))
    x = x + 1
  LOOP UNTIL x = 11

  DIM navetta AS BYTE
  DIM fase AS UBYTE
  DIM rand AS BYTE
  DIM statomis AS UBYTE
  DIM prob AS BYTE

  ' Efficienza totale della fase (efficienza di base della missione + bonus abilità piloti - modificatore)

  DIM efftot AS BYTE

  ' Gravità del malfunzionamento

  DIM grav AS BYTE

  DIM mate$(19)
  IF naz = 1 THEN
    mate$(1) = "EXPLORER"
    mate$(2) = "RANGER"
    mate$(3) = "SURVEYOR"
    mate$(4) = "MERCURY"
    mate$(5) = "GEMINI"
    mate$(6) = "APOLO"
    mate$(7) = "XMS-2"
    mate$(8) = "JtPITER"
    mate$(9) = "LM-1"
    mate$(10) = "LEM"
    mate$(13) = "ATLAS"
    mate$(14) = "TITbN"
    mate$(15) = "SATURNO V"
    mate$(16) = "NOVA"
    mate$(17) = "BOOSTER"
  ELSE
    mate$(1) = "SPUTNIK"
    mate$(2) = "KOSMOS"
    mate$(3) = "LUNA"
    mate$(4) = "VOSTOK"
    mate$(5) = "VOSJOD"
    mate$(6) = "SOYUZ"
    mate$(7) = "SPIRAL"
    mate$(8) = "LK-700"
    mate$(9) = "LK"
    mate$(10) = "LEK"
    mate$(13) = "R-7"
    mate$(14) = "11A511"
    mate$(15) = "N1"
    mate$(16) = "UR-700"
    mate$(17) = "STADIO AUS."
  END IF

  mate$(11) = "M.ATRAQUE"
  mate$(12) = "TRAJE AEV"
  mate$(18) = "MoD.SER.A"
  mate$(19) = "MoD.SER.B"

  DIM pilo$(10)
  IF naz = 1 THEN
    pilo$(1) = "SHEPARD"
    pilo$(2) = "GLENN"
    pilo$(3) = "COOPER"
    pilo$(4) = "SCHIRRA"
    pilo$(5) = "GRISSOM"
    pilo$(6) = "YOUNG"
    pilo$(7) = "COLLINS"
    pilo$(8) = "ARMSTRONG"
    pilo$(9) = "ALDRIN"
    pilo$(10) = "WHITE"
  ELSE
    pilo$(1) = "GAGARIN"
    pilo$(2) = "TITOV"
    pilo$(3) = "LEoNOV"
    pilo$(4) = "TERESHKOVA"
    pilo$(5) = "BYKOVSKIJ"
    pilo$(6) = "BELIbYEV"
    pilo$(7) = "GORBATKo"
    pilo$(8) = "KOMAROV"
    pilo$(9) = "BEREGoVOI"
    pilo$(10) = "POPOVICH"
  END IF

  DIM pimi$(6)
  pimi$(1) = "O SATgLITE ARTIFICIAL"
  pimi$(2) = "O VUELO ESPACIAL HUMANO"
  pimi$(3) = "O PASEO ESPACIAL"
  pimi$(4) = "O SATgLITE EN oRB.LUNAR"
  pimi$(5) = "A SONDA EN LA LUNA"
  pimi$(6) = "O VUELO HUMANO oRB.LUNAR"

  DIM scena AS UINTEGER

  DIM id, pilota, scelta AS UBYTE
 
  ' Controlla se ci sono missioni pianificate.
  ' In tal caso, effettua una serie di verifiche per ogni passaggio.
  ' Più una missione è complessa, più passaggi deve attraversare.
  ' Verifica a seconda delle fasi se la missione ha avuto successo o è fallita, in tutto o in parte.
  ' Calcola il punteggio e il prestigio guadagnato o perso.

  ' Le fasi e i relativi materiali interessati sono:
  '  1) Decollo - Razzo, potenziamento (se presente)
  '  2) Ingresso in orbita terrestre - Razzo
  '  3) Attività in orbita terrestre - Capsula, mini-navetta, satellite
  '  4) Uscita da orbita terrestre - Razzo, modulo di servizio
  '  5) Percorso Terra-Luna - Satellite lunare, sonda, capsula, mini-navetta, veicolo lunare
  '  6) Ingresso in orbita lunare - Capsula, veicolo lunare, modulo di servizio, satellite, sonda
  '  7) Avvicinamento lunare - Modulo lunare, veicolo lunare, sonda
  '  8) Ricognizione lunare - Satellite lunare
  '  9) Atterraggio lunare - Modulo lunare, veicolo lunare, sonda
  ' 10) Passeggiata lunare - Tuta AEV
  ' 11) Partenza dal suolo lunare - Modulo lunare, veicolo lunare
  ' 12) Attività in orbita lunare - Capsula, mini-navetta, veicolo lunare
  ' 13) Aggancio (dopo missione lunare) - Modulo aggancio
  ' 14) Passeggiata spaziale - Tuta AEV
  ' 15) Uscita da orbita lunare - Capsula, modulo di servizio
  ' 16) Percorso Luna-Terra - Capsula, mini-navetta, veicolo lunare
  ' 17) Ingresso in orbita terrestre (ritorno) - Capsula, mini-navetta, veicolo lunare
  ' 18) Rientro - Capsula, mini-navetta, veicolo lunare

  ' ------------------------------------------------
  ' ---------- AVVIO MISSIONI PIANIFICATE ----------
  ' ------------------------------------------------

  ' id qui fa da contatore per determinare se e quali missioni abbiamo in programma

  id = 0

  ' Verifica se abbiamo una missione in programma

vermiss:

  id = id + 1

  ' Se i = 4 tutte le missioni sono state controllate

  IF id = 4 THEN GOTO uscita

  ' La missione parte se programmata, altrimenti si controlla quella successiva

  IF miss(15,id) = id THEN
    GOTO missione
  ELSE
    GOTO uscita
  END IF

  ' --------------------------------------------------
  ' ---------- MOSTRA I DATI DELLA MISSIONE ----------
  ' --------------------------------------------------

missione:

  BORDER 7: PAPER 7: INK 0: BRIGHT 0: CLS

  ' Copia in mpr i dati della missione programmata

  n = 1
  DO
    mpr(n) = miss(n,id)
    n = n + 1
  LOOP UNTIL n = 17

  ' id = i

  ' Rivedi tutti i dati della missione.
  ' id è il numero identificativo della missione e va specificato prima di richiamare il sottoprogramma
  ' k indica la riga dove stampare

  k = 7  

  IF mpr(2) = 1 THEN v$ = "oRB.TERRESTRE"
  IF mpr(2) = 2 THEN v$ = "oRB.LUNAR"
  IF mpr(2) = 3 THEN v$ = "ATERR.LUNAR"

  ' Mostra veicolo, destinazione, vettore ed eventuale potenziamento

  POKE UINTEGER indir,@riepil
  stampa()
  w = mpr(1): PRINT AT 3,11; mate$(w); AT 4,11;v$
  w = mpr(4): PRINT AT 5,11; mate$(w)
  IF mpr(5) = 1 THEN
    v$ = "Sl"
  ELSE
    v$ = "NO"
  END IF
  PRINT AT 6,11; v$; AT 1,7; PAPER naz; "\{i7}\{b1} RESUMEN MISIoN "; id; " "

  ' Modulo lunare sì/no

checklem:

  w = mpr(3)

  ' Modulo lunare non presente

  IF w = 0 THEN GOTO checkms

  ' Modulo lunare presente

  v$ = mate$(w)
  PRINT AT k,1; "MoD.LUNAR: "; v$
  
  ' Passa alla riga successiva

  k = k + 1

  ' Modulo di servizio sì/no

checkms:

  ' Modulo di servizio non presente

  IF mpr(6) = 0 AND mpr(7) = 0 THEN GOTO checkagga
  IF mpr(6) = 1 THEN v$ = "A"
  IF mpr(7) = 1 THEN v$ = "B"
  PRINT AT k,1; "MoD.SERV.: "; v$

  ' Passa alla riga successiva

  k = k + 1

  ' Modulo di aggancio sì/no

checkagga:

  ' Modulo aggancio non presente

  IF mpr(8) = 0 THEN GOTO checktute

  ' Modulo aggancio presente

  PRINT AT k,1; mate$(11)
 
  ' Passa alla riga successiva

  k = k + 1

  ' Tute AEV sì/no

checktute:

  w = mpr(9)

  ' Tuta AEV non presente

  IF w = 0 THEN GOTO checkequi

  ' Tuta AEV presente

  PRINT AT k,1; mate$(12);" (";w;")"
  
  ' Passa alla riga successiva

  k = k + 1

  ' Lista equipaggio

checkequi:

  ' Se la missione è senza equipaggio va direttamente alla fine
  ' (se il volo è con equipaggio c'è sempre almeno un pilota)

  w = mpr(10)

  IF w = 0 THEN GOTO fineriep

  ' Avanza di una riga

  k = k + 1

  PRINT AT k,1; "TRIPULACIoN:"

  k = k + 1

  ' Controlla quali sono i piloti e ne stampa il nome

  n = 10
  DO
    w = mpr(n)
    IF w > 0 THEN PRINT AT k,3; pilo$(w): k = k + 1
    n = n + 1
  LOOP UNTIL n = 14

fineriep:

  ' Stampa l'efficienza globale della missione. Specificare id prima di richiamare

  PRINT AT 18,1; "EFIC. GLOBAL: ";effmis(id);"%"

  ' Calcola la penalità

' penalita:

  ' Azzera z

  z = 0

  ' La penalità si aggiunge se una o più missioni pietre miliari non sono state completate da noi.
  ' Se pm(x) < 2 vuol dire o che non l'ha completata nessuno (0) o che l'hanno fatto i nostri avversari (1).

  ' Satellite in orbita terrestre
 
  IF pm(1) < 2 THEN z = pen

  ' Volo con capsula, navetta o veicolo (con o senza equipaggio)

  IF mpr(1) > 3 AND mpr(1) < 9 AND pm(2) < 2 THEN z = z + pen

  ' AEV 

  IF mpr(9) <> 0 AND pm(3) < 2 THEN z = z + pen

  ' Destinazione orbita lunare

  IF mpr(2) > 1 AND pm(4) < 2 THEN z = z + pen

  ' Destinazione suolo lunare

  IF mpr(2) = 3 AND pm(5) < 2 THEN z = z + pen

  ' Volo lunare C/E

  IF mpr(2) > 1 AND mpr(10) <> 0 AND pm(6) < 2 THEN z = z + pen

  IF z > 0 THEN PRINT AT 19,1; "(PENALIZACIoN: -";z;"%)"

  premitasto()

  updateSeed()

  ' ----------------------------------------
  ' ---------- CONTROLLO MISSIONE ----------
  ' ----------------------------------------

  BORDER 0: PAPER 0: BRIGHT 1: CLS

  ' Decomprime la schermata della sala di controllo

  dzx7AgileRCS(@salacm,16384)

  ' Da questo momento in poi le scritte (con le dovute eccezioni) saranno tutte in verde

  INK 4

  POKE UINTEGER indir,@f00: stampa()

  PAUSE 0

  ' Lo stato della missione è inizialmente pari a 1. In caso di rientro anticipato si azzera

  statomis = 1

  ' Se il veicolo è una navetta pone la variabile di controllo inizialmente a 1

  navetta = 1

  ' Assegna la base del bonus prestigio per questa missione.
  ' È data dal numero del veicolo, più 2 per ogni membro dell'equipaggio
  
  bonuspre = mpr(1)

  n = 11
  DO
    IF mpr(n) <> 0 THEN bonuspre = bonuspre + 2
    n = n + 1
  LOOP UNTIL n = 15

  ' Per ogni fase confronta il valore di r100 con l'efficienza attuale dei materiali

  ' 1) Decollo - Razzo, potenziamento (se presente)

  ' Razzo

fase01:

  ' 255 significa che in caso di inconveniente la missione fallisce senza possibilità di recupero

  fase = 255

  ' Mostra il messaggio "accensione motori"

  ' Carica in memoria il set di caratteri animazione

  POKE UINTEGER 23606,@animfont-256

  ' Mostra il fumo dei motori

  POKE UINTEGER indir,@fumotori: stampa()

  ' Carica in memoria il set di caratteri predefinito

  POKE UINTEGER 23606,@adfont-256

  POKE UINTEGER indir,@f01: pannello()

  w = mpr(4)
  
  controllo()

  ' Stampa "DECOLLO EFFETTUATO"

  IF k = 0 THEN GOTO animlancio

  ' Malfunzionamento.
  ' NB: y + prob rappresenta il numero del messaggio pr$(...) da mostrare.
  ' Es. in questo caso (inconveniente del razzo) i messaggi a seconda della gravità possono essere pr$(1), (2) o (3)
  
  y = 0 : malfunz()

  ' Se si verifica un'esplosione al razzo vettore (prob > 2) la rampa è danneggiata
  ' Memorizza il numero della rampa in q
  ' Indica il valore della rampa come "in riparazione" (codice 4)
  ' Programma 2 turni per la riparazione (3 perché le riparazioni cominciano alla fine di questo turno)

  ' Stampa l'avviso "Rampa danneggiata"
  
  IF prob > 2
    POKE UINTEGER indir,@rampadann
    pannello()
	q = mpr(15)
	stru(1,q) = 4
	stru(2,q) = 3
  END IF

  GOTO fallita

  ' Mostra l'animazione del lancio e la mappa delle orbite

animlancio:

  scena = 1
  DO
    animaz()
    PAUSE 50
    scena = scena + 1
  LOOP UNTIL scena = 5

  POKE UINTEGER indir,@mis01
  pannello()
  ' GOTO fase01a

  ' Potenziamento

fase01a:

  ' Controlla se il potenziamento è presente, se non lo è passa alla fase 2

  IF mpr(5) = 0 THEN GOTO fase02

  POKE UINTEGER indir,@f01a
  pannello()

  w = mpr(5)

  controllo()

  ' Stampa "RAZZI AUS. STACCATI"

  IF k = 0
    POKE UINTEGER indir,@mis02
	pannello()
    GOTO fase02
  END IF

  ' Malfunzionamento

  y = 3 : malfunz()

  ' Se c'è equipaggio rientra, altrimenti fallisce subito

  statomis = 0 : GOTO fase18

  '  2) Ingresso in orbita terrestre - Razzo

fase02:

  POKE UINTEGER indir,@f02: pannello()
  
  w = mpr(4)
  
  controllo()

  ' Stampa "ORBITA TERRESTRE RAGGIUNTA"

  IF k = 0
    POKE UINTEGER indir,@mis03
	pannello()
    GOTO fase03
  END IF

  ' Malfunzionamento

  y = 0 : malfunz()

  ' Se c'è equipaggio rientra, altrimenti fallisce subito

  statomis = 0: GOTO fase18

  '  3) Attività in orbita terrestre - Capsula, mini-navetta, satellite

  ' NOTA BENE:
  ' Da qui si comincia a memorizzare il numero di fase. In caso di inconvenienti la missione può essere continuata,
  ' o si può tornare indietro, ovviamente solo in presenza di equipaggio e se questo non subisce infortuni.

fase03:

  fase = 3

  ' Se la destinazione è la Luna salta questa fase

  IF mpr(2) > 1 THEN GOTO fase04

  ' Se c'è equipaggio mostra la scena 10

  IF mpr(10) > 0 THEN scena = 10: animaz()

  POKE UINTEGER indir,@f03: pannello()

  w = mpr(1)

  controllo()

  IF k = 0 THEN GOTO fase03bis

  ' Malfunzionamento

  IF w = 1 THEN
    y = 6
  ELSE
    y = 12
  END IF

  malfunz()

  ' Fallimento

  IF fase = 255 THEN GOTO fallita

  IF statomis = 0 THEN GOTO fase18

fase03bis:

  ' Stampa "ATTIVITÀ ESEGUITE"
  
  POKE UINTEGER indir,@mis04: pannello()
  
  ' Se è satellite terrestre la missione è terminata con successo

  IF w = 1 THEN GOTO riuscita

  ' Se la destinazione è l'orbita terrestre e non ci sono tute AEV vai alla fase 18

  IF mpr(2) = 1 AND mpr(9) = 0 THEN GOTO fase18
  
  ' Se la destinazione è l'orbita terrestre e ci sono tute AEV vai alla fase 14

  IF mpr(2) = 1 AND mpr(9) > 0 THEN GOTO fase14

  ' 4) Uscita da orbita terrestre - Razzo

fase04:

  ' Mostra la scena "orbita terrestre"

  scena = 7 : animaz()

  fase = 4

  POKE UINTEGER indir,@f04: pannello()

  w = mpr(4)

  controllo()

  ' Stampa "ORBITA TERRESTRE LASCIATA"

  IF k = 0
    POKE UINTEGER indir,@mis05
    pannello()
    GOTO fase05
  END IF

  ' Malfunzionamento

  y = 0: malfunz()

  ' Se c'è equipaggio rientra, altrimenti fallisce subito

  IF scelta = 0 THEN GOTO fase18

  ' 5) Percorso Terra-Luna - Satellite lunare, sonda lunare, capsula con ML, mini-navetta, veicolo lunare
  ' 6) Ingresso in orbita lunare - Satellite lunare, sonda lunare, capsula con ML, mini-navetta, veicolo lunare
  ' Queste due fasi sono di fatto identiche. Vengono eseguite una dopo l'altra in un ciclo in due passaggi.

fase05:

  fase = 5

ciclofasi0506:

  ' Mostra l'animazione Terra-Luna-Terra

  IF fase = 5 THEN
    ' Stampa testo "NAVIGAZ.TERRA-LUNA    "
	POKE UINTEGER indir,@mis06
  ELSE
    ' Stampa testo "INGRESSO IN ORB.LUNARE"
	POKE UINTEGER indir,@mis07
  END IF

  pannello()

  w = mpr(1)

  controllo()

  ' Stampa "NAVIGAZ.REGOLARE"
  
  IF k = 0 AND fase = 5 THEN navigaz() : POKE UINTEGER indir,@mis08: pannello(): fase = 6: GOTO ciclofasi0506
  
  ' Stampa "ORB.LUNARE RAGGIUNTA"
  
  IF k = 0 AND fase = 6 THEN POKE UINTEGER indir,@mis09: pannello(): GOTO fase07

  ' Malfunzionamento

  y = 21 : malfunz()

  ' La missione continua

  IF scelta = 1 THEN fase = 6 : GOTO ciclofasi0506

  ' Se scelta = 0 la missione è considerata fallita e si torna indietro

  GOTO fase18

  ' 7) Avvicinamento lunare - Modulo lunare, veicolo lunare, sonda

  ' Determina se si tratta di un ML o di un altro tipo di mezzo

fase07:

  ' Mostra la scena "orbita lunare"

  scena = 6 : animaz()

  ' Se è un satellite lunare va direttamente alla fase 8

  IF mpr(1) = 2 THEN GOTO fase08

  POKE UINTEGER indir,@f07: pannello()

  ' Determina se è un ML, una navetta o una sonda

  IF mpr(3) <> 0 THEN w = mpr(3): GOTO fase07ter
  IF mpr(1) = 3 OR mpr(1) = 8 THEN w = mpr(1): GOTO fase07bis

  ' Se non è nessuna di queste (capsula o navetta in orbita lunare) va alla fase 12

  GOTO fase12

  ' Avvicinamento veicolo lunare o sonda. w è sempre uguale a mpr(1) come stabilito nella fase precedente

fase07bis:

  controllo()

  ' Stampa "AVVICINAM.IN CORSO"
  
  IF k = 0 THEN
    POKE UINTEGER indir,@mis10
	pannello()
    GOTO fase09
  END IF

  ' Malfunzionamento

  IF w = 3 THEN
    y = 9
  ELSE
    y = 18
  END IF

  malfunz()

  ' La missione continua

  IF scelta = 1 THEN GOTO fase09

  ' Se scelta = 0 la missione è considerata fallita e si salta alla fase 15 (uscita dall'orbita lunare)

  GOTO fase15

  ' Avvicinamento ML

fase07ter:

  controllo()

  ' Stampa "MODULO LUNARE IN AVVICINAM."
  
  IF k = 0 THEN
    POKE UINTEGER indir,@mis11
	pannello()
    GOTO fase09
  END IF

  ' Malfunzionamento

  y = 18 : malfunz()

  ' La missione continua

  IF scelta = 1 THEN GOTO fase09

  ' Se k = 0 la missione è considerata fallita e si salta alla fase 15 (uscita dall'orbita lunare)

  GOTO fase15

  ' 8) Ricognizione lunare - Satellite

fase08:

  POKE UINTEGER indir,@f08: pannello()

  w = 2

  controllo()

  ' In caso di successo la missione è completata

  ' Stampa "RICOGNIZ.COMPIUTA"

  IF k = 0
    POKE UINTEGER indir,@mis12
	pannello()
    GOTO riuscita
  END IF

  ' Malfunzionamento; in questo caso la missione fallisce senza possibilità di recupero

  y = 6 : malfunz()

  GOTO fallita

  ' 9) Atterraggio lunare - Modulo lunare, veicolo lunare, sonda

fase09:

  POKE UINTEGER indir,@f09: pannello()

  ' Determina se è un ML (mpr(3)<>0)

  IF mpr(3) <> 0 THEN
    w = mpr(3)
    GOTO fase09bis
  ELSE
    w = mpr(1)
  END IF

  ' Atterraggio veicolo lunare o sonda. w è sempre uguale a mpr(1) come stabilito nella fase precedente

  controllo()

  ' Se è una sonda la missione è compiuta; stampa "SONDA ATTERRATA,DATI RICEVUTI"
  
  IF k = 0 AND w = 3 THEN POKE UINTEGER indir,@mis13: pannello(): GOTO riuscita
  
  ' Atterraggio veicolo lunare; stampa "ATTERR.LUNARE COMPIUTO"

  IF k = 0 AND w = 8 THEN POKE UINTEGER indir,@mis14: pannello(): GOTO fase10

  ' Malfunzionamento

  IF w = 3 THEN
    y = 9
  ELSE
    y = 18
  END IF

  malfunz()

  GOTO fase09ter

  ' Atterraggio ML

fase09bis:

  controllo()

  ' Stampa "MODULO LUNARE ATTERRATO"
  
  IF k = 0
    POKE UINTEGER indir,@mis15
    pannello()
    GOTO fase10
  END IF

  ' Malfunzionamento

  y = 18 : malfunz()

fase09ter:

  ' La missione continua

  IF scelta = 1 THEN GOTO fase10

  ' Se scelta = 0 la missione è considerata fallita e si salta alla fase 11 (partenza dal suolo lunare)

  GOTO fase11

  ' 10) Passeggiata lunare - Tuta AEV

fase10:

  POKE UINTEGER indir,@f10: pannello()

  ' NOTA: Questa fase si effettua solo in presenza di equipaggio.

  IF mpr(10) = 0 THEN GOTO fase11

  w = 12

  controllo()

  ' Se non ci sono avarie mostra la passeggiata lunare

  IF k = 0 THEN GOTO passeluna

  ' Malfunzionamento

  y = 15 : malfunz()

  ' Se scelta = 0 la missione è considerata fallita, si va comunque alla fase 11 (partenza dal suolo lunare)

  IF scelta = 0 THEN GOTO fase11

passeluna:

  POKE UINTEGER 23606,@animfont-256

  INK 7
  ' PAPER 0 : BRIGHT 1

  n = 2
  DO
    PRINT AT n,11; "          "
    n = n + 1
  LOOP UNTIL n = 8

  POKE UINTEGER indir,@suololun: stampa()

  POKE UINTEGER indir,@pos1: stampa()
  PAUSE 40
  POKE UINTEGER indir,@pos2: stampa()
  PAUSE 40
  POKE UINTEGER indir,@pos3: stampa()
  PAUSE 40
  POKE UINTEGER indir,@pos4: stampa()

  POKE UINTEGER 23606,@adfont-256

  IF naz = 1
    POKE UINTEGER indir,@bandusa
  ELSE
    POKE UINTEGER indir,@bandurss
  END IF

  stampa()

  ' Stampa "PASSEGG.LUNARE COMPIUTA"

  POKE UINTEGER indir,@mis16
  pannello()

  ' 11) Partenza dal suolo lunare - Modulo lunare, veicolo lunare

fase11:

  ' Mostra la scena "orbita lunare"

  scena = 6 : animaz()

  POKE UINTEGER indir,@f11: pannello()

  ' Determina se è un ML o un veicolo lunare

  IF mpr(3) <> 0 THEN
    w = mpr(3)
  ELSE
    w = 8
  END IF

  controllo()

  ' Stampa "DECOLLO EFFETTUATO"
  
  IF k = 0
    POKE UINTEGER indir,@mis01
    pannello()
    GOTO fase13
  END IF

  ' Malfunzionamento (22-24)

  y = 21 : malfunz()

  ' Se scelta = 0 la missione è considerata parzialmente riuscita, si va comunque alla fase 13 (aggancio capsula-ML)

  IF scelta = 0 AND statomis = 1 THEN statomis = 2

  GOTO fase13

  ' 12) Attività in orbita lunare - Capsula, mini-navetta, veicolo lunare

fase12:

  ' Se c'è equipaggio mostra la scena 10

  IF mpr(10) > 0 THEN scena = 10: animaz()

  POKE UINTEGER indir,@f03: pannello()

  w = mpr(1)

  controllo()

  IF k = 0
    POKE UINTEGER indir,@mis04
    pannello()
	GOTO fase15
  END IF

  ' Malfunzionamento (13-15)

  y = 12 : malfunz()

 ' La missione continua

  IF scelta = 1 THEN GOTO fase13

  ' Se scelta = 0 la missione è considerata parzialmente riuscita

  IF statomis = 1 THEN statomis = 2

  ' Se non c'è un modulo lunare si va alla fase 15 (uscita dall'orbita lunare), altrimenti si prosegue alla fase 13

  IF mpr(3) = 0 THEN GOTO fase15

  ' 13) Aggancio capsula-ML - Modulo aggancio

fase13:

  ' Se non c'è un ML salta questa fase

  IF mpr(3) = 0 THEN GOTO fase15

  POKE UINTEGER indir,@f13: pannello()

  w = 11

  controllo()

  ' Stampa "MOD.LUNARE AGGANCIATO"

  IF k = 0
    POKE UINTEGER indir,@mis17
    pannello()
	GOTO fase15
  END IF

  ' Malfunzionamento (25-27)

  y = 24 : malfunz()

  ' Se scelta = 0 la missione è considerata parzialmente riuscita, si va comunque alla fase 15 (aggancio capsula-ML)

  IF scelta = 0 AND statomis = 1 THEN statomis = 2 

  GOTO fase15

  ' 14) Passeggiata spaziale - Tuta AEV

fase14:

  POKE UINTEGER indir,@f14: pannello()

  scena = 7 : animaz()

  w = 12

  controllo()

  ' Se ha successo la capsula/navetta rientra

  IF k = 0

    ' Animazione passeggiata spaziale
 
    POKE UINTEGER 23606,@animfont-256
    n = 1
    DO
      POKE UINTEGER indir, @passpa1
      stampa()
      PAUSE 25
      POKE UINTEGER indir, @passpa2
      stampa()
      PAUSE 25
      n = n + 1
    LOOP UNTIL n = 5

  ' Stampa "PASS. SPAZ. COMPIUTA"

    POKE UINTEGER 23606,@adfont-256
    POKE UINTEGER indir,@mis18
    pannello()
    GOTO fase18
  END IF

  ' Malfunzionamento

  y = 15 : malfunz()

  ' Se scelta = 0 la missione è considerata fallita; si rientra comunque

  IF scelta = 0 THEN GOTO fase18

  ' 15) Uscita da orbita lunare - Modulo di servizio, veicolo lunare

fase15:

  POKE UINTEGER indir,@f15: pannello()

  ' Determina se il mezzo è un veicolo lunare o un modulo di servizio A o B

  IF mpr(1) = 8 THEN w = 8
  IF mpr(6) = 1 THEN w = 18
  IF mpr(7) = 1 THEN w = 19

  controllo()

  IF k = 0 THEN POKE UINTEGER indir,@mis15bis: pannello() : GOTO fase16

  ' Malfunzionamento (22-24)

  y = 21: malfunz()

  ' Se scelta = 0 la missione è considerata parzialmente riuscita; si prosegue comunque alla fase 16

  IF scelta = 0 AND statomis = 1 THEN statomis = 2

  ' 16) Percorso Luna-Terra - Capsula, mini-navetta, veicolo lunare
  ' 17) Ingresso in orbita terrestre (ritorno) - Capsula, mini-navetta, veicolo lunare

  ' NOTA: Queste due fasi sono di fatto identiche. Vengono eseguite una dopo l'altra in un ciclo in due passaggi

fase16:

  ' Imposta il valore iniziale di n come contatore del ciclo

  fase = 16

ciclofasi1617:

  IF fase = 16 THEN
    ' testo$ = "NAVIGAZ.LUNA-TERRA    "
	POKE UINTEGER indir,@mis19
  ELSE
    ' testo$ = "INGRESSO IN ORB.TERRESTRE"
	POKE UINTEGER indir,@f02
  END IF

  pannello()

  w = mpr(1)

  controllo()

  ' Stampa "NAVIGAZ.REGOLARE"
  
  IF k = 0 AND fase = 16 THEN navigaz(): POKE UINTEGER indir,@mis08: pannello(): fase = 17: GOTO ciclofasi1617
  
  ' Stampa "ORB.TERRESTRE RAGGIUNTA"
  
  IF k = 0 AND fase = 17 THEN POKE UINTEGER indir,@mis03: pannello(): GOTO fase18

  ' Malfunzionamento

  y = 21 : malfunz()

  ' Se scelta = 0 la missione è considerata parzialmente riuscita

  IF scelta = 0 AND statomis = 1 THEN statomis = 2: GOTO fase18

  ' La missione continua

  IF scelta = 1 AND fase = 16 THEN fase = 17 : GOTO ciclofasi1617

  ' Se scelta = 1 e fase = 17 si continua alla fase 18

  ' 18) Rientro - Capsula, mini-navetta, veicolo lunare

fase18:

  ' Se non c'è equipaggio e la missione è fallita non rientra

  IF mpr(10) = 0 AND statomis = 0 THEN GOTO fallita

  scena = 4 : animaz()

  POKE UINTEGER indir,@f18: pannello()

  w = mpr(1)

  controllo()

  ' Missione riuscita

  IF k = 0 THEN GOTO rientro
  
  ' Missione fallita o compromessa

  IF k > 0 AND statomis = 0 THEN GOTO fase18bis

  ' Missione parzialmente riuscita anche con inconveniente

  IF k > 0 AND statomis = 2 THEN GOTO rientro
  
  ' Tutti gli altri casi

  GOTO fase18bis

  ' Rientro (missione compiuta o parzialmente compiuta)

rientro:

  ' Mostra l'animazione di fine rientro

  animrientro()

  ' Stampa "Rientro effettuato"

  POKE UINTEGER indir,@mis20
  pannello()

  IF statomis = 1 THEN GOTO riuscita
  IF statomis = 2 THEN GOTO parziale
  IF statomis = 0 THEN GOTO fallita

  ' Malfunzionamento. Determina l'inconveniente e stampa il messaggio relativo

fase18bis:

  y = 27 : malfunz()

  ' Se non c'è equipaggio vai direttamente a missione fallita

  IF mpr(10) = 0 THEN GOTO fallita

  ' Se il veicolo ha equipaggio ma c'è stato un errore fatale la missione è fallita

  IF statomis = 0 THEN GOTO fallita

  ' Missione parzialmente riuscita: obiettivi raggiunti ma si sono verificati inconvenienti.

parziale:

  pulisci()
  POKE UINTEGER indir,@mispar: stampa()

  BEEP .5,-1

  ' Il bonus prestigio è ridotto della metà

  bonuspre = INT(bonuspre/2)

  totalmis(2) = totalmis(2) + 1

  PAUSE 0: GOTO finemissione

  ' Missione fallita: nessun bonus prestigio, penalità calcolata da malfunz()

fallita:

  scena = 0: animaz()

  pulisci()
  POKE UINTEGER indir,@misfal: stampa()

  BEEP 1,-25

  bonuspre = 0

  totalmis(3) = totalmis(3) + 1

  PAUSE 0: GOTO finemissione

  ' Missione riuscita

riuscita:

  pulisci()

  POKE UINTEGER indir,@miscom: stampa()

  BEEP .2,4: BEEP .3,11

  PAUSE 0

  totalmis(1) = totalmis(1) + 1

  ' Determina se la missione è una pietra miliare e se è stata condotta per prima. In tal caso, aumenta il bonus prestigio

  BORDER 7: PAPER 7: INK 0: BRIGHT 0: CLS

  ' Azzera q

  q = 0

  ' Satellite in orbita terrestre
 
  IF mpr(1) = 1 THEN q = 1

  ' Volo orbitale con equipaggio (capsula, navetta)

  IF mpr(1) > 3 AND mpr(1) < 8 AND mpr(10) <> 0 AND mpr(2) = 1 THEN q = 2

  ' AEV in orbita terrestre

  IF mpr(9) <> 0 AND mpr(2) = 1 THEN q = 3

  ' Satellite in orbita lunare

  IF mpr(1) = 2 THEN q = 4

  ' Sonda lunare

  IF mpr(1) = 3 THEN q = 5

  ' Volo lunare C/E

  IF mpr(1) > 3 AND mpr(1) < 8 AND mpr(10) <> 0 AND mpr(2) = 2 THEN q = 6

  ' Per tutti gli altri casi non si procede alla verifica del bonus

  IF q = 0 THEN GOTO aumentaeff

  ' Pietra miliare raggiunta, bonus ottenibile

  IF pm(q) = 0 THEN
    pm(q) = 2
    bonuspre = bonuspre + pmbon(q)
    CLS
    PRINT AT 12,0;"PRIMER";pimi$(q); AT 10,13; PAPER naz; "\{i7}\{b1} HITO "
    inno()
    premitasto()
  END IF

  ' Pietra miliare raggiunta, bonus non ottenibile

  IF pm(q) = 1 THEN pm(q) = 3

  ' Aumenta di 2 l'efficienza dei materiali impiegati nella missione

aumentaeff:

  ' Veicolo

  q = mpr(1) : efficienza()

  ' Modulo lunare (se presente)

  IF mpr(3) <> 0 THEN q = mpr(3) : efficienza()

  ' Razzo vettore

  q = mpr(4) : efficienza()
  
  ' Booster (se presenti)

  IF mpr(5) <> 0 THEN q = 17 : efficienza()

  ' Modulo di servizio A (se presente)

  IF mpr(6) <> 0 THEN q = 18 : efficienza()

  ' Modulo di servizio B (se presente)

  IF mpr(7) <> 0 THEN q = 19 : efficienza()

  ' Modulo di aggancio (se presente)

  IF mpr(8) <> 0 THEN q = 11 : efficienza()

  ' Tuta AEV (se presente)

  IF mpr(9) <> 0 THEN q = 12 : efficienza()

finemissione:

  x = 10

liberapilo:

  ' Marca i piloti in missione come disponibili nuovamente se non sono né feriti, né deceduti.
  ' x corrisponde al numero del pilota inserito nella missione, da mpr(10) a mpr(13).
  ' Se x > 0 vuol dire che c'è un pilota in questa missione

  pilota = mpr(x)
  IF pilota = 0 THEN GOTO bonusprest
  IF pilost$(pilota) = "M" THEN pilost$(pilota) = "A"
  x = x + 1
  IF x < 14 THEN GOTO liberapilo

bonusprest:

  ' Aggiunge il bonus al prestigio

  prestigio = prestigio + bonuspre

  ' Se la destinazione era 3, la missione era con equipaggio ed è stata compiuta con successo abbiamo vinto

  IF mpr(2) = 3 AND mpr(10) <> 0 AND statomis = 1 THEN prestigio = prestigio + 100 : GOTO vittoria

  ' Se la destinazione era 3, la missione era con equipaggio ed è parzialmente riuscita abbiamo comunque un bonus di 25 al prestigio

  IF mpr(2) = 3 AND mpr(10) <> 0 AND statomis = 2 THEN prestigio = prestigio + 25

  ' Se il veicolo è una navetta e non è stata danneggiata gravemente (navetta = 1) rendila di nuovo disponibile

  q = mpr(1)
  IF q = 7 AND navetta = 1 THEN qt(q) = qt(q) + 1

  ' Marca la rampa di lancio usata come disponibile se risulta ancora occupata, quindi non è danneggiata

  q = mpr(15)

  IF stru(1,q) = 2 THEN stru(1,q) = 1

  ' Torna a controllare se abbiamo un'altra missione in programma

esci04:

  ' Azzera i parametri della missione

  n = 1
  DO
    mpr(n) = 0
    miss(n,id) = 0
    n = n + 1
  LOOP UNTIL n = 17

  ' somma = 0
  
  GOTO vermiss

  ' ----------------------------
  ' ---------- USCITE ----------
  ' ----------------------------

uscita:

  ' Vai a fine turno

  POKE @segue, 6: GOTO backup

  ' Vai al messaggio di vittoria

vittoria:

  POKE @segue, 7

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

  ' Vengono salvate solo le variabili modificate dal programma

backup:

  POKE UINTEGER @memo + 3, prestigio

  x = 1
  DO
    POKE @memo + 10 + x, stru(1,x)
    POKE @memo + 19 + x, stru(2,x)
    POKE @memo + 28 + x, stru(3,x)
    x = x + 1
  LOOP UNTIL x = 10

  x = 1
  DO
    POKE @memo + 230 + x, qt(x)
    POKE @memo + 249 + x, rsatt(x)
    POKE @memo + 268 + x, effatt(x)
    x = x + 1
  LOOP UNTIL x = 20

  x = 1
  DO
    POKE @memo + 330 + x, miss(1,x)
    POKE @memo + 333 + x, miss(2,x)
    POKE @memo + 336 + x, miss(3,x)
    POKE @memo + 339 + x, miss(4,x)
    POKE @memo + 342 + x, miss(5,x)
    POKE @memo + 345 + x, miss(6,x)
    POKE @memo + 348 + x, miss(7,x)
    POKE @memo + 351 + x, miss(8,x)
    POKE @memo + 354 + x, miss(9,x)
    POKE @memo + 357 + x, miss(10,x)
    POKE @memo + 360 + x, miss(11,x)
    POKE @memo + 363 + x, miss(12,x)
    POKE @memo + 366 + x, miss(13,x)
    POKE @memo + 369 + x, miss(14,x)
    POKE @memo + 372 + x, miss(15,x)
    POKE @memo + 375 + x, miss(16,x)
    POKE @memo + 378 + x, effmis(x)
    POKE @memo + 381 + x, totalmis(x)
    x = x + 1
  LOOP UNTIL x = 4

  x = 1
  DO
    POKE @memo + 400 + x, pm(x)
    x = x + 1
  LOOP UNTIL x = 7

  x = 1
  DO
    POKE @memo + 415 + x, CODE pilost$(x)
    x = x + 1
  LOOP UNTIL x = 11

  x = 1
  DO
    POKE @memo + 381 + x, totalmis(x)
    x = x + 1
  LOOP UNTIL x = 4

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------  

  END

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Inni nazionali

SUB FASTCALL inno()
ASM

  PUSH BC
  POP BC
  CALL 37114

END ASM
END SUB

  ' Mostra il messaggio "premi un tasto" e mette il gioco in pausa finché non si preme un tasto

SUB premitasto()

  FLASH 0: PRINT AT 22,7; "\{p3}\{i7}\{b1} PULSE UNA TECLA ": INK 0: PAUSE 0

END SUB

  #INCLUDE "_animazione.bas"

  ' Animazione navigazione Terra-Luna-Terra

SUB navigaz()

  scena = 5 : animaz()

  POKE UINTEGER 23606,@animfont-256
  n = 1
  DO
    POKE UINTEGER indir, @nav1
    stampa()
    BEEP .1, 6
    PAUSE 25
    POKE UINTEGER indir, @nav2
    stampa()
    PAUSE 25
    n = n + 1
  LOOP UNTIL n = 5

  POKE UINTEGER 23606,@adfont-256
    
END SUB

  ' Animazione rientro

SUB animrientro()

  IF mpr(1) = 7 GOTO rnavetta

  ' Rientro capsula: mpr(1) = 4, 5, 6 o 8

rcapsula:

  scena = 8 : animaz() : GOTO fineanim

  ' Rientro navetta

rnavetta:

  scena = 9 : animaz()

  INK 0: PAPER 5

  POKE UINTEGER 23606,@animfont-256

  PAUSE 50
  POKE UINTEGER indir,@navetta1 : stampa()
  PAUSE 50
  POKE UINTEGER indir,@navetta2 : stampa()
  PAUSE 50
  POKE UINTEGER indir,@navetta3 : stampa()

fineanim:

  POKE UINTEGER 23606,@adfont-256

END SUB

  ' Pulisce il pannello, stampa il messaggio e attende la pressione di un tasto

SUB pannello()

  INK 4: PAPER 0
  pulisci()
  stampa()
  
  PAUSE 0

END SUB

  ' Pulisce lo schermo della console

SUB pulisci()
  
  n = 13
  DO
    PRINT AT n,9; "              "
	n = n + 1
  LOOP UNTIL n = 18

END SUB

  ' Conferma/annulla

SUB conferma()

attendiconf:

  PAUSE 0

  IF INKEY$ = "1" THEN LET scelta = 1: GOTO esci
  IF INKEY$ = "0" THEN LET scelta = 0: GOTO esci
 
  GOTO attendiconf

esci:

END SUB

  ' Confronta l'efficienza attuale del materiale e la relativa abilità del pilota con un numero pseudocasuale tra 1 e 100

SUB controllo()

  ' Azzera k

  k = 0

  ' Azzera il bonus abilità

  bonabi = 0

  ' Imposta il contatore

  q = 10

  ' Inserisci in z il numero del pilota dell'equipaggio

  z = mpr(q)

bonusabi:

  ' Calcola il coefficiente di salvezza per il pilota considerato e lo aggiunge a quello già determinato per gli eventuali altri membri dell'equipaggio

  ' Massimo 4 piloti per missione (10-13)

  IF q = 14 OR z = 0 THEN GOTO fasebis

  ' Abilità piloti: abi(abilità,numero pilota) (1,10)
  ' 1. PB Pilotaggio base
  ' 2. EV AEV
  ' 3. AG Aggancio
  ' 4. PA Pilotaggio avanzato; richiesta dalle missioni lunari
  ' 5. RS Resistenza (avanzata); richiesta dalle missioni lunari

  ' Abilità richiesta PB

  IF w > 3 AND w < 7 AND mpr(2) = 1 THEN y = 1: calcbonabi(): GOTO contciclo

  ' Abilità richiesta PA+RS

  IF w > 4 AND w < 11 AND mpr(2) > 1 THEN y = 4: calcbonabi(): y = 5: calcbonabi(): GOTO contciclo

  ' Abilità richiesta EV

  IF w = 12 THEN y = 2: calcbonabi()

  ' Abilità richiesta AG

  IF w = 11 THEN y = 3: calcbonabi()

  ' Continua il ciclo

contciclo:

  q = q + 1 : GOTO bonusabi

fasebis:

  ' Determina il valore di rand tra 1 e 100

  randomBase()
  rand = randomLimit(99)+1

  ' Memorizza in efftot: efficienza attuale della missione + bonus abilità + modificatore

  efftot = effmis(id) + bonabi - modif

  ' efftot può arrivare al massimo a 95
  
  IF efftot > 95 THEN efftot = 95

  ' efftot maggiore di rand + modif: fase superata
  ' efftot minore di rand: determina gravità dell'inconveniente al materiale in particolare

  IF rand > efftot THEN
    grav = rand - effatt(w)
    k = 1 
  ELSE
    BEEP .2,4
  END IF

END SUB

  ' Calcola il bonus abilità (max 20)

SUB calcbonabi()

  bonabi = bonabi + INT(abi(z,y)/2)
  IF bonabi > 20 THEN bonabi = 20

END SUB

  ' Determina il tipo di inconveniente in base al materiale e stampa il relativo messaggio

  #INCLUDE "_malfunz.bas"

  ' Sceglie un pilota a caso e ne inserisce il numero (10-13) in q

SUB pilorand()

pilorandstart:

  ' rand è compreso tra 10 e 13

  randomBase()
  rand = randomLimit(3)+10

  ' Se il pilota numero q è assente si ripete il ciclo

  IF mpr(rand) = 0 THEN GOTO pilorandstart
  
  pilota = mpr(rand)
  
END SUB

  ' Stampa il messaggio di pilota ferito e ne cambia lo status

SUB piloferito()

  pulisci()

  PRINT AT 14,9; pilo$(pilota): pilost$(pilota) = "I"

  POKE UINTEGER indir,@pilofer: stampa()
  PAUSE 0

  ' Assegna al pilota 3 turni di cura (di fatto 2 perché la cura comincia alla fine del turno)

  abi(8,pilota) = 3

  ' Diminuzione del prestigio

  prestigio = prestigio - 10

END SUB

  ' Stampa il messaggio di pilota morto e ne cambia lo status

SUB pilomorto()

  pulisci()

  PRINT AT 14,9; pilo$(pilota): pilost$(pilota) = "X"

  POKE UINTEGER indir,@pilomor: stampa()
  PAUSE 0

  ' Diminuzione del prestigio

  prestigio = prestigio - 20

END SUB

  ' Aumenta di 2 l'efficienza del materiale e la R&S fino al massimo possibile

SUB efficienza()

  effatt(q) = effatt(q) + 2
  rsatt(q) = rsatt(q) + 2

  IF effatt(q) > effmax(q) THEN effatt(q) = effmax(q)
  IF rsatt(q) > rsmax(q) THEN rsatt(q) = rsmax(q)
  
END SUB

  ' Funzioni per il calcolo dei coefficienti pseudo-casuali (Britlion, Patrik Rak)

FUNCTION FASTCALL time() AS ULONG
ASM
  DI
  LD DE,(23674)
  LD D,0
  LD HL,(23672)
  EI
END ASM
END FUNCTION

FUNCTION FASTCALL randomBase AS UBYTE
ASM
random:
  ld  de,$A280   ; xz -> yw
  ld  hl,$C0DE   ; yw -> zt
  ld  (random+1),hl  ; x = y, z = w
  ld  a,l         ; w = w ^ ( w << 3 )
  add a,a
  add a,a
  add a,a
  xor l
  ld  l,a
  ld  a,d         ; t = x ^ (x << 1)
  add a,a
  xor d
  ld  h,a
  rra             ; t = t ^ (t >> 1) ^ w
  xor h
  xor l
  ld  h,e         ; y = z
  ld  l,a         ; w = t
  ld  (random+4),hl
END ASM
END FUNCTION

SUB FASTCALL updateSeed()
REM Updates the random generator seed from the FRAMES system variable.
time()
ASM
  LD A,E
  EX DE,HL
  LD HL,random+2
  XOR (HL)
  AND A
  JR NZ,updateSeedNotZero
  INC A
updateSeedNotZero:
  LD (HL),A
  LD HL,random+4
  LD A,E
  XOR (HL)
  LD (HL),A
  INC HL
  LD A,D
  XOR (HL)
  LD (HL),A
END ASM
END SUB

FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE
ASM
  AND A
  RET Z ; Input zero, output zero.
  LD B,A ; Save A

  LD C,255
  randomBinLoop:
  RLA
  JR C, randomBinLoopExit
  RR C
  JR randomBinLoop ; loop back until we find a bit.
  randomBinLoopExit:

  randomBinRedoCall:
  call random
  AND C
  CP B
  RET Z
  JR NC, randomBinRedoCall
END ASM
END FUNCTION

  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

riepil:
ASM
  DEFB 22, 3, 1
  DEFM "VEHlCULO:"
  DEFB 13
  DEFM " DESTINO:"
  DEFB 13
  DEFM " LANZADOR:"
  DEFB 13
  DEFM " REFUERZO:"
  DEFB 255
END ASM

f00:
ASM
  DEFB 22, 14, 9
  DEFM "PULSE UNA"
  DEFB 22, 15, 9
  DEFM "TECLA PARA"
  DEFB 22, 16, 9
  DEFM "INICIAR"
  DEFB 255
END ASM

f01:
ASM
  DEFB 22, 14, 9
  DEFM "IGNICIoN DE"
  DEFB 22, 15, 9
  DEFM "LOS MOTORES"
  DEFB 255
END ASM

f01a:
ASM
  DEFB 22, 14, 9
  DEFM "DESENGANCHE"
  DEFB 22, 15, 9
  DEFM "PARTES AUX."
  DEFB 255
END ASM

f02:
ASM
  DEFB 22, 14, 9
  DEFM "ENTRADA "
  DEFB 22, 15, 9
  DEFM "EN oRBITA"
  DEFM 22, 16, 9
  DEFM "TERRESTRE"
  DEFB 255
END ASM

f03:
ASM
  DEFB 22, 14, 9
  DEFM "ACTIVIDADES"
  DEFB 22, 15, 9
  DEFM "EN ORBITA"
  DEFB 255
END ASM

f04:
ASM
  DEFB 22, 14, 9
  DEFM "SALIDA DE"
  DEFB 22, 15, 9
  DEFM "LA oRBITA"
  DEFB 22, 16, 9
  DEFM "TERRESTRE"
  DEFB 255
END ASM

f07:
ASM
  DEFB 22, 14, 9
  DEFM "APROXIMACIoN"
  DEFB 22, 15, 9
  DEFM "A LA LUNA"
  DEFB 255
END ASM

f08:
ASM
  DEFB 22, 14, 9
  DEFM "RECONOCIMIENTO"
  DEFB 22, 15, 9
  DEFB "SUPERFICIE"
  DEFB 22, 16, 9
  DEFB "LUNAR"
  DEFB 255
END ASM

f09:
ASM
  DEFB 22, 14, 9
  DEFM "ATTERRIZAJE"
  DEFB 22, 15, 9
  DEFM "LUNAR"
  DEFB 255
END ASM

f10:
ASM
  DEFB 22, 15, 9
  DEFM "PASEO LUNAR"
  DEFB 255
END ASM

f11:
ASM
  DEFB 22, 14, 9
  DEFM "DESPEGUE"
  DEFB 22, 15, 9
  DEFM "DE LA LUNA"
  DEFB 255
END ASM

f13:
ASM
  DEFB 22, 14, 9
  DEFM "ATRAQUE"
  DEFB 22, 15, 9
  DEFM "EN oRBITA"
  DEFB 255
END ASM

f14:
ASM
  DEFB 22, 15, 9
  DEFM "PASEO ESPACIAL"
  DEFB 255
END ASM

f15:
ASM
  DEFB 22, 14, 9
  DEFM "SALIDA DE"
  DEFB 22, 15, 9
  DEFM "LA oRBITA"
  DEFB 22, 16, 9
  DEFM "LUNAR"
  DEFB 255
END ASM

f18:
ASM
  DEFB 22, 14, 9
  DEFM "REENTRADA"
  DEFB 22, 15, 9
  DEFM "EN LA TIERRA"
  DEFB 255
END ASM

mispar:
ASM
  ; DEFB 16, 6
  DEFB 22, 14, 9
  DEFM "MISIoN"
  DEFB 22, 15, 9
  DEFM "PARCIALMENTE"
  DEFB 22, 16, 9
  DEFB "CUMPLIDA"
  DEFB 255
END ASM

misfal:
ASM
  ; DEFB 16, 2
  ; DEFB 18, 1
  DEFB 22, 14, 12
  DEFM "MISIoN"
  DEFB 22, 15, 12
  DEFM "FALLIDA"
  DEFB 255
END ASM

miscom:
ASM
  ; DEFB 18, 1
  DEFB 22, 14, 13
  DEFM "MISIoN"
  DEFB 22, 15, 12
  DEFM "CUMPLIDA"
  DEFB 255
END ASM

malf:
ASM
  DEFB 22, 15, 12
  DEFB 16, 2
  DEFB 18, 1
  DEFM " AVERlA "
  DEFB 255
END ASM

continuamis:
ASM
  DEFB 22, 13, 9
  DEFM "^CONTINUAR"
  DEFB 22, 14, 9
  DEFM "LA MISIoN?"
  DEFB 22, 16, 9
  DEFM "1 = Sl"
  DEFB 22, 17, 9
  DEFM "0 = NO"
  DEFB 255
END ASM

miscont:
ASM
  DEFB 22, 14, 9
  DEFM "LA MISIoN"
  DEFB 22, 15, 9
  DEFM "CONTINUA"
  DEFB 255
END ASM

miscompr:
ASM
  DEFB 22, 13, 9
  DEFM "MISIoNE"
  DEFB 22, 14, 9
  DEFM "COMPROMETIDA"
  DEFB 16, 2
  DEFB 18, 1
  DEFB 22, 16, 10 
  DEFM " REENTRADA "
  DEFB 22, 17, 10
  DEFM " INMEDIATA "
  DEFB 18, 0
  DEFB 255
END ASM

mis01:
ASM
  DEFB 22, 14, 9
  DEFM "DESPEGUE"
  DEFB 22, 15, 9
  DEFM "EJECUTADO"
  DEFB 255
END ASM

mis02:
ASM
  DEFB 22, 14, 9
  DEFM "REFUERZOS"
  DEFB 22, 15, 9
  DEFM "DESENGANCHADOS"
  DEFB 255
END ASM

mis03:
ASM
  DEFB 22, 14, 9
  DEFM "oRBITA"
  DEFB 22, 15, 9
  DEFM "TERRESTRE"
  DEFB 22, 16, 9
  DEFM "ALCANZADA"
  DEFB 255
END ASM

mis04:
ASM
  DEFB 22, 14, 9
  DEFM "ACTIVIDADES"
  DEFB 22, 15, 9
  DEFM "EFECTUADAS"
  DEFB 255
END ASM

mis05:
ASM
  DEFB 22, 14, 9
  DEFM "oRBITA"
  DEFB 22, 15, 9
  DEFM "TERRESTRE"
  DEFB 22, 16, 9
  DEFM "DEJADA"
  DEFB 255
END ASM

mis06:
ASM
  DEFB 22, 14, 9
  DEFM "NAVEGACIoN"
  DEFB 22, 15, 9
  DEFM "TIERRA-LUNA"
  DEFB 255
END ASM

mis07:
ASM
  DEFB 22, 14, 9
  DEFM "INGRESO EN"
  DEFB 22, 15, 9
  DEFM "oRBITA LUNAR"
  DEFB 255
END ASM

mis08:
ASM
  DEFB 22, 14, 9
  DEFM "NAVEGACIoN"
  DEFB 22, 15, 9
  DEFM "REGULAR"
  DEFB 255
END ASM

mis09:
ASM
  DEFB 22, 14, 9
  DEFM "oRBITA LUNAR"
  DEFB 22, 15, 9
  DEFM "ALCANZADA"
  DEFB 255
END ASM

mis10:
ASM
  DEFB 22, 14, 9
  DEFM "APROXIMACIoN"
  DEFB 22, 15, 9
  DEFM "EN CURSO"
  DEFB 255
END ASM

mis11:
ASM
  DEFB 22, 14, 9
  DEFM "MoDULO LUNAR"
  DEFB 22, 15, 9
  DEFM "EN"
  DEFB 22, 16, 9
  DEFM "APROXIMACIoN"
  DEFB 255
END ASM

mis12:
ASM
  DEFB 22, 14, 9
  DEFM "EXPLORACIoN"
  DEFB 22, 15, 9
  DEFM "COMPLETADA"
  DEFB 255
END ASM

mis13:
ASM
  DEFB 22, 14, 9
  DEFM "SONDA"
  DEFB 22, 15, 9
  DEFM "ATTERRIZADA:"
  DEFB 22, 16, 9
  DEFM "DATOS"
  DEFB 22, 17, 9
  DEFM "RECIBIDOS"
  DEFB 255
END ASM

mis14:
ASM
  DEFB 22, 14, 9
  DEFM "ATERRIZAJE"
  DEFB 22, 15, 9
  DEFM "LUNAR"
  DEFB 22, 16, 9
  DEFM "CUMPLIDO"
  DEFB 255
END ASM

mis15:
ASM
  DEFB 22, 14, 9
  DEFM "MoDULO LUNAR"
  DEFB 22, 15, 9
  DEFM "ATERRIZADO"
  DEFB 255
END ASM

mis16:
ASM
  DEFB 22, 14, 9
  DEFM "PASEO LUNAR"
  DEFB 22, 15, 9
  DEFM "EJECUTADO"
  DEFB 255
END ASM

mis17:
ASM
  DEFB 22, 14, 9
  DEFM "MoDULO LUNAR"
  DEFB 22, 15, 9
  DEFM "ATRACADO"
  DEFB 255
END ASM

mis15bis:
ASM
  DEFB 22, 14, 9
  DEFM "oRBITA LUNAR"
  DEFB 22, 15, 9
  DEFM "DEJADA"
  DEFB 255
END ASM

mis18:
ASM
  DEFB 22, 14, 9
  DEFM "PASEO ESPACIAL"
  DEFB 22, 15, 9
  DEFM "EJECUTADO"
  DEFB 255
END ASM

mis19:
ASM
  DEFB 22, 14, 9
  DEFM "NAVEGACIoN"
  DEFB 22, 15, 9
  DEFM "LUNA-TIERRA"
  DEFB 255
END ASM

mis20:
ASM
  DEFB 22, 14, 9
  DEFM "REENTRADA"
  DEFB 22, 15, 9
  DEFM "EFECTUADA"
  DEFB 255
END ASM

rampadann:
ASM
  DEFB 18, 0
  DEFB 22, 15, 9
  DEFM "RAMPA DAmADA"
  DEFB 18, 0
  DEFB 255
END ASM

missione1:
ASM
  DEFB 22, 3, 7
  DEFM "MISIoN 1"
  DEFB 255
END ASM

missione2:
ASM
  DEFB 22, 5, 7
  DEFM "MISIoN 2"
  DEFB 255
END ASM

missione3:
ASM
  DEFB 22, 7, 7
  DEFM "MISIoN 3"
  DEFB 255
END ASM

pr1:
ASM
  DEFB 22, 14, 9
  DEFM "LOS MOTORES NO"
  DEFB 22, 15, 9
  DEFM "SE ENCENDIERON"
  DEFB 255
END ASM
/'
pr2:
ASM
  DEFB 22, 15, 9
  DEFM "MOTORI ESPLOSI"
  DEFB 255
END ASM
'/
pr3:
ASM
  DEFB 22, 14, 9
  DEFM "COHETE"
  DEFB 22, 15, 9
  DEFM "EXPLOSIONADO"
  DEFB 255
END ASM

pr4:
ASM
  DEFB 22, 14, 9
  DEFM "LAS PARTES"
  DEFB 22, 15, 9
  DEFM "AUXILIARIAS"
  DEFB 22, 16, 9
  DEFM "NO SE"
  DEFB 22, 17, 9
  DEFM "ENCENDIERON"
  DEFB 255
END ASM

pr5:
ASM
  DEFB 22, 14, 9
  DEFM "PARTES"
  DEFB 22, 15, 9
  DEFM "AUXILIARIAS NO"
  DEFB 22, 16, 9
  DEFM "DESENGANCHADAS"
  DEFB 255
END ASM

pr6:
ASM
  DEFB 22, 14, 9
  DEFM "PARTES"
  DEFB 22, 15, 9
  DEFM "AUXILIARIAS"
  DEFB 22, 16, 9
  DEFM "EXPLOSIONADAS"
  DEFB 255
END ASM

pr7:
ASM
  DEFB 22, 14, 9
  DEFM "NINGUNA"
  DEFB 22, 15, 9
  DEFM "TRANSMISIoN"
  DEFB 22, 16, 9
  DEFM "DE DATOS"
  DEFB 255
END ASM

pr8:
ASM
  DEFB 22, 14, 9
  DEFM "SATgLITE"
  DEFB 22, 15, 9
  DEFM "NO ACTIVADO"
  DEFB 255
END ASM

pr9:
ASM
  DEFB 22, 14, 9
  DEFM "EL SATgLITE"
  DEFB 22, 15, 9
  DEFM "NO ENTRo"
  DEFB 22, 16, 9
  DEFM "EN oRBITA"
  DEFB 255
END ASM

pr10:
ASM
  DEFB 22, 14, 9
  DEFM "CONTACTO"
  DEFB 22, 15, 9
  DEFM "POR RADIO"
  DEFB 22, 16, 9
  DEFM "PERDIDO"
  DEFB 255
END ASM

pr11:
ASM
  DEFB 22, 14, 9
  DEFM "SONDA"
  DEFB 22, 15, 9
  DEFM "ATTERRIZADA"
  DEFB 22, 16, 9
  DEFM "SIN ACTIVARSE"
  DEFB 255
END ASM

pr12:
ASM
  DEFB 22, 14, 9
  DEFM "DESCENSO"
  DEFB 22, 15, 9
  DEFM "DEMASIADO"
  DEFB 22, 16, 9
  DEFM "RbPIDO:"
  DEFB 22, 17, 9
  DEFM "COLISIoN"
  DEFB 255
END ASM

pr13:
ASM
  DEFB 22, 14, 9
  DEFM "CORTOCIRCUITO"
  DEFB 22, 15, 9
  DEFM "A BORDO"
  DEFB 255
END ASM

pr14:
ASM
  DEFB 22, 14, 9
  DEFM "INCENDIO"
  DEFB 22, 15, 9
  DEFM "EN CABINA"
  DEFB 255
END ASM

pr15:
ASM
  DEFB 22, 14, 9
  DEFM "EXPLOSIoN"
  DEFB 22, 15, 9
  DEFM "EN VUELO"
  DEFB 255
END ASM

pr16:
ASM
  DEFB 22, 15, 9
  DEFM "TRAJE LACERADO"
  DEFB 255
END ASM

pr17:
ASM
  DEFB 22, 14, 9
  DEFM "VENTILACIoN"
  DEFB 22, 15, 9
  DEFM "DEFECTUOSA"
  DEFB 255
END ASM

pr18:
ASM
  DEFB 22, 14, 9
  DEFM "PENETRACIoN"
  DEFB 22, 15, 9
  DEFM "RADIACIONES"
  DEFB 22, 16, 9
  DEFM "EXTERNAS"
  DEFB 255
END ASM

pr19:
ASM
  DEFB 22, 14, 9
  DEFM "GIRoSCOPIOS"
  DEFB 22, 15, 9
  DEFM "NO OPERATIVOS"
  DEFB 255
END ASM

pr20:
ASM
  DEFB 22, 14, 9
  DEFM "RETROCOHETES"
  DEFB 22, 15, 9
  DEFM "ENCENDIDOS"
  DEFB 22, 16, 9
  DEFM "CON RETRASO"
  DEFB 255
END ASM

pr21:
ASM
  DEFB 22, 14, 9
  DEFM "IMPACTO EN"
  DEFB 22, 15, 9
  DEFM "ATERRIZAJE"
  DEFB 255
END ASM

pr22:
ASM
  DEFB 22, 15, 9
  DEFM "CABLEADO ROTO"
  DEFB 255
END ASM

pr23:
ASM
  DEFB 22, 14, 9
  DEFM "FALLO"
  DEFB 22, 15, 9
  DEFM "ESTRUCTURAL"
  DEFB 255
END ASM

pr24:
ASM
  DEFB 22, 14, 9
  DEFM "MOTORES"
  DEFB 22, 15, 9
  DEFM "EN LLAMAS"
  DEFB 255
END ASM

pr25:
ASM
  DEFB 22, 14, 9
  DEFM "IMPACTO EN"
  DEFB 22, 15, 9
  DEFM "LA MANIOBRA"
  DEFB 22, 16, 9
  DEFM "DE ATRAQUE"
  DEFB 255
END ASM

pr26:
ASM
  DEFB 22, 14, 9
  DEFM "COLISIoN"
  DEFB 22, 15, 9
  DEFM "ENTRE MoDULO"
  DEFB 22, 16, 9
  DEFM "Y VEHlCULO"
  DEFB 255
END ASM

pr27:
ASM
  DEFB 22, 13, 9
  DEFM "ERROR EN"
  DEFB 22, 14, 9
  DEFM "LA MANIOBRA"
  DEFB 22, 15, 9
  DEFM "DE ATRAQUE:"
  DEFB 22, 16, 9
  DEFM "VEHlCULO"
  DEFB 22, 17, 9
  DEFM "DAmADO"
  DEFB 255
END ASM

pr28:
ASM
  DEFB 22, 14, 9
  DEFM "ESCUDO TgRMICO"
  DEFB 22, 15, 9
  DEFM "DAmADO"
  DEFB 255
END ASM

pr29:
ASM
  DEFB 22, 14, 9
  DEFM "RETRASO"
  DEFB 22, 15, 9
  DEFM "APERTURA"
  DEFB 22, 16, 9
  DEFM "PARACAlDAS"
  DEFB 255
END ASM

pr30:
ASM
  DEFB 22, 14, 9
  DEFM "PRESURIZACIoN"
  DEFB 22, 15, 9
  DEFM "CABINA"
  DEFB 22, 16, 9
  DEFM "DEFECTUOSA"
  DEFB 255
END ASM

eqilleso:
ASM
  DEFB 22, 14, 9
  DEFM "LA TRIPULACIoN"
  DEFB 22, 15, 9
  DEFM "ESTb ILESA"
  DEFB 255
END ASM

illeso:
ASM
  DEFB 22, 15, 9
  DEFM "ESTb ILESO"
  DEFB 255
END ASM

pilofer:
ASM
  DEFB 22, 15, 9
  DEFM "ESTb HERIDO"
  DEFB 255
END ASM

pilomor:
ASM
  DEFB 22, 15, 9
  DEFM "ESTb MUERTO"
  DEFB 255
END ASM

fumotori:
ASM
  DEFB 16, 0, 17, 7
  DEFB 22, 6, 14
  DEFB 33, 34, 35
  DEFB 17, 0
  DEFB 255
END ASM

passpa1:
ASM
  DEFB 16, 7, 17, 0, 19, 1
  DEFB 22, 3, 16
  DEFM "$% "
  DEFB 22, 4, 16
  DEFM "&'("
  DEFB 22, 5, 16
  DEFM ")*+Y"
  DEFB 22, 6, 16
  DEFM ",-.Z["
  DEFB 255
END ASM

passpa2:
ASM
  DEFB 16, 7, 17, 0
  DEFB 22, 3, 16
  DEFM " /0"
  DEFB 22, 4, 16
  DEFM "1'2"
  DEFB 22, 5, 16
  DEFM "345"
  DEFB 22, 6, 16
  DEFM "67 "
  DEFB 255
END ASM

nav1:
ASM
  DEFB 16, 7, 17, 0
  DEFB 22, 4, 16
  DEFM "\"
  DEFB 22, 5, 16
  DEFM "]"
  DEFB 255
END ASM

nav2:
ASM
  DEFB 16, 7, 17, 0
  DEFB 22, 4, 16
  DEFM "^"
  DEFB 22, 5, 16
  DEFM "_"
  DEFB 255
END ASM

suololun:
ASM
  DEFB 19, 0
  DEFB 22, 7, 11
  DEFM 96, 96, 96, 96, 96, 96, 96, 96, 96, 96
  DEFB 255
END ASM

bandusa:
ASM
  DEFB 16, 7, 17, 1
  DEFB 22, 3, 17
  DEFM "w"
  DEFB 16, 2, 17, 7
  DEFM "xx"
  DEFB 22, 4, 17
  DEFM "xxx"
  DEFB 255
END ASM

bandurss:
ASM
  DEFB 16, 6, 17, 2
  DEFB 22, 3, 17
  DEFM "y  "
  DEFB 22, 4, 17
  DEFM "   "
  DEFB 255
END ASM

pos1:
ASM
  DEFB 22, 2, 13
  DEFM "D"
  DEFB 22, 3, 12
  DEFM "EF"
  DEFB 22, 4, 12
  DEFM "GHI"
  DEFB 22, 5, 12
  DEFM "JK"
  DEFB 22, 6, 12
  DEFM "LMN"
  DEFB 255
END ASM

pos2:
ASM
  DEFB 22, 2, 13
  DEFM " "
  DEFB 22, 3, 12
  DEFM " 89:"
  DEFB 22, 4, 12
  DEFM " ;<="
  DEFB 22, 5, 12
  DEFM " >?@"
  DEFB 22, 6, 12
  DEFM " ABC"
  DEFB 255
END ASM

pos3:
ASM
  DEFB 22, 2, 15
  DEFM "D"
  DEFB 22, 3, 13
  DEFM " EF"
  DEFB 22, 4, 13
  DEFM " GHI"
  DEFB 22, 5, 13
  DEFM " JK"
  DEFB 22, 6, 13
  DEFM " LMN"
  DEFB 255
END ASM

pos4:
ASM
  DEFB 22, 2, 14
  DEFM "OP"
  DEFB 22, 3, 14
  DEFM "QRS"
  DEFB 22, 4, 14
  DEFM "TUS"
  DEFB 22, 5, 14
  DEFM "VWS"
  DEFB 22, 6, 14
  DEFM " XS"
  DEFB 255
END ASM

navetta1:
ASM
  ; DEFM 16, 0, 17, 5
  DEFM 21, 1
  DEFB 22, 4, 15
  DEFM "  "
  DEFM 21, 0
  DEFB 22, 3, 15
  DEFM "  "
  DEFB 255
END ASM

navetta2:
ASM
  ; DEFM 16, 0, 17, 5
  DEFM 21, 1
  DEFB 22, 5, 15
  DEFM "  "
  DEFM 21, 0
  DEFB 22, 4, 15
  DEFM "  "
  DEFB 255
END ASM

navetta3:
ASM
  ; DEFM 16, 0, 17, 5
  DEFM 21, 1
  DEFB 22, 6, 15
  DEFM "  "
  DEFM 21, 0
  DEFB 22, 5, 15
  DEFM "  "
  DEFB 255
END ASM

  ' ---------------------------
  ' ---------- SCENE ----------
  ' ---------------------------

fuzzya:
ASM
  INCBIN "scene_attrib.bin"
END ASM

fuzzyp:
ASM
  INCBIN "scene_pixel.bin"
END ASM

