  ' ------------------------------------------------------------
  ' ---------- ATTIVITÀ DI FINE TURNO / POST MISSIONI ----------
  ' ------------------------------------------------------------

  ' Cose da fare:
  ' -------------
  ' - Azzerare le ricerche e completare le ordinazioni dei materiali
  ' - Addestrare i piloti
  ' - Curare i piloti infortunati
  ' - Costruire/riparare le strutture

  ' Preparazione turno successivo:
  ' ------------------------------
  ' - Se arriva il 1976 e non si è ancora verificata una missione lunare con successo, il giocatore perde
  ' - Determinare eventuali imprevisti per la stagione successiva
  ' - Mostrare il rapporto sulle attività degli avversari
  ' - Se è primavera, determinare prestigio e fondi per l'anno in corso; mostrare rapporto sull'opinione del governo

  #INCLUDE "_intestazione.bas"

  CONST scrivania AS UINTEGER = 35852

  DECLARE FUNCTION FASTCALL time() as uLong 
  DECLARE FUNCTION FASTCALL randomBase AS UBYTE
  DECLARE FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE

  ' ----------------------------------------
  ' ---------- RECUPERO VARIABILI ----------
  ' ----------------------------------------

  DIM x, y, z, n, w, k, i, q AS UBYTE

  DIM nn, qq, zz, temp AS UINTEGER

  #INCLUDE "_recCF.bas"

  DIM cfCopia AS FLOAT AT 24600 + 431

  DIM naz AS UBYTE
  naz = PEEK (@memo)

  DIM fondi AS INTEGER
  fondi = PEEK (UINTEGER, @memo + 1)

  DIM prestigio AS INTEGER
  prestigio = PEEK (UINTEGER, @memo + 3)

  DIM prestprec AS INTEGER
  prestprec = PEEK (UINTEGER, @memo + 5)

  DIM diffpres AS INTEGER
  diffpres = PEEK (UINTEGER, @memo + 7)

  DIM anno AS UBYTE
  anno = PEEK (@memo + 8)

  DIM turno AS UBYTE
  turno = PEEK (@memo + 9)

  DIM modif AS BYTE
  modif = PEEK (@memo + 10)

  DIM stru(3,9) AS UBYTE
  x = 1
  DO
    stru(1,x) = PEEK (@memo + 10 + x)
    stru(2,x) = PEEK (@memo + 19 + x)
    stru(3,x) = PEEK (@memo + 28 + x)
    x = x + 1
  LOOP UNTIL x = 10

  DIM abi(8,10) AS UBYTE
  x = 1
  DO
    abi(1,x) = PEEK (@memo + 37 + x)
    abi(2,x) = PEEK (@memo + 47 + x)
    abi(3,x) = PEEK (@memo + 57 + x)
    abi(4,x) = PEEK (@memo + 67 + x)
    abi(5,x) = PEEK (@memo + 77 + x)
    abi(6,x) = PEEK (@memo + 87 + x)
    abi(7,x) = PEEK (@memo + 97 + x)
    abi(8,x) = PEEK (@memo + 107 + x)
    x = x + 1
  LOOP UNTIL x = 11

  DIM rsmax(19) AS UBYTE
  DIM effmax(19) AS UBYTE
  DIM qt(19) AS UBYTE
  DIM rsatt(19) AS UBYTE
  DIM effatt(19) AS UBYTE
  DIM progrs(19) AS UBYTE
  DIM ordini(19) AS UBYTE
  x = 1
  DO
    rsmax(x) = PEEK (@memo + 173 + x)
    effmax(x) = PEEK (@memo + 192 + x)
    qt(x) = PEEK (@memo + 230 + x)
    rsatt(x) = PEEK (@memo + 249 + x)
    effatt(x) = PEEK (@memo + 268 + x)
    progrs(x) = PEEK (@memo + 287 + x)
    ordini(x) = PEEK (@memo + 306 + x)
    x = x + 1
  LOOP UNTIL x = 20

  DIM pm(6) AS UBYTE
  x = 1
  DO
    pm(x) = PEEK (@memo + 400 + x)
    x = x + 1
  LOOP UNTIL x = 7

  DIM pmbon(6) AS UBYTE => {12,16,8,10,12,20}

  DIM ia AS UINTEGER
  ia = PEEK (UINTEGER, @memo + 413)

  DIM pilost$(10)
  x = 1
  DO
    pilost$(x) = CHR$(PEEK(@memo + 415 + x))
    x = x + 1
  LOOP UNTIL x = 11

  DIM rand AS UBYTE

  DIM bonmal AS BYTE

  DIM pilo$(10)
  IF naz = 1 THEN
    pilo$(1) = "SHEPARD"
    pilo$(2) = "GLENN"
    pilo$(3) = "COOPER"
    pilo$(4) = "SCHIRRA"
    pilo$(5) = "GRISSOM"
    pilo$(6) = "YOUNG"
    pilo$(7) = "COLLINS"
    pilo$(8) = "ARMSTRONG"
    pilo$(9) = "ALDRIN"
    pilo$(10) = "WHITE"
  ELSE
    pilo$(1) = "GAGARIN"
    pilo$(2) = "TITOV"
    pilo$(3) = "LEoNOV"
    pilo$(4) = "TERESHKOVA"
    pilo$(5) = "BYKOVSKIJ"
    pilo$(6) = "BELIbYEV"
    pilo$(7) = "GORBATKo"
    pilo$(8) = "KOMAROV"
    pilo$(9) = "BEREGoVOI"
    pilo$(10) = "POPOVICH"
  END IF

  IF naz = 1 THEN
    avver$ = "LOS SOVIgTICOS "
    gov$ = " PRESIDENTE "
  ELSE
    avver$ = "LOS AMERICANOS "
    gov$ = " POLITBURO "
  END IF

  DIM abl$(5)
  abl$(1) = "PIL.BbSICO"
  abl$(2) = "AEV"
  abl$(3) = "ATRAQUE"
  abl$(4) = "PIL.AVANZADO"
  abl$(5) = "RESISTENCIA"

  DIM inte$(5)
  inte$(1) = "HEMOS DESCUBIERTO"
  inte$(2) = "SABEMOS CON CERTEZA"
  inte$(3) = "NS. AGENTES DICEN"
  inte$(4) = "NOS HAN INFORMADO"
  inte$(5) = "ACTUALMENTE SABEMOS"

  DIM mate$(19)
  IF naz = 1 THEN
    mate$(1) = "EXPLORER"
    mate$(2) = "RANGER"
    mate$(3) = "SURVEYOR"
    mate$(4) = "MERCURY"
    mate$(5) = "GEMINI"
    mate$(6) = "APOLO"
    mate$(7) = "XMS-2"
    mate$(8) = "JtPITER"
    mate$(9) = "LM-1"
    mate$(10) = "LEM"
    mate$(13) = "ATLAS"
    mate$(14) = "TITbN"
    mate$(15) = "SATURNO V"
    mate$(16) = "NOVA"
    mate$(17) = "BOOSTER"
  ELSE
    mate$(1) = "SPUTNIK"
    mate$(2) = "KOSMOS"
    mate$(3) = "LUNA"
    mate$(4) = "VOSTOK"
    mate$(5) = "VOSJOD"
    mate$(6) = "SOYUZ"
    mate$(7) = "SPIRAL"
    mate$(8) = "LK-700"
    mate$(9) = "LK"
    mate$(10) = "LEK"
    mate$(13) = "R-7"
    mate$(14) = "11A511"
    mate$(15) = "N1"
    mate$(16) = "UR-700"
    mate$(17) = "ETAPA ADIC."
  END IF

  mate$(11) = "M.ATRAQUE"
  mate$(12) = "TRAJE AEV"
  mate$(18) = "MoD.SER.A"
  mate$(19) = "MoD.SER.B"

  ' --------------------------------------
  ' ---------- INIZIO PROGRAMMA ----------
  ' --------------------------------------

  BORDER 0 : PAPER 0 : INK 0 : BRIGHT 1: CLS

  dzx7AgileRCS(@scrivania,16384)

  PAPER 7

  updateSeed()

  ' -------------------------------------------------------------------------------
  ' ---------- RESET DELLE RICERCHE IN CORSO E COMPLETAMENTO ORDINAZIONI ----------
  ' -------------------------------------------------------------------------------

  ' Reset delle ricerche in corso, di modo che siano disponibili nuovamente nel turno
  ' (stato del programma di R&S: 0 = non avviato, 1 = avviato, 2 = in corso di ricerca per questo turno)

  n = 1
  DO
    IF progrs(n) = 2 THEN progrs(n) = 1

  ' Aggiunge la quantità di ordini(n) in qt(n) e azzera gli ordini in corso

    qt(n) = qt(n) + ordini(n)
    ordini(n) = 0

	n = n + 1
  LOOP UNTIL n = 20

  ' ---------------------------------------------------------------
  ' ---------- CONDUZIONE E RISULTATO DELL'ADDESTRAMENTO ----------
  ' ---------------------------------------------------------------

  ' Verifica quali piloti sono in addestramento

  n = 1
  DO
    IF pilost$(n) = "E" THEN addest()
    puliscri()
    n = n + 1
  LOOP UNTIL n = 11

  ' ---------------------------------------------
  ' ---------- CURA PILOTI INFORTUNATI ----------
  ' ---------------------------------------------

  ' Cura i piloti infortunati e li rende disponibili nuovamente al termine, o riprende l'addestramento

  n = 1
  DO
    IF pilost$(n) = "L" THEN abi(8,n) = abi(8,n) - 1
    IF abi(8,n) = 0 AND pilost$(n) = "L" AND abi(6,n) > 0 THEN pilost$(n) = "E"
    IF abi(8,n) = 0 AND pilost$(n) = "L" AND abi(6,n) = 0 THEN pilost$(n) = "D"
    n = n + 1
  LOOP UNTIL n = 11

  ' -------------------------------------------------------
  ' ---------- COSTRUZIONE/RIPARAZIONE STRUTTURE ----------
  ' -------------------------------------------------------

  ' Verifica quali strutture sono in costruzione/riparazione (valore > 2) e scala il relativo turno di 1
  ' Se il valore arriva a 1 marca la struttura come "disponibile"

  n = 1
  DO
    IF stru(1,n) > 2 AND stru(2,n) > 0 THEN stru(2,n) = stru(2,n) - 1
    IF stru(1,n) > 2 AND stru(2,n) = 0 THEN stru(1,n) = 1
    n = n + 1
  LOOP UNTIL n = 10

  ' -------------------------------------------
  ' ---------- AVANZAMENTO DEL TEMPO ----------
  ' -------------------------------------------

  turno = turno + 1

  IF turno = 5 THEN anno = anno + 1 : turno = 1

  ' Sconfitta per fine tempo

  IF anno = 76 THEN GOTO sconfitta

  ' ---------------------------------------------------------
  ' ---------- INTELLIGENZA ARTIFICIALE AVVERSARIA ---------- 
  ' ---------------------------------------------------------

  ' Ad ogni turno aggiunge un coefficiente casuale al loro livello di progresso (iaprog).

rapporto:

  randomBase()
  rand = randomLimit(4)+1

  ' Stampa intestazione

  INK naz
  POKE UINTEGER indir,@rappserv: stampa()
  INK 0

  PAPER 7
  PRINT AT 4,8; inte$(rand); AT 5,8; "QUE "+avver$

  randomBase()
  rand = randomLimit(4)+1

  ' Niente da segnalare

  IF rand = 5 THEN POKE UINTEGER indir,@ia0 : GOTO finerapporto

  ia = ia + rand + modif

  ' Razzo vettore leggero in lavorazione

  IF ia < 8 THEN POKE UINTEGER indir,@ia1 

  ' Razzo vettore leggero lanciato

  IF ia > 7 AND ia < 15 THEN POKE UINTEGER indir,@ia2 : ia = 20

  ' Satellite artificiale in lavorazione

  IF ia > 20 AND ia < 31 THEN POKE UINTEGER indir,@ia3 

  ' Satellite artificiale lanciato

  IF ia > 30 AND ia < 38 THEN z = 1: POKE UINTEGER indir,@ia3a : notizia(): ia = 40: GOTO fineflash

  ' Razzo vettore medio in lavorazione

  IF ia > 40 AND ia < 51 THEN POKE UINTEGER indir,@ia4

  ' Razzo vettore medio lanciato

  IF ia > 50 AND ia < 58 THEN POKE UINTEGER indir,@ia5

  ' Piloti in addestramento

  IF ia > 57 AND ia < 66 THEN POKE UINTEGER indir,@ia5a

  ' Capsula monoposto in lavorazione

  IF ia > 65 AND ia < 76 THEN POKE UINTEGER indir,@ia6

  ' Capsula monoposto in collaudo

  IF ia > 75 AND ia < 86 THEN POKE UINTEGER indir,@ia7

  ' Capsula monoposto lanciata

  IF ia > 85 AND ia < 93 THEN z = 2: POKE UINTEGER indir,@ia8: notizia(): ia = 95: GOTO fineflash

  ' Tuta EVA

  IF ia > 95 AND ia < 106 THEN POKE UINTEGER indir,@ia9

  ' Capsula biposto in lavorazione

  IF ia > 105 AND ia < 116 THEN POKE UINTEGER indir,@ia10

  ' Capsula biposto in collaudo

  IF ia > 115 AND ia < 126 THEN POKE UINTEGER indir,@ia11

  ' Capsula biposto e passeggiata spaziale

  IF ia > 125 AND ia < 133 THEN z = 3: POKE UINTEGER indir,@ia12: notizia(): ia = 160: GOTO fineflash

  ' Razzo vettore pesante in lavorazione

  IF ia > 160 AND ia < 176 THEN POKE UINTEGER indir,@ia13

  ' Razzo vettore pesante lanciato

  IF ia > 175 AND ia < 181 THEN POKE UINTEGER indir,@ia14

  ' Satellite lunare in lavorazione

  IF ia > 180 AND ia < 196 THEN POKE UINTEGER indir,@ia15

  ' Satellite lunare lanciato

  IF ia > 195 AND ia < 203 THEN z = 4: POKE UINTEGER indir,@ia16: notizia(): ia = 205: GOTO fineflash

  ' Sonda lunare in lavorazione

  IF ia > 205 AND ia < 221 THEN POKE UINTEGER indir,@ia17

  ' Sonda lunare lanciata

  IF ia > 220 AND ia < 228 THEN z = 5: POKE UINTEGER indir,@ia18: notizia(): ia = 235: GOTO fineflash

  ' Nuovo veicolo in progetto

  IF ia > 235 AND ia < 246 THEN POKE UINTEGER indir,@ia19

  ' Nuovo veicolo in collaudo

  IF ia > 245 AND ia < 261 THEN POKE UINTEGER indir,@ia20

  ' Missione verso la luna

  IF ia > 260 AND ia < 276 THEN POKE UINTEGER indir,@ia21

  ' Volo lunare

  IF ia > 275 AND ia < 283 THEN z = 6: POKE UINTEGER indir,@ia22: notizia(): ia = 290: GOTO fineflash

finerapporto:

  stampa()

fineflash:

  PAUSE 0

  ' Se il prestigio va a zero o è negativo il giocatore perde

  IF prestigio < 1 THEN POKE @segue,8 : GOTO sconfitta

  ' -------------------------------
  ' ---------- PRESTIGIO ----------
  ' -------------------------------

messaggio:

  ' Se non è cominciato un nuovo anno si va direttamente al menù principale

  IF turno <> 1 THEN GOTO nuovoturno

  ' Cancella la scrivania

  puliscri()

  ' Mostra l'emblema

  qq = 16384+14

  ' Controlla quale ritratto dobbiamo mostrare (0 = Shepard)

  temp = @emblemi

  IF naz = 2 THEN temp = temp + 512

PIXEL:

  zz = qq
  FOR m = 0 TO 7
    FOR nn = zz TO zz + 7
      POKE nn, PEEK temp
      temp = temp + 1
    NEXT nn
    zz = zz + 256
  NEXT m

  qq = qq + 32

  ' 16608 = 16384 + 32*8 (8 righe)

  IF qq <= 16608+14 THEN GOTO PIXEL

  ' Stampa "Comunicazione dal..."

  INK naz: POKE UINTEGER indir,@comunicaz: stampa()

  PRINT AT 10,14; gov$

  INK 0 : PAPER 7

  ' Raffronto del prestigio con l'anno precedente

  diffpres = prestigio - prestprec

  IF diffpres > -1 AND diffpres < 6 THEN POKE UINTEGER indir,@messneut 

  IF diffpres > 5 AND diffpres < 11 THEN POKE UINTEGER indir,@messpos1: cf = cf + 0.1

  IF diffpres > 10 AND diffpres < 16 THEN POKE UINTEGER indir,@messpos2: cf = cf + 0.2

  IF diffpres > 15 THEN POKE UINTEGER indir,@messpos3: cf = cf + 0.3

  IF diffpres > -11 AND diffpres < 1 THEN POKE UINTEGER indir,@messneg1: prestigio = prestigio - 6: cf = cf - 0.1

  IF diffpres > -16 AND diffpres < -10 THEN POKE UINTEGER indir,@messneg2: prestigio = prestigio - 7: cf = cf - 0.2

  IF diffpres < -15 THEN POKE UINTEGER indir,@messneg3: prestigio = prestigio - 8: cf = cf - 0.3

  ' Limite minimo per cf

  IF cf < 0.1 THEN cf = 0.1

  stampa()

  PAUSE 0

  ' Se il prestigio va a zero o è negativo il giocatore perde

  IF prestigio < 1 THEN POKE @segue,8 : GOTO sconfitta

  ' Il prestigio registrato quest'anno viene memorizzato in prestprec per il confronto con quello dell'anno prossimo

  prestprec = prestigio

  ' Calcola il finanziamento per quest'anno in base al prestigio

  fondi = fondi + INT(prestigio*cf*0.80)

nuovoturno:

  puliscri()

  ' ---------------------------------------
  ' ---------- EVENTI IMPREVISTI ----------
  ' ---------------------------------------

  ' 1) Infortunio: un pilota a caso tra quelli reclutati (se ce ne sono) si è infortunato
  ' 2) Difetto: abbassa il livello di efficienza di un programma già sviluppato di 15 punti
  ' 3) Progresso: alza il livello di efficienza di un programma già sviluppato di 15 punti
  ' 4) Fondi extra: bonus +30 fondi
  ' 5) Tagli: malus -30 fondi

  randomBase()
  rand = randomLimit(99)+1

  IF rand < 51 THEN GOTO backup

  POKE UINTEGER indir,@impre: stampa()

  IF rand > 50 AND rand < 61 THEN GOTO infortunio

  IF rand > 60 AND rand < 71 THEN GOTO difetto

  IF rand > 70 AND rand < 81 THEN GOTO progresso

  IF rand > 80 AND rand < 91 THEN GOTO fondiextra

  IF rand > 90 THEN GOTO tagli

infortunio:

  randomBase()
  rand = randomLimit(9)+1

  ' Se il pilota selezionato non è stato assunto o è morto esci

  IF pilost$(rand) = "N" OR pilost$(rand) = "X" THEN GOTO backup

  PRINT AT 3,9; pilo$(rand)

  POKE UINTEGER indir,@infortun: stampa()

  pilost$(rand) = "L": abi(8,rand) = 2

  GOTO fineimpre

difetto:

  randomBase()
  rand = randomLimit(19)+1

  ' Se non abbiamo ancora avviato il programma di ricerca esci

  IF progrs(rand) = 0 THEN GOTO backup

  ' Diminuisce l'efficienza attuale

  effatt(rand) = effatt(rand) - 15
  IF effatt(rand) < 0 THEN effatt(rand) = 0
  
  ' Livella la R&S all'efficienza attuale
  
  rsatt(rand) = effatt(rand)

  POKE UINTEGER indir,@incid: stampa()

  PRINT AT 5,8; mate$(rand)

  GOTO fineimpre

progresso:

  randomBase()
  rand = randomLimit(19)+1

  ' Se non abbiamo ancora avviato il programma di ricerca esci

  IF progrs(rand) = 0 OR rsatt(rand) = rsmax(rand) THEN GOTO backup

  ' Aumenta di 15 la ricerca
  
  rsatt(rand) = rsatt(rand) + 15
  
  ' Se la R&S attuale eccede quella massima, si livella con quest'ultima
  
  IF rsatt(rand) > rsmax(rand) THEN rsatt(rand) = rsmax(rand)

  POKE UINTEGER indir,@progre: stampa()

  PRINT AT 5,8; mate$(rand)

  GOTO fineimpre

fondiextra:

  POKE UINTEGER indir,@favor: stampa()

  fondi = fondi + 20

  GOTO fineimpre

tagli:

  POKE UINTEGER indir,@contr: stampa()

  fondi = fondi - 20

fineimpre:

  IF fondi < 0 THEN fondi = 0

  PAUSE 0

  ' Torna al menù principale

  GOTO backup

  ' -------------------------------
  ' ---------- SCONFITTA ----------
  ' -------------------------------

  ' La sconfitta viene determinata in questa fase secondo tre possibili condizioni:
  ' a) prestigio < 1
  ' b) anno = 76
  ' c) ia = 999
  ' In tutti questi casi si esce dal programma senza passare dal salvataggio variabili

sconfitta:

  INK 7: PAPER 0: BRIGHT 1: CLS

  POKE UINTEGER indir,@haiperso: stampa()

  IF anno = 76 THEN POKE UINTEGER indir,@finetempo: stampa()
  
  IF ia = 999 THEN
    PRINT AT 10,0; avver$; "LOGRARON LLEGAR A"
    POKE UINTEGER indir,@vintoloro: stampa()
  END IF

  IF prestigio < 1 THEN
    PRINT AT 10,2; gov$; "TE RELEVo DE"
    POKE UINTEGER indir,@licenz: stampa()
  END IF

  BEEP 1,-25

  PAUSE 0

  POKE @segue,8 : GOTO fineprog

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

backup:

  puliscri()

  ' POKE @memo, naz
  POKE UINTEGER @memo + 1, fondi
  POKE UINTEGER @memo + 3, prestigio
  POKE UINTEGER @memo + 5, prestprec
  POKE UINTEGER @memo + 7, diffpres
  POKE @memo + 8, anno
  POKE @memo + 9, turno

  x = 1
  DO
    POKE @memo + 10 + x, stru(1,x)
    POKE @memo + 19 + x, stru(2,x)
    POKE @memo + 28 + x, stru(3,x)
    x = x + 1
  LOOP UNTIL x = 10

  x = 1
  DO
    POKE @memo + 37 + x, abi(1,x)
    POKE @memo + 47 + x, abi(2,x)
    POKE @memo + 57 + x, abi(3,x)
    POKE @memo + 67 + x, abi(4,x)
    POKE @memo + 77 + x, abi(5,x)
    POKE @memo + 87 + x, abi(6,x)
    POKE @memo + 97 + x, abi(7,x)
    POKE @memo + 107 + x, abi(8,x)
    x = x + 1
  LOOP UNTIL x = 11

  x = 1
  DO
    POKE @memo + 230 + x, qt(x)
    POKE @memo + 249 + x, rsatt(x)
    POKE @memo + 268 + x, effatt(x)
    POKE @memo + 287 + x, progrs(x)
    POKE @memo + 306 + x, ordini(x)
    x = x + 1
  LOOP UNTIL x = 20

  x = 1
  DO
    POKE @memo + 400 + x, pm(x)
    x = x + 1
  LOOP UNTIL x = 7

  POKE UINTEGER @memo + 413, ia
 
  x = 1
  DO
    POKE @memo + 415 + x, CODE pilost$(x)
    x = x + 1
  LOOP UNTIL x = 11

  cfCopia = cf

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------

  POKE @segue, 1

fineprog:

  BORDER 7: PAPER 7

  END

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Procedura addestramento piloti

SUB addest()

  ' CLS

  ' Determina quale abilità stiamo addestrando (1-5)

  w = abi(7,n)

  ' Scala di 1 il numero di turni necessari all'addestramento

  abi(6,n) = abi(6,n) - 1

  ' Se l'addestramento non è ancora finito esce

  IF abi(6,n) > 0 THEN PRINT AT 8,8; "\{p7}TURNOS: ";abi(6,n): INK naz: POKE UINTEGER indir,@addincorso: stampa(): GOTO esci3

  ' Calcola il risultato dell'addestramento

  randomBase()
  rand = randomLimit(4)+1

  abi(w,n) = abi(w,n) + rand

  ' Massimo livello 9

  IF abi(w,n) > 9 THEN abi(w,n) = 9

  ' Stampa il risultato

  INK naz: POKE UINTEGER indir,@risultadd: stampa()

  ' Marca il pilota nuovamente come disponibile

  pilost$(n) = "D"
 
esci3:

  PAPER 7: INK 0

  PRINT AT 4,8; pilo$(n); AT 6,8; abl$(w); ": "; abi(w,n)

  PAUSE 0

END SUB

  ' Stampa l'avviso "notizia flash" e controlla se gli avversari hanno raggiunto una pietra miliare

SUB notizia()

  puliscri()

  stampa()

  POKE UINTEGER indir,@newsflash: stampa()

  PRINT AT 3,8; "z";avver$

  IF pm(z) = 0 THEN pm(z) = 1: prestigio = prestigio - pmbon(z)/2: POKE UINTEGER indir,@pietraloro: stampa()

END SUB

  ' Pulisce la scrivania

SUB puliscri()

  q = 0
   DO
   PRINT AT q,8; "                    "
   q = q+1
  LOOP UNTIL q = 20

END SUB

  ' Funzioni per il calcolo dei coefficienti pseudo-casuali (Britlion, Patrik Rak)

FUNCTION FASTCALL time() AS ULONG
ASM
  DI
  LD DE,(23674)
  LD D,0
  LD HL,(23672)
  EI
END ASM
END FUNCTION

FUNCTION FASTCALL randomBase AS UBYTE
ASM
random:
  ld  de,$A280   ; xz -> yw
  ld  hl,$C0DE   ; yw -> zt
  ld  (random+1),hl  ; x = y, z = w
  ld  a,l         ; w = w ^ ( w << 3 )
  add a,a
  add a,a
  add a,a
  xor l
  ld  l,a
  ld  a,d         ; t = x ^ (x << 1)
  add a,a
  xor d
  ld  h,a
  rra             ; t = t ^ (t >> 1) ^ w
  xor h
  xor l
  ld  h,e         ; y = z
  ld  l,a         ; w = t
  ld  (random+4),hl
END ASM
END FUNCTION

SUB FASTCALL updateSeed()
REM Updates the random generator seed from the FRAMES system variable.
time()
ASM
  LD A,E
  EX DE,HL
  LD HL,random+2
  XOR (HL)
  AND A
  JR NZ,updateSeedNotZero
  INC A
updateSeedNotZero:
  LD (HL),A
  LD HL,random+4
  LD A,E
  XOR (HL)
  LD (HL),A
  INC HL
  LD A,D
  XOR (HL)
  LD (HL),A
END ASM
END SUB

FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE
ASM
  AND A
  RET Z ; Input zero, output zero.
  LD B,A ; Save A

  LD C,255
  randomBinLoop:
  RLA
  JR C, randomBinLoopExit
  RR C
  JR randomBinLoop ; loop back until we find a bit.
  randomBinLoopExit:

  randomBinRedoCall:
  call random
  AND C
  CP B
  RET Z
  JR NC, randomBinRedoCall
END ASM
END FUNCTION

  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

addincorso:
ASM
  DEFB 22, 1, 11
  DEFM "ENTRENAMIENTO"
  DEFB 22, 2, 13
  DEFM "EN CURSO"
  DEFB 255
END ASM

risultadd:
ASM
  DEFB 22, 1, 13
  DEFM "RESULTADO"
  DEFB 22, 2, 11
  DEFM "ENTRENAMIENTO"
  DEFB 255
END ASM

comunicaz:
ASM
  DEFB 22, 9, 12
  DEFM "COMUNICACIoN"
  DEFB 22, 10, 11
  DEFM "DAL"
  DEFB 255
END ASM

messneut:
ASM
  DEFB 22, 12, 8
  DEFM "NO SE OBSERVAN"
  DEFB 22, 13, 8
  DEFM "PROGRESOS NOTABLES"
  DEFB 22, 14, 8
  DEFM "EN EL PROGRAMA. SE"
  DEFB 22, 15, 8
  DEFM "ESPERAN RESULTADOS"
  DEFB 22, 16, 8
  DEFM "MEJORES."
  DEFB 255
END ASM

messpos1:
ASM
  DEFB 22, 12, 8
  DEFM "HAY ALGUNOS AVANCES,"
  DEFB 22, 13, 8
  DEFM "PERO SE ESPERA UN"
  DEFB 22, 14, 8
  DEFM "PROGRESO MbS"
  DEFB 22, 15, 8
  DEFM "SUSTANCIAL PARA EL"
  DEFB 22, 16, 8
  DEFM "PRoXIMO AmO."
  DEFB 255
END ASM

messpos2:
ASM
  DEFB 22, 12, 8
  DEFM "EL PROGRAMMA HAS"
  DEFB 22, 13, 8
  DEFM "LOGRADO ALGUNOS RE-"
  DEFB 22, 14, 8
  DEFM "SULTADOS POSITIVOS."
  DEFB 22, 15, 8
  DEFM "ESPERAMOS OTROS"
  DEFB 22, 16, 8
  DEFM "PROGRESOS EN EL"
  DEFB 22, 17, 8
  DEFM "FUTURO."
  DEFB 255
END ASM

messpos3:
ASM
  DEFB 22, 12, 8
  DEFM "HAY SATISFACCIoN"
  DEFB 22, 13, 8
  DEFM "POR LOS RESULTADOS"
  DEFB 22, 14, 8
  DEFM "ALCANZADOS EL AmO"
  DEFB 22, 15, 8
  DEFM "PASADO. SE DEBE"
  DEFB 22, 16, 8
  DEFM "CONTINUAR ASl."
  DEFB 255
END ASM

messneg1:
ASM
  DEFB 22, 12, 8
  DEFM "EL PROGRAMA AVANZA"
  DEFB 22, 13, 8
  DEFM "DEMASIADO LENTAMEN-"
  DEFB 22, 14, 8
  DEFM "TE. SE DEBE REANUDAR"
  DEFB 22, 15, 8
  DEFM "COM MbS COMPROMISO."
  DEFB 255
END ASM

messneg2:
ASM
  DEFB 22, 12, 8
  DEFM "LOS RESULTADOS ESTbN"
  DEFB 22, 13, 8
  DEFM "POR DEBAJO DE LAS"
  DEFB 22, 14, 8
  DEFM "EXPECTATIVAS. SE"
  DEFB 22, 15, 8
  DEFM "ESPERA UNA MEJORA"
  DEFB 22, 16, 8
  DEFM "DETERMINADA."
  DEFB 255
END ASM

messneg3:
ASM
  DEFB 22, 12, 8
  DEFM "LOS RESULTADOS DEL"
  DEFB 22, 13, 8
  DEFM "PROGRAMA NO SON"
  DEFB 22, 14, 8
  DEFM "SATISFACTORIOS. SE"
  DEFB 22, 15, 8
  DEFM "REQUIERE UNA SERIA"
  DEFB 22, 16, 8
  DEFM "REVISIoN DE SUS"
  DEFB 22, 17, 8
  DEFM "OBJETIVOS Y METODOS."
  DEFB 255
END ASM

rappserv:
ASM
  DEFB 22, 1, 14
  DEFM "INFORME"
  DEFB 22, 2, 9
  DEFM "SERVICIOS SECRETOS"
  DEFB 255
END ASM

newsflash:
ASM
  DEFB 22, 1, 10
  DEFB 20, 1
  DEFM " NOTICIA "
  DEFB 219
  DEFB 20, 0
  DEFB 255
END ASM

ia0:
ASM
  DEFB 22, 4, 8
  DEFM "PARA ESTE PERlODO   "
  DEFB 22, 5, 8
  DEFM "NO HAY NADA ESPECIAL"
  DEFB 22, 6, 8
  DEFM "QUE REPORTAR."
  DEFB 255
END ASM

ia1:
ASM
  DEFB 22, 6, 8
  DEFM "TRABAJAN EN UN"
  DEFB 22, 7, 8
  DEFM "LANZADOR LIGERO."
  DEFB 255
END ASM

ia2:
ASM
  DEFB 22, 6, 8
  DEFM "LANZARON CON gXITO"
  DEFB 22, 7, 8
  DEFM "UN COHETE PROPULSOR"
  DEFB 22, 8, 8
  DEFM "LIGERO."
  DEFB 255
END ASM

ia3:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN TRABAJANDO"
  DEFB 22, 7, 8
  DEFM "EN UN SATgLITE"
  DEFB 22, 8, 8
  DEFM "ARTIFICIAL."
  DEFB 255
END ASM

ia3a:
ASM
  DEFB 22, 4, 8
  DEFB "ENVIARON UN SATgLITE"
  DEFB 22, 5, 8
  DEFM "ARTIFICIAL EN oRBITA"
  DEFB 22, 6, 8
  DEFM "TERRESTRE!"
  DEFB 255
END ASM

ia4:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN DISEmANDO UN"
  DEFB 22, 7, 8
  DEFM "COHETE LANZADOR"
  DEFB 22, 8, 8
  DEFM "MEDIO."
  DEFB 255
END ASM

ia5:
ASM
  DEFB 22, 6, 8
  DEFM "PROBARON UN LANZADOR"
  DEFB 22, 7, 8
  DEFM "MEDIO CON gXITO."
  DEFB 255
END ASM

ia5a:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN ENTRENANDO"
  DEFB 22, 7, 8
  DEFM "ALGUNOS PILOTOS"
  DEFB 22, 8, 8
  DEFM "PARA EL VUELO"
  DEFB 22, 9, 8
  DEFM "ESPACIAL."
  DEFB 255
END ASM

ia6:
ASM
  DEFB 22, 6, 8
  DEFM "TRABAJAN EN UNA"
  DEFB 22, 7, 8
  DEFM "CbPSULA MONOPLAZA,"
  DEFB 22, 8, 8
  DEFM "PARA EL ENVlO EN"
  DEFB 22, 9, 8
  DEFM "oRBITA TERRESTRE."
  DEFB 255
END ASM

ia7:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN PROBANDO SU"
  DEFB 22, 7, 8
  DEFM "CbPSULA."
  DEFB 255
END ASM

ia8:
ASM
  DEFB 22, 4, 8
  DEFM "ENVIARON UN PILOTO"
  DEFB 22, 5, 8
  DEFM "EN oRBITA TERRESTRE!"
  DEFB 255
END ASM

ia9:
ASM
  DEFB 22, 6, 8
  DEFM "DISEmARON UN TRAJE"
  DEFB 22, 7, 8
  DEFM "PARA LAS ACTIVIDADES"
  DEFB 22, 8, 8
  DEFM "EXTRAVEHICULARES."
  DEFB 255
END ASM

ia10:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN DISEmANDO UNA"
  DEFB 22, 7, 8
  DEFM "NUEVA CbPSULA."
  DEFB 255
END ASM

ia11:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN PROBANDO UNA"
  DEFB 22, 7, 8
  DEFM "CbPSULA BIPLAZA."
  DEFB 255
END ASM

ia12:
ASM
  DEFB 22, 4, 8
  DEFM "HICIERON UN PASEO"
  DEFB 22, 5, 8
  DEFM "EN EL ESPACIO!"
  DEFB 255
END ASM

ia13:
ASM
  DEFB 22, 6, 8
  DEFM "TRABAJAN EN UN"
  DEFB 22, 7, 8
  DEFM "COHETE LANZADOR"
  DEFB 22, 8, 8
  DEFM "PESADO."
  DEFB 255
END ASM

ia14:
ASM
  DEFB 22, 6, 8
  DEFM "HAN PROBADO SU NUEVO"
  DEFB 22, 7, 8
  DEFM "COHETE PROPULSOR"
  DEFB 22, 8, 8
  DEFM "PESADO CON gXITO."
  DEFB 255
END ASM

ia15:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN DISEmANDO UN"
  DEFB 22, 7, 8
  DEFM "SATgLITE PARA EL"
  DEFB 22, 8, 8
  DEFM "RECONOCIMIENTO"
  DEFB 22, 9, 8
  DEFM "LUNAR."
  DEFB 255
END ASM

ia16:
ASM
  DEFB 22, 4, 8
  DEFB "ENVIARON UN SATgLITE"
  DEFB 22, 5, 8
  DEFM "EN oRBITA LUNAR!"
  DEFB 255
END ASM

ia17:
ASM
  DEFB 22, 6, 8
  DEFM "ESTbN CONSTRUYENDO"
  DEFB 22, 7, 8
  DEFM "UNA SONDA PARA EL"
  DEFB 22, 8, 8
  DEFM "ATERRIZAJE LUNAR."
  DEFB 255
END ASM

ia18:
ASM
  DEFB 22, 4, 8
  DEFM "LOGRARON ATERRIZAR"
  DEFB 22, 5, 8
  DEFM "SU SONDA EN LA LUNA!"
  DEFB 255
END ASM

ia19:
ASM
  DEFB 22, 6, 8
  DEFM "TRABAJAN EN UN NUEVO"
  DEFB 22, 7, 8
  DEFM "VEHlCULO TRIPULADO."
  DEFB 255
END ASM

ia20:
ASM
  DEFB 22, 6, 8
  DEFM "TIENEN UN VEHlCULO"
  DEFB 22, 7, 8
  DEFM "TRIPLAZA EN CURSO"
  DEFB 22, 8, 8
  DEFM "DE PRUEBA."
  DEFB 255
END ASM

ia21:
ASM
  DEFB 22, 6, 8
  DEFM "VAN A ENVIAR SU"
  DEFB 22, 7, 8
  DEFM "NUEVO VEHlCULO EN"
  DEFB 22, 8, 8
  DEFM "oRBITA LUNAR."
  DEFB 255
END ASM

ia22:
ASM
  DEFB 22, 4, 8
  DEFM "ENVIARON UN VEHlCULO"
  DEFB 22, 5, 8
  DEFM "TRIPLAZA ALREDEDOR"
  DEFB 22, 6, 8
  DEFM "DE LA LUNA!"
  DEFB 255
END ASM

ia23:
ASM
  DEFB 22, 6, 8
  DEFM "TRABAJAN A UNA"
  DEFB 22, 7, 8
  DEFM "ESPECIE DE MoDULO"
  DEFB 22, 8, 8
  DEFM "LUNAR."
  DEFB 255
END ASM

ia24:
ASM
  DEFB 22, 6, 8
  DEFM "ESTAN PROBANDO"
  DEFB 22, 7, 8
  DEFM "UN MoDULO LUNAR."
  DEFB 255
END ASM

ia25:
ASM
  DEFB 22, 6, 8
  DEFM "TIENEN UN PLAN"
  DEFB 22, 7, 8
  DEFM "DEFINITIVO PARA"
  DEFB 22, 8, 8
  DEFM "ENVIAR UN VEHlCULO"
  DEFB 22, 9, 8
  DEFM "TRIPULADO EN LA"
  DEFB 22, 10, 8
  DEFM "LUNA."
  DEFB 255
END ASM

ia26:
ASM
  DEFB 22, 4, 8
  DEFM "LOGRARON ENVIAR UNA"
  DEFB 22, 5, 8
  DEFM "TRIPULACIoN EN LA"
  DEFB 22, 6, 8
  DEFM "LUNA Y HACERLA"
  DEFB 22, 7, 8
  DEFM "VOLVER A LA TIERRA!"
  DEFB 22, 10, 8
  DEFM "zLO HICIERON ANTES"
  DEFB 22, 11, 8
  DEFM "QUE NOSOTROS!"
  DEFB 255
END ASM

impre:
ASM
  DEFB 22, 1, 12
  DEFB 20, 1
  DEFM " IMPREVISTO "
  DEFB 20, 0
  DEFB 255
END ASM

infortun:
ASM
  DEFB 22, 3, 8
  DEFM "z"
  DEFB 22, 4, 8
  DEFM "CAYo ENFERMO!"
  DEFB 22, 5, 8
  DEFM "PARADO POR 2 TURNOS"
  DEFB 255
END ASM

incid:
ASM
  DEFB 22, 3, 8
  DEFM "DEFECTO HALLADO"
  DEFB 22, 4, 8
  DEFM "EN EL PROYECTO:"
  DEFB 22, 7, 8
  DEFM "-15% I+D"
  DEFB 255
END ASM

progre:
ASM
  DEFB 22, 3, 8
  DEFM "PROGRESO EXCEPCIONAL"
  DEFB 22, 4, 8
  DEFM "PARA EL PROYECTO:"
  DEFB 22, 7, 8
  DEFM "+15% I+D"
  DEFB 255
END ASM

favor:
ASM
  DEFB 22, 3, 8
  DEFM "ASIGNACIoN DE FONDOS"
  DEFB 22, 4, 8
  DEFM "EXTRA PARA EL"
  DEFB 22, 5, 8
  DEFM "PROGRAMA ESPACIAL"
  DEFB 22, 6, 8
  DEFM "+20"
  DEFB 255
END ASM

contr:
ASM
  DEFB 22, 3, 8
  DEFM "RECORTES DE FONDOS"
  DEFB 22, 4, 8
  DEFM "AL PROGRAMA A CAUSA"
  DEFB 22, 5, 8
  DEFM "DE GASTOS MbS"
  DEFB 22, 6, 8
  DEFM "URGENTES"
  DEFB 22, 7, 8
  DEFM "-20"
  DEFB 255
END ASM

pietraloro:
ASM
  DEFB 22, 7, 8
  DEFM "zCONSIGUIERON UN"
  DEFB 22, 8, 8
  DEFM "HITO ANTES QUE"
  DEFB 22, 9, 8
  DEFM "NOSOTROS!"
  DEFB 255
END ASM

haiperso:
ASM
  DEFB 20, 1 
  DEFB 22, 8, 8
  DEFM " zHAS PERDIDO! "
  DEFB 20, 0
  DEFB 255
END ASM

finetempo:
ASM
  DEFB 22, 10, 0
  DEFM "NO LOGRASTE LLEVAR UNA"
  DEFB 13
  DEFM "TRIPULACIoN A LA LUNA Y HACER"
  DEFB 13
  DEFM "QUE VOLVIERA SANA Y SALVA"
  DEFM 13
  DEFM "ANTES DE FINALES DEL 1975."
  DEFB 255
END ASM

vintoloro:
ASM
  DEFB 22, 11, 0
  DEFM "LA LUNA ANTES DE QUE PUDIgRAMOS "
  DEFB 13
  DEFM "HACERLO NOSOTROS."
  DEFB 255
END ASM

licenz:
ASM
  DEFB 22, 10, 0
  DEFM "EL"
  DEFB 13
  DEFM "TU CARGO POR "
  DEFB 34
  DEFM "MANIFIESTA"
  DEFB 13
  DEFM "INCAPACIDAD"
  DEFB 34
  DEFM "."
  DEFB 255
END ASM


  ' ------------------------------
  ' ---------- IMMAGINI ----------
  ' ------------------------------

  ' Emblemi (non compressi)

emblemi:
ASM
  INCBIN "emblemi.bin"
END ASM