  #INCLUDE "_intestazione.bas"

  DECLARE FUNCTION FASTCALL time() as uLong 
  DECLARE FUNCTION FASTCALL randomBase AS UBYTE
  DECLARE FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE

  ' ----------------------------------------------
  ' ---------- LOCAZIONI DELLE IMMAGINI ----------
  ' ----------------------------------------------

  CONST R0A AS UINTEGER = 26140
  CONST R0B AS UINTEGER = R0A+748
  CONST R1A AS UINTEGER = R0A+1579
  CONST R1B AS UINTEGER = R0A+2201
  CONST R2A AS UINTEGER = R0A+2698
  CONST R2B AS UINTEGER = R0A+3548
  CONST R3A AS UINTEGER = R0A+4548
  CONST R3B AS UINTEGER = R0A+5011
  CONST R4A AS UINTEGER = R0A+5561
  CONST R4B AS UINTEGER = R0A+6254
  CONST R5A AS UINTEGER = R0A+6893
  CONST R5B AS UINTEGER = R0A+7429

  ' ----------------------------------------
  ' ---------- RECUPERO VARIABILI ----------
  ' ----------------------------------------

  DIM x, y, z, n, w, k, i, q AS UBYTE

  DIM naz AS UBYTE
  naz = PEEK (@memo)

  DIM fondi AS INTEGER
  fondi = PEEK (UINTEGER, @memo + 1)

  DIM prestigio AS INTEGER
  prestigio = PEEK (UINTEGER, @memo + 3)

  DIM stru(3,9) AS UBYTE
  x = 1
  DO
    stru(1,x) = PEEK (@memo + 10 + x)
    stru(2,x) = PEEK (@memo + 19 + x)
    stru(3,x) = PEEK (@memo + 28 + x)
    x = x + 1
  LOOP UNTIL x = 10

  ' Descrizione materiale:
  ' Ogni materiale è contraddistinto da un numero, che serve da guida
  ' per tutte le variabili relative a esso.
  
  '  1 - Satellite orbitale terrestre
  '  2 - Satellite orbitale lunare
  '  3 - Sonda lunare
  '  4 - Capsula monoposto
  '  5 - Capsula biposto
  '  6 - Capsula triposto
  '  7 - Mini navetta riutilizzabile
  '  8 - Veicolo lunare
  '  9 - Modulo lunare monoposto  
  ' 10 - Modulo lunare biposto
  ' 11 - Modulo aggancio
  ' 12 - Tuta AEV
  ' 13 - Razzo vettore leggero
  ' 14 - Razzo vettore medio
  ' 15 - Razzo vettore pesante
  ' 16 - Razzo vettore super
  ' 17 - Parte ausiliaria
  ' 18 - Modulo servizio A
  ' 19 - Modulo servizio B

  DIM costoini(19) AS UBYTE
  DIM costo(19) AS UBYTE
  DIM costors(19) AS UBYTE
  DIM rsmax(19) AS UBYTE
  DIM effmax(19) AS UBYTE
  DIM massa(19) AS UBYTE
  DIM qt(19) AS UBYTE
  DIM rsatt(19) AS UBYTE
  DIM effatt(19) AS BYTE
  DIM progrs(19) AS UBYTE
  x = 1
  DO
    costoini(x) = PEEK (@memo + 116 + x)
    costo(x) = PEEK (@memo + 135 + x)
    costors(x) = PEEK (@memo + 154 + x)
    rsmax(x) = PEEK (@memo + 173 + x)
    effmax(x) = PEEK (@memo + 192 + x)
    massa(x) = PEEK (@memo + 211 + x)
    qt(x) = PEEK (@memo + 230 + x)
    rsatt(x) = PEEK (@memo + 249 + x)
    effatt(x) = PEEK (@memo + 268 + x)
    progrs(x) = PEEK (@memo + 287 + x)
    x = x + 1
  LOOP UNTIL x = 20

  DIM cu(5) AS UBYTE
  x = 1
  DO
    cu(x) = PEEK (@memo + 325 + x)
    x = x + 1
  LOOP UNTIL  x = 6

  DIM rand AS UBYTE

  DIM mate$(19)
  IF naz = 1 THEN
    mate$(1) = "EXPLORER"
    mate$(2) = "RANGER"
    mate$(3) = "SURVEYOR"
    mate$(4) = "MERCURY"
    mate$(5) = "GEMINI"
    mate$(6) = "APOLLO"
    mate$(7) = "XMS-2"
    mate$(8) = "JUPITER"
    mate$(9) = "LM-1"
    mate$(10) = "LEM"
    mate$(13) = "ATLAS"
    mate$(14) = "TITAN"
    mate$(15) = "SATURNO V"
    mate$(16) = "NOVA"
    mate$(17) = "BOOSTER"
  ELSE
    mate$(1) = "SPUTNIK"
    mate$(2) = "KOSMOS"
    mate$(3) = "LUNA"
    mate$(4) = "VOSTOK"
    mate$(5) = "VOSKHOD"
    mate$(6) = "SOYUZ"
    mate$(7) = "SPIRAL"
    mate$(8) = "LK-700"
    mate$(9) = "LK"
    mate$(10) = "LEK"
    mate$(13) = "R-7"
    mate$(14) = "11A511"
    mate$(15) = "N1"
    mate$(16) = "UR-700"
    mate$(17) = "STADIO AUS."
  END IF

  mate$(11) = "M.AGGANCIO"
  mate$(12) = "TUTA AEV"
  mate$(18) = "MOD.SER.A"
  mate$(19) = "MOD.SER.B"

  rigav$ = "                                "
  sce1$ = "\{i7}\{b1} 1 "
  sce0$ = "\{i7}\{b1} 0 "
  ind$ = "(0=INDIETRO)"
  fond$ = "FONDI: "

  ' Variabili usate per le didascalie e i titoli dei menù

  DIM dida AS UINTEGER
  DIM titolo AS UINTEGER

  ' --------------------------------------
  ' ---------- INIZIO PROGRAMMA ----------
  ' --------------------------------------

  ' Menù iniziale:
  ' 1. Satelliti/Sonde
  ' 2. Veicoli C/E
  ' 3. Moduli lunari
  ' 4. Razzi
  ' 5. Altro
  
  ' Satelliti:
  ' 1. Satellite orbita terrestre
  ' 2. Satellite orbita lunare
  ' 3. Sonda lunare
  
  ' Veicoli C/E:
  ' 1. Capsula monoposto
  ' 2. Capsula biposto
  ' 3. Capsula triposto
  ' 4. Navetta
  ' 5. Veicolo lunare
  
  ' Moduli lunari:
  ' 1. Monoposto
  ' 2. Biposto
  
  ' Razzi:
  ' 1. Leggero
  ' 2. Medio
  ' 3. Pesante
  ' 4. Super
  ' 5. Ausiliario
  
  ' Altro:
  ' 1. Modulo servizio A
  ' 2. Modulo servizio B
  ' 3. Tuta AEV
  
  ' Avvia ricerca: costoini(x) deve essere < fondi
  ' Affiancare una squadra di ricerca (1-5, 0 nessuna)?
  ' Ogni squadra di ricerca costa costors(x)
  ' Si può assegnare la ricerca solo una volta per turno
  ' Ogni squadra di ricerca dà 1-6 di effatt(x), totale mai > di rsmax(x)
  ' stru(4)=2 permette un secondo bonus 1-3

  ' All'avvio va direttamente alla scenza perché la dissolvenza è effettuata dal programma di gestione

  GOTO ricercabis

ricerca:

  bip()

  diss()

ricercabis:

  updateSeed()

  scena(0)
  
attesa03:

  PAUSE 0

  IF INKEY$="1" THEN GOTO ricsat
  IF INKEY$="2" THEN GOTO ricvei
  IF INKEY$="3" THEN GOTO ricmod
  IF INKEY$="4" THEN GOTO ricraz
  IF INKEY$="5" THEN GOTO ricalt
  IF INKEY$="0" THEN GOTO main
  
  GOTO attesa03

  ' Ricerca satelliti/sonde
  
ricsat:

  bip()

  diss()

  scena(1)

attesa04:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 51 THEN GOTO attesa04

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ : GOTO avvioricerca

  ' Ricerca veicoli con equipaggio

ricvei:

  bip()

  diss()

  scena(2)

attesa05:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 53 THEN GOTO attesa05

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ + 3: GOTO avvioricerca

  ' Ricerca moduli lunari

ricmod:

  bip()

  diss()

  scena(3)

attesa06:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 50 THEN GOTO attesa06

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ + 8: GOTO avvioricerca

  ' Ricerca razzi
  
ricraz:

  bip()

  diss()

  scena(4)

attesa07:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 53 THEN GOTO attesa07

  IF q = 48 THEN GOTO ricerca

  x = VAL INKEY$ + 12: GOTO avvioricerca

  ' Ricerca altri materiali

ricalt:

  bip()

  diss()

  scena(5)

attesa08:

  PAUSE 0

  q = CODE INKEY$

  IF q < 48 OR q > 52 THEN GOTO attesa08

  IF q = 48 THEN GOTO ricerca

  IF q = 49 THEN x = 12
  IF q = 50 THEN x = 18
  IF q = 51 THEN x = 19
  IF q = 52 THEN x = 11
  
  ' Avvio ricerca materiale

avvioricerca:

  bip()

  ' Se il prototipo è un ML/navetta/veicolo lunare c'è bisogno del laboratorio avanzato

  IF x > 6 AND x < 11 AND stru(1,9) = 0 THEN nostru(): GOTO ricerca

  ' Bonus per ricerca (solo capsule e razzi): se il materiale precedente è già stato ricercato al massimo,
  ' si ottiene un bonus una tantum del 20%

  ' Bonus per ricerca precedente (capsule)

  IF x > 4 AND x < 7 THEN bonusric()

  ' Bonus per ricerca precedente (razzi)

  IF x > 13 AND x < 18 THEN bonusric()

  ' Se il prototipo non è stato ancora ricercato e i fondi sono insufficienti, non è possibile avviare il programma di ricerca
  
  IF costoini(x)+costors(x) > fondi AND progrs(x) = 0 THEN nofondi() : GOTO ricerca
  
  ' Se non è possibile allocare nemmeno un tecnico, idem
  
  IF costors(x) > fondi THEN nofondi() : GOTO ricerca

  pulisci()
  
  PRINT AT 3,1; INK naz; mate$(x)
  
  costoricerca()
  
  ' Se il programma è già in corso di ricerca per questo turno, non ricercarlo di nuovo
  
  IF progrs(x) = 2 THEN POKE UINTEGER indir,@ricincorso: stampa(): premitasto(): GOTO ricerca

  ' Se non si può più andare oltre rsmax(x), torna indietro
  
  IF rsatt(x) = rsmax(x) THEN POKE UINTEGER indir,@ricalmax: stampa(): premitasto(): GOTO ricerca

sceglitecnici:

  cancerig()

  POKE UINTEGER indir,@chieditec: stampa()

  PRINT AT 19,1; ind$

  inp()
  
  IF i = 0 THEN GOTO tornaindietro
  
  IF i > 5 OR i < 1 THEN GOTO sceglitecnici
  
  PRINT AT 18,16; i; AT 19,0; rigav$
  
  ' Calcola il costo totale della ricerca. Se il programma non è stato ancora avviato inserisce anche il costo del prototipo iniziale

  w = costors(x)*i

  IF progrs(x) = 0 THEN w = w + costoini(x)
  
  ' Se il costo totale della ricerca è superiore ai fondi disponibili torna indietro,
  ' altrimenti lo sottrae dai fondi e dichiara il progetto di R&S in corso per quest'anno (progrs(x)=2)
  
  IF w > fondi THEN GOTO sceglitecnici

  ' Il numero di tecnici è caricato in y

  y = i

  ' Se è presente un centro R&S avanzato si ottiene un bonus alla ricerca di +1, come se avessimo un tecnico in più

  IF stru(1,9) = 1 THEN y = y + 1
 
  conferma()

  ' In caso di annullamento torna all'inizio

  IF k = 0 THEN GOTO ricerca
  
  ' Altrimenti sottrae l'importo della ricerca 
  
  fondi = fondi - w

  ' Se è l'inizio di un nuovo programma, costruisce il prototipo 

  IF progrs(x) = 0 THEN qt(x) = qt(x) + 1
  
  ' Il programma è in corso per questo turno
  
  progrs(x) = 2

  ' Calcolo sicurezza R&S: ogni tecnico dà un bonus da 2 a 10. Questo coefficiente viene poi aggiunto alla R&S attuale
  ' fino a che non si arriva al massimo.
  
  n = 1
  DO
    randomBase()
    rand = randomLimit(4)+1
    rsatt(x) = rsatt(x) + rand*2
	n = n + 1
  LOOP UNTIL n > y

  ' Massima % di ricerca per questo programma raggiunta e aumenta il prestigio di 5

  IF rsatt(x) > rsmax(x) THEN rsatt(x) = rsmax(x) : prestigio = prestigio + 5
  
  ' L'efficienza attuale è pari alla percentuale di R&S attuale
  
  effatt(x) = rsatt(x)

finericerca:

  PRINT AT 20,2; INK naz;"R&S ATTUALE: ";rsatt(x);"%"
    
  premitasto()

  GOTO ricerca

tornaindietro:

  IF x < 4 THEN GOTO ricsat
  IF x > 3 AND x < 9 THEN GOTO ricvei
  IF x = 9 OR x = 10 THEN GOTO ricmod
  IF x > 12 AND x < 18 THEN GOTO ricraz
  GOTO ricalt

main:

   bip()

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

  ' Vengono salvate solo le variabili modificate dal programma.

  POKE UINTEGER @memo + 1, fondi
  POKE UINTEGER @memo + 3, prestigio

  x = 1
  DO
    POKE @memo + 230 + x, qt(x)
    POKE @memo + 249 + x, rsatt(x)
    POKE @memo + 268 + x, effatt(x)
    POKE @memo + 287 + x, progrs(x)
    x = x + 1
  LOOP UNTIL x = 20

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------

  ' Ritorna a "_main.bas"

  POKE @segue, 1

  END

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Mostra il messaggio "premi un tasto" e mette il gioco in pausa finché non si preme un tasto

SUB premitasto()

  FLASH 0: PRINT AT 22,0; rigav$; AT 22,8; "\{p3}\{i7}\{b1} PREMI UN TASTO ": INK 0: PAUSE 0

END SUB

  ' nofondi: Stampa l'avviso "fondi insufficienti"

SUB nofondi()

  CLS
  POKE UINTEGER indir,@nofond
  stampa()
  premitasto()

END SUB

  ' nostru: Stampa l'avviso "struttura necessaria"

SUB nostru()

  CLS
  POKE UINTEGER indir,@strunec
  stampa()
  premitasto()

END SUB

  ' pulisci: Pulisce le righe da 2 a 21

SUB pulisci()
  
  n = 2
  DO
    PRINT AT n,0; rigav$
	n = n + 1
  LOOP UNTIL n = 22

END SUB

  ' inp: Inserisce un valore numerico. Il valore è conservato in i

SUB inp()

   v$=""
   cancerig()
   PRINT AT 21,2; "SCELTA: "; "\{f1} "; "\{f0}  "

10 PAUSE 0
   
   IF CODE INKEY$ = 13 THEN GOTO 20
   IF CODE INKEY$ = 12 AND LEN v$ > 0 THEN v$ = v$(TO LEN (v$)-1) :	 GOTO 15
   IF CODE INKEY$ < 48 OR CODE INKEY$ > 57 THEN GOTO 10
   IF LEN v$ < 2 THEN v$ = v$+INKEY$
   
15 PRINT AT 21,10; v$; "\{f1} "; "\{f0} "
   GOTO 10

20 IF v$ = "" THEN GOTO 10

   cancerig()
   i = VAL(v$) 

END SUB

  ' conferma: Conferma/annulla

SUB conferma()

  PRINT AT 21,8; "CONFERMA"; AT 23,8; "ANNULLA"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

attendiconf:

  PAUSE 0

  IF INKEY$ = "1" THEN bip(): LET k = 1: GOTO esci
  IF INKEY$ = "0" THEN LET k = 0: GOTO esci
 
  GOTO attendiconf

esci:

  ' bip()

  cancerig()

END SUB

  ' cancerig: Cancella le ultime tre righe dello schermo

SUB cancerig()

  n = 21
  DO
    PRINT AT n,0; rigav$
    n = n + 1
 LOOP UNTIL n = 24

END SUB

  ' costoricerca: Mostra i costi e la situazione della ricerca

SUB costoricerca()

  POKE UINTEGER indir,@costoric
  stampa()

  PRINT AT 5,18; costoini(x); AT 6,10; rsmax(x);"%"; AT 7,12; effmax(x);"%"; AT 8,14; rsatt(x);"%"; AT 9,16; effatt(x);"%"; AT 10,20; costors(x); AT 13,1; INK naz; fond$; fondi

END SUB

  ' bonusric: Assegna un bonus una tantum all'inizio della ricerca se
  ' il mezzo/l'equipaggiamento precedente è già stato sviluppato al massimo

SUB bonusric()

  q = x-1

  IF rsatt(x) = 0 AND rsatt(q) = rsmax(q) THEN rsatt(x) = 20 : effatt(x) = 20

END SUB

  ' Decomprime l'immagine richiesta con il testo relativo

SUB scena(imm AS UBYTE)

  ' INK 7: CLS

  ' Aggiunge 6 a imm se naz = 2 (URSS)

  IF naz = 2 THEN imm = imm + 6

  IF imm = 0 THEN buffer = @R0A: dida = @tR0: titolo = @titolo0
  IF imm = 1 THEN buffer = @R1A: dida = @tR1A: titolo = @titolo1
  IF imm = 2 THEN buffer = @R2A: dida = @tR2A: titolo = @titolo2
  IF imm = 3 THEN buffer = @R3A: dida = @tR3A: titolo = @titolo3
  IF imm = 4 THEN buffer = @R4A: dida = @tR4A: titolo = @titolo4
  IF imm = 5 THEN buffer = @R5A: dida = @tR5: titolo = @titolo5
  IF imm = 6 THEN buffer = @R0B: dida = @tR0: titolo = @titolo0
  IF imm = 7 THEN buffer = @R1B: dida = @tR1B: titolo = @titolo1
  IF imm = 8 THEN buffer = @R2B: dida = @tR2B: titolo = @titolo2
  IF imm = 9 THEN buffer = @R3B: dida = @tR3B: titolo = @titolo3
  IF imm = 10 THEN buffer = @R4B: dida = @tR4B: titolo = @titolo4
  IF imm = 11 THEN buffer = @R5B: dida = @tR5: titolo = @titolo5

  dzx7AgileRCS(buffer,16384)

  PAPER naz

  POKE UINTEGER indir,titolo : stampa()

  PAPER 7: INK 0

  POKE UINTEGER indir,dida : stampa()

END SUB

  ' Funzioni per il calcolo dei coefficienti pseudo-casuali (Britlion, Patrik Rak)

FUNCTION FASTCALL time() AS ULONG
ASM
  DI
  LD DE,(23674)
  LD D,0
  LD HL,(23672)
  EI
END ASM
END FUNCTION

FUNCTION FASTCALL randomBase AS UBYTE
ASM
random:
  ld  de,$A280   ; xz -> yw
  ld  hl,$C0DE   ; yw -> zt
  ld  (random+1),hl  ; x = y, z = w
  ld  a,l         ; w = w ^ ( w << 3 )
  add a,a
  add a,a
  add a,a
  xor l
  ld  l,a
  ld  a,d         ; t = x ^ (x << 1)
  add a,a
  xor d
  ld  h,a
  rra             ; t = t ^ (t >> 1) ^ w
  xor h
  xor l
  ld  h,e         ; y = z
  ld  l,a         ; w = t
  ld  (random+4),hl
END ASM
END FUNCTION

SUB FASTCALL updateSeed()
REM Updates the random generator seed from the FRAMES system variable.
time()
ASM
  LD A,E
  EX DE,HL
  LD HL,random+2
  XOR (HL)
  AND A
  JR NZ,updateSeedNotZero
  INC A
updateSeedNotZero:
  LD (HL),A
  LD HL,random+4
  LD A,E
  XOR (HL)
  LD (HL),A
  INC HL
  LD A,D
  XOR (HL)
  LD (HL),A
END ASM
END SUB

FUNCTION FASTCALL randomLimit(limit AS UBYTE) AS UBYTE
ASM
  AND A
  RET Z ; Input zero, output zero.
  LD B,A ; Save A

  LD C,255
  randomBinLoop:
  RLA
  JR C, randomBinLoopExit
  RR C
  JR randomBinLoop ; loop back until we find a bit.
  randomBinLoopExit:

  randomBinRedoCall:
  call random
  AND C
  CP B
  RET Z
  JR NC, randomBinRedoCall
END ASM
END FUNCTION


  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

nofond:
ASM
  DEFB 22, 11, 5
  DEFB 18, 1
  DEFM " FONDI INSUFFICIENTI "
  DEFB 255
END ASM

costoric:
ASM
  DEFB 22, 5, 1
  DEFM "COSTO PROTOTIPO:"
  DEFB 13
  DEFM " R&S MAX:"
  DEFB 13
  DEFM " EFFIC.MAX:"
  DEFB 13
  DEFM " R&S ATTUALE:"
  DEFB 13
  DEFM " EFFIC.ATTUALE:"
  DEFB 13
  DEFM " COSTO PER TECNICO:"
  DEFB 255
END ASM

ricincorso:
ASM
  DEFB 22, 16, 9
  DEFB 18, 1
  DEFM " GIa "
  DEFB 191
  DEFM  "CORSO "
  DEFB 255
END ASM

ricalmax:
ASM
  DEFB 22, 16, 6
  DEFB 18, 1
  DEFM " R&S MAX RAGGIUNTA "
  DEFB 255
END ASM

chieditec:
ASM
  DEFB 22, 18, 1
  DEFM "TECNICI? (1-5)"
  DEFB 255
END ASM

strunec:
ASM
  DEFB 22, 11, 5
  DEFB 18, 1
  DEFM " STRUTTURA NECESSARIA "
  DEFB 255
END ASM

titolo0:
ASM
  DEFB 16, 7, 19, 1
  DEFB 22, 1, 6
  DEFM " RICERCA E SVILUPPO "
  DEFB 255
END ASM

titolo1:
ASM
  DEFB 16, 7, 19, 1
  DEFB 22, 1, 7
  DEFM " SATELLITI/SONDA "
  DEFB 255
END ASM

titolo2:
ASM
  DEFB 16, 7, 19, 1
  DEFB 22, 1, 4
  DEFM " VEICOLI CON EQUIPAGGIO "
  DEFB 255
END ASM

titolo3:
ASM
  DEFB 16, 7, 19, 1
  DEFB 22, 1, 8
  DEFM " MODULI LUNARI "
  DEFB 255
END ASM

titolo4:
ASM
  DEFB 16, 7, 19, 1
  DEFB 22, 1, 12
  DEFM " RAZZI "
  DEFB 255
END ASM

titolo5:
ASM
  DEFB 16, 7, 19, 1
  DEFB 22, 1, 12
  DEFM " ALTRO "
  DEFB 255
END ASM

tR0:
ASM
  DEFB 22, 9, 5
  DEFM "SATELLITI/"
  DEFB 22, 9, 17
  DEFM "VEICOLI CON"
  DEFB 22, 10, 7
  DEFM "SONDA"
  DEFB 22, 10, 17
  DEFM "EQUIPAGGIO"
  DEFB 22, 18, 2
  DEFM "MODULI"
  DEFB 22, 19, 2
  DEFM "LUNARI"
  DEFB 22, 18, 13
  DEFM "RAZZI"
  DEFB 22, 18, 23
  DEFM "ALTRO"
  DEFB 22, 21, 6
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR1A:
ASM
  DEFB 22, 9, 2
  DEFM "EXPLORER"
  DEFB 22, 9, 12
  DEFM "RANGER"
  DEFB 22, 9, 22
  DEFM "SURVEYOR"
  DEFB 22, 12, 6
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR1B:
ASM
  DEFB 22, 9, 2
  DEFM "SPUTNIK"
  DEFB 22, 9, 12
  DEFM "KOSMOS"
  DEFB 22, 9, 23
  DEFM "LUNA"
  DEFB 22, 12, 6
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR2A:
ASM
  DEFB 22, 9, 2
  DEFM "MERCURY"
  DEFB 22, 9, 12
  DEFM "GEMINI"
  DEFB 22, 9, 22
  DEFM "APOLLO"
  DEFB 22, 17, 8
  DEFM "XMS-2"
  DEFB 22, 17, 17
  DEFM "JUPITER"
  DEFB 22, 20, 6
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR2B:
ASM
  DEFB 22, 9, 2
  DEFM "VOSTOK"
  DEFB 22, 9, 12
  DEFM "VOSKHOD"
  DEFB 22, 9, 23
  DEFM "SOYUZ"
  DEFB 22, 17, 7
  DEFM "SPIRAL"
  DEFB 22, 17, 17
  DEFM "LK-700"
  DEFB 22, 20, 6
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR3A:
ASM
  DEFB 22, 9, 8
  DEFM "LM-1"
  DEFB 22, 9, 19
  DEFM "LEM"
  DEFB 22, 12, 7
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR3B:
ASM
  DEFB 22, 9, 10
  DEFM "LK"
  DEFB 22, 9, 19
  DEFM "LEK"
  DEFB 22, 12, 7
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR4A:
ASM
  DEFB 22, 3, 5
  DEFM "ATLAS"
  DEFB 22, 5, 5
  DEFM "TITAN"
  DEFB 22, 7, 5
  DEFM "SATURNO V"
  DEFB 22, 9, 5
  DEFM "NOVA"
  DEFB 22, 11, 5
  DEFM "BOOSTER"
  DEFB 22, 14, 5
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR4B:
ASM
  DEFB 22, 3, 5
  DEFM "R-7"
  DEFB 22, 5, 5
  DEFM "11A511"
  DEFB 22, 7, 5
  DEFM "N1"
  DEFB 22, 9, 5
  DEFM "UR-700"
  DEFB 22, 11, 5
  DEFM "STADIO AUS."
  DEFB 22, 14, 5
  DEFM "INDIETRO"
  DEFB 255
END ASM

tR5:
ASM
  DEFB 22, 9, 6
  DEFM "TUTA AEV"
  DEFB 22, 9, 18
  DEFM "MOD.SER.A"
  DEFB 22, 17, 5
  DEFM "MOD.SER.B"
  DEFB 22, 17, 17
  DEFM "MOD.AGGANCIO"
  DEFB 22, 20, 7
  DEFM "INDIETRO"
  DEFB 255
END ASM