  ' Stampa un testo in formato ASM (cambiare valore di DE se necessario)

SUB FASTCALL stampa()
ASM
  
  LD DE,(25040)

STAMPA:
  PUSH DE            ; conserva l'indirizzo del messaggio
  LD A,2             ; parte superiore
  CALL 5633          ; apri il canale
  POP DE             ; riprendi l'indirizzo del messaggio...

STAMPA_MESS:
  LD A,(DE)          ; seleziona il carattere da stampare
  INC DE             ; punta al prossimo carattere
  CP 255             ; 255 = fine del testo
  JR Z, FINE         ; in tal caso, ritorna
  RST 16             ; stampa
  JR STAMPA_MESS     ; prosegui fino alla fine

FINE:
  
END ASM
END SUB

  ' Suono "bip"

SUB FASTCALL bip()
ASM
  PUSH BC
  POP BC
  CALL 37070
END ASM
END SUB

  ' Dissolvenza sinistra-destra

SUB FASTCALL diss()
ASM
  PUSH BC
  POP BC
  CALL 25812
END ASM
END SUB

  ' Decompressore ZX7+RCS "Agile" (Einar Saukas)

' -----------------------------------------------------------------------------
' Decompress (from source to destination address) data that was previously
' compressed using ZX7. This is the fastest version of the integrated RCS+ZX7
' decompressor.
'
' IMPORTANT: Data decompressed directly to the ZX-Spectrum screen must be both
' RCS encoded and ZX7 compressed, everything else must be ZX7 compressed only.
'
' Parameters:
'     src: source address (compressed data)
'     dst: destination address (decompressing)
' -----------------------------------------------------------------------------
sub FASTCALL dzx7AgileRCS(src as UINTEGER, dst as UINTEGER)
    asm
        pop bc          ; RET address
        pop de          ; DE=dst
        push bc         ; restore RET address
 ; #include "dzx7_agileRCS.asm"

    CALL 25990

   end asm
end sub