  #INCLUDE "_intestazione.bas"

  ' ----------------------------------------
  ' ---------- RECUPERO VARIABILI ----------
  ' ----------------------------------------

  DIM x, y, z, n, w, k, i, q AS UBYTE

  DIM nn, qq, zz, temp AS UINTEGER

  DIM pilota AS BYTE

  DIM naz AS UBYTE
  naz = PEEK (@memo)

  DIM fondi AS INTEGER
  fondi = PEEK (UINTEGER, @memo + 1)

  DIM prestigio AS INTEGER
  prestigio = PEEK (UINTEGER, @memo + 3)

  DIM prestprec AS INTEGER
  prestprec = PEEK (UINTEGER, @memo + 5)

  DIM diffpres AS INTEGER
  diffpres = PEEK (UINTEGER, @memo + 7)

  DIM anno AS UBYTE
  anno = PEEK (@memo + 8)

  DIM turno AS UBYTE
  turno = PEEK (@memo + 9)

  DIM modif AS BYTE
  modif = PEEK (@memo + 10)

  ' Descrizione materiale:
  ' Ogni materiale è contraddistinto da un numero, che serve da guida
  ' per tutte le variabili relative a esso.
  
  '  1 - Satellite orbitale terrestre
  '  2 - Satellite orbitale lunare
  '  3 - Sonda lunare
  '  4 - Capsula monoposto
  '  5 - Capsula biposto
  '  6 - Capsula triposto
  '  7 - Mini navetta riutilizzabile
  '  8 - Veicolo lunare
  '  9 - Modulo lunare monoposto  
  ' 10 - Modulo lunare biposto
  ' 11 - Modulo aggancio
  ' 12 - Tuta AEV
  ' 13 - Razzo vettore leggero
  ' 14 - Razzo vettore medio
  ' 15 - Razzo vettore pesante
  ' 16 - Razzo vettore super
  ' 17 - Parte ausiliaria
  ' 18 - Modulo servizio A
  ' 19 - Modulo servizio B

  DIM costoini(19) AS UBYTE
  DIM costo(19) AS UBYTE
  DIM qt(19) AS UBYTE
  DIM effatt(19) AS BYTE
  DIM progrs(19) AS UBYTE
  DIM ordini(19) AS UBYTE
  x = 1
  DO
    costoini(x) = PEEK (@memo + 116 + x)
    costo(x) = PEEK (@memo + 135 + x)
    qt(x) = PEEK (@memo + 230 + x)
    effatt(x) = PEEK (@memo + 268 + x)
    progrs(x) = PEEK (@memo + 287 + x)
    ordini(x) = PEEK (@memo + 306 + x)
    x = x + 1
  LOOP UNTIL x = 20

  DIM totalmis(3) AS UBYTE
  x = 1
  DO
    totalmis(x) = PEEK (@memo + 381 + x)
    x = x + 1
  LOOP UNTIL x = 4

  DIM pm(6) AS UBYTE
  x = 1
  DO
    pm(x) = PEEK (@memo + 400 + x)
    x = x + 1
  LOOP UNTIL x = 7

  DIM punti AS INTEGER
  punti = PEEK (UINTEGER, @memo + 411)

  DIM alt, dur AS FLOAT

  DIM stru(3,9) AS UBYTE
  x = 1
  DO
    stru(1,x) = PEEK (@memo + 10 + x)
    stru(2,x) = PEEK (@memo + 19 + x)
    stru(3,x) = PEEK (@memo + 28 + x)
    x = x + 1
  LOOP UNTIL x = 10

  DIM abi(8,10) AS UBYTE
  x = 1
  DO
    abi(1,x) = PEEK (@memo + 37 + x)
    abi(2,x) = PEEK (@memo + 47 + x)
    abi(3,x) = PEEK (@memo + 57 + x)
    abi(4,x) = PEEK (@memo + 67 + x)
    abi(5,x) = PEEK (@memo + 77 + x)
    abi(6,x) = PEEK (@memo + 87 + x)
    abi(7,x) = PEEK (@memo + 97 + x)
    abi(8,x) = PEEK (@memo + 107 + x)
    x = x + 1
  LOOP UNTIL x = 11

  DIM pilost$(10)
  x = 1
  DO
    pilost$(x) = CHR$(PEEK(@memo + 415 + x))
    x = x + 1
  LOOP UNTIL x = 11

  DIM stag$(4)
  stag$(1) = "SPRING"
  stag$(2) = "SUMMER"
  stag$(3) = "FALL"
  stag$(4) = "WINTER"

  DIM mate$(19)
  IF naz = 1 THEN
    mate$(1) = "EXPLORER"
    mate$(2) = "RANGER"
    mate$(3) = "SURVEYOR"
    mate$(4) = "MERCURY"
    mate$(5) = "GEMINI"
    mate$(6) = "APOLLO"
    mate$(7) = "XMS-2"
    mate$(8) = "JUPITER"
    mate$(9) = "LM-1"
    mate$(10) = "LEM"
    mate$(13) = "ATLAS"
    mate$(14) = "TITAN"
    mate$(15) = "SATURN V"
    mate$(16) = "NOVA"
    mate$(17) = "BOOSTER"
  ELSE
    mate$(1) = "SPUTNIK"
    mate$(2) = "KOSMOS"
    mate$(3) = "LUNA"
    mate$(4) = "VOSTOK"
    mate$(5) = "VOSKHOD"
    mate$(6) = "SOYUZ"
    mate$(7) = "SPIRAL"
    mate$(8) = "LK-700"
    mate$(9) = "LK"
    mate$(10) = "LEK"
    mate$(13) = "R-7"
    mate$(14) = "11A511"
    mate$(15) = "N1"
    mate$(16) = "UR-700"
    mate$(17) = "AUX.STAGE"
  END IF

  mate$(11) = "DOCKING MOD."
  mate$(12) = "EVA SUIT"
  mate$(18) = "SER.MOD.A"
  mate$(19) = "SER.MOD.B"

  DIM pilo$(10)
  IF naz = 1 THEN
    pilo$(1) = "SHEPARD"
    pilo$(2) = "GLENN"
    pilo$(3) = "COOPER"
    pilo$(4) = "SCHIRRA"
    pilo$(5) = "GRISSOM"
    pilo$(6) = "YOUNG"
    pilo$(7) = "COLLINS"
    pilo$(8) = "ARMSTRONG"
    pilo$(9) = "ALDRIN"
    pilo$(10) = "WHITE"
  ELSE
    pilo$(1) = "GAGARIN"
    pilo$(2) = "TITOV"
    pilo$(3) = "LEONOV"
    pilo$(4) = "TERESHKOVA"
    pilo$(5) = "BYKOVSKY"
    pilo$(6) = "BELYAYEV"
    pilo$(7) = "GORBATKO"
    pilo$(8) = "KOMAROV"
    pilo$(9) = "BEREGOVOY"
    pilo$(10) = "POPOVICH"
  END IF

  DIM pimi$(6)
  pimi$(1) = "ARTIFICIAL SATELLITE"
  pimi$(2) = "MANNED EARTH ORB.FLIGHT"
  pimi$(3) = "SPACE WALK"
  pimi$(4) = "SATELLITE IN LUN.ORB."
  pimi$(5) = "PROBE ON THE MOON"
  pimi$(6) = "MANNED LUN.ORB.FLIGHT"

  rigav$ = "                                "
  sce1$ = "\{i7}\{b1} 1 "
  sce0$ = "\{i7}\{b1} 0 "
  ind$ = "(0=BACK)"
  fond$ = "FUNDS: "

  GOTO mainbis

main:

  bip(): diss()

mainbis:

  INK 7

  ' Decomprime la schermata del menù principale

  dzx7AgileRCS(@menuimg,16384)

  BRIGHT 1: PAPER naz

  IF naz = 1 THEN
    PRINT AT 22,0; "\{p1}\{i7}w"; "\{p7}\{i2}x";CHR$ 13;"xx"
    plt$ = " ASTR"
  ELSE
	PRINT AT 22,0; "\{p2}\{i6}y ";CHR$ 13;"  "
    plt$ = " COSM"
  END IF

  ' Stampa le cifre sulle immagini del menù

  POKE UINTEGER indir,@cifre: stampa()

  INK 0: PAPER 7: BRIGHT 0

  ' Stampa le didascalie

  POKE UINTEGER indir,@menuprin: stampa()

  PRINT AT 23,3; stag$(turno);" 19";anno; AT 23,20; fond$;fondi; AT 12,3; plt$

attesa02:

  PAUSE 0

  IF INKEY$ = "1" THEN GOTO info
  IF INKEY$ = "2" THEN GOTO ricerca
  IF INKEY$ = "3" THEN GOTO materiali
  IF INKEY$ = "4" THEN GOTO piloti
  IF INKEY$ = "5" THEN GOTO strutture
  IF INKEY$ = "6" THEN GOTO missioni
  IF INKEY$ = "7" THEN GOTO salvacarica
  IF INKEY$ = "8" THEN GOTO fineturno

  GOTO attesa02

  ' ------------------------------------------
  ' ---------- INFORMAZIONI DI BASE ----------
  ' ------------------------------------------

info:
 
  bip(): diss()

  POKE UINTEGER indir,@infobase: stampa()

  PRINT AT 3,8;fondi; AT 5,11;prestigio; AT 7,14;totalmis(1)+totalmis(2)+totalmis(3); AT 8,12; totalmis(1); AT 9,12; totalmis(2); AT 10,12; totalmis(3); AT 1,9; PAPER naz; "\{i7}\{b1} INFORMATION "

  ' Mostra le pietre miliari. x è la riga a cui stampare e funge anche da variabile di controllo

  x = 13

  n = 1
  DO
    IF pm(n) = 2 THEN PRINT AT x,2; "FIRST ";pimi$(n): x = x+1
    n = n + 1
  LOOP UNTIL n = 7

  ' Se x è invariato significa che non abbiamo conseguito nessuna pietra miliare

  IF x = 13 THEN PRINT AT x,2; "NONE"

  premitasto()
  
  diss(): GOTO mainbis

  ' Esce verso il blocco ricerca

ricerca:

  POKE @segue, 2 : GOTO backup

  ' -------------------------------
  ' ---------- MAGAZZINI ----------
  ' -------------------------------

materiali:
  
  ' Elenco materiali
  ' ----------------

  ' 1-19 mostra elenco dei materiali, quantità e costo unitario
  ' Dividerlo su 2 pagine
  ' SPAZIO per passare alla pagina seguente
  ' ENTER per acquistare un mezzo
  ' 0 per tornare al menù principale

  ' Premendo ENTER si aziona l'input utente
  ' 0 esce dall'input senza acquistare niente

  ' 1 = conferma acquisto
  ' 0 = annulla

  ' Se 1 allora sottrae costo(x) da fondi e aumenta qt(x) di 1
  
  ' BORDER 3: CLS

  bip(): diss()

materiali2:

  CLS : PRINT AT 1,11; PAPER naz; "\{i7}\{b1} STORES "

  POKE UINTEGER indir,@menuordini: stampa()

  lista(3,1,2)

attesa11:

  PAUSE 0

  IF INKEY$="1" THEN bip(): GOTO visuordi
  IF INKEY$="2" THEN bip(): GOTO ordincorso
  IF INKEY$="0" THEN GOTO main

  GOTO attesa11

visuordi:

  CLS

  ' Stampa la lista dei materiali:
  ' Nome/Quantità disponibile/Costo prototipo/Costo per unità/Efficienza attuale

  PRINT INK naz; AT 0,1; fond$; fondi; AT 0,15;"QNT"; AT 0,19; "CPR"; AT 0,23; "CUN"; AT 0,28; "EFF"

  n = 1
  DO
    PRINT AT n,1; n; "."; mate$(n); AT n,16;qt(n); AT n,20; costoini(n); AT n,24; costo(n); AT n,28; effatt(n);"%"
    n = n + 1
  LOOP UNTIL n = 20

  PRINT AT 21,8; "ORDER"; AT 23,8; "BACK"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

attesa09:

  PAUSE 0

  IF INKEY$ = "1" THEN GOTO ordina
  IF INKEY$ = "0" THEN bip(): GOTO materiali2

  GOTO attesa09

ordina:

  bip()

  PRINT AT 20,1;ind$

  inp()
  
  IF i = 0 THEN GOTO visuordi

  ' Inserimento codice non valido

  IF i < 1 OR i > 19 THEN GOTO ordina

  ' Se progrs(i) = 0 il materiale non è stato ancora ricercato, quindi non si può acquistare

  IF progrs(i) = 0 THEN CLS: POKE UINTEGER indir,@nonavviato: stampa(): premitasto(): GOTO visuordi

  ' Stampa un carattere ">" accanto all'oggetto ordinato
  
  PRINT AT i,0; PAPER naz; "\{i7}\{b1}>"

  ' Chiede conferma dell'ordine

  PRINT AT 21,0; rigav$: conferma()

  ' Annullamento ordine

  IF k = 0 THEN GOTO visuordi

  ' Fondi insufficienti

  IF costo(i) > fondi THEN nofondi() : GOTO visuordi

  ' ordine eseguito

  fondi = fondi - costo(i): ordini(i) = ordini(i) + 1

  ' Visualizza gli eventuali ordini in corso

ordincorso:

  CLS

  k = 3

  n = 1
  DO
    IF ordini(n) <> 0 THEN PRINT AT k,1; mate$(n); AT k,15; ordini(n): k = k + 1
	n = n + 1
  LOOP UNTIL n = 20

  ' Se k rimane invariato non ci sono ordini in corso

  IF k = 3 THEN POKE UINTEGER indir,@nessunord: stampa(): GOTO escidaordini

  PRINT AT 1,8; PAPER naz; "\{i7}\{b1} ONGOING ORDERS "

escidaordini:

  premitasto()

  GOTO materiali2

  ' --------------------------------------
  ' ---------- GESTIONE PILOTI -----------
  ' --------------------------------------

piloti:

  bip(): diss()

pilotibis:

  CLS

  PRINT AT 1,10; PAPER naz; INK 7; BRIGHT 1; plt$+"ONAUTS "

  ' Stampa la lista delle opzioni

  POKE UINTEGER indir,@menupilo: stampa()

  x = 3
  y = 1
  z = 3

  k = 1
  DO
    PRINT at x,y; PAPER naz; INK 7; BRIGHT 1; " ";k;" "
	x = x + 2
	k = k + 1
  LOOP UNTIL k > z

  PRINT AT x+1,y+4; "BACK"; AT x+1,y; PAPER naz; "\{i7}\{b1} 0 "

attesa10:

  PAUSE 0

  IF INKEY$="1" THEN GOTO reclutamento
  IF INKEY$="2" THEN bip(): GOTO addestramento
  IF INKEY$="3" THEN bip(): GOTO elencopiloti
  IF INKEY$="0" THEN GOTO main

  GOTO attesa10

reclutamento:

  bip()
  CLS

  ' verifica se ci sono ancora piloti da reclutare
  
  k = 0
  
  n = 1
  DO
    IF pilost$(n) = "N" THEN k = k + 1
	n = n + 1
  LOOP UNTIL n = 11
  
  ' Non ci sono piloti da reclutare
  
  IF k = 0 THEN nopiloti(): GOTO pilotibis

  ' Fondi insufficienti

  IF fondi < 25 THEN nofondi(): GOTO pilotibis

  ' Mostra l'elenco dei piloti se almeno il primo gruppo è stato reclutato
  
  IF pilost$(1) <> "N" THEN elenpilo()

  ' Chiede se si vuole reclutare un gruppo di 5 piloti

  PRINT AT 18,10; plt$; AT 16,1; INK naz; fond$;fondi

  POKE UINTEGER indir,@reclupilo: stampa()

  PRINT AT 21,8; "CONFIRM"; AT 23,8; "CANCEL"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

  conferma()

  cancerig()

  IF k = 0 THEN GOTO pilotibis
  
  ' Deduce i fondi
  
  fondi = fondi - 25
  
  ' Segna i piloti come disponibili a gruppi di 5, controllando i nn. 1, 6 e 11
  
  IF pilost$(1) = "N" THEN w = 1 : GOTO recluta
  IF pilost$(6) = "N" THEN w = 6

recluta:
  
  ' Recluta il primo pilota libero e i 4 successivi nell'elenco
  
  n = w
  DO
    pilost$(n) = "A"
	n = n + 1
  LOOP UNTIL n = w + 5
  
  ' Mostra il nuovo elenco dei piloti

  elenpilo(): premitasto(): GOTO pilotibis

addestramento:

  ' Verifica se ci sono piloti disponibili
  
  k = 0
  
  n = 1
  DO
    IF pilost$(n) = "A" THEN k = k + 1
    n = n + 1
  LOOP UNTIL n = 11

  IF k = 0 THEN
    CLS
    POKE UINTEGER indir,@nondisp
    stampa()
    premitasto()
    GOTO pilotibis
  END IF

  ' Verifica se ci sono abbastanza fondi

  IF fondi < 5 THEN nofondi(): GOTO pilotibis

  elenpilo()

  PRINT AT 16,0; plt$; AT 14,1; INK naz; fond$; fondi
  
  POKE UINTEGER indir,@qualepilo: stampa()

chepilota:

  inp()

  ' Numero non valido

  IF i > 10 THEN GOTO chepilota

  ' Torna indietro

  IF i = 0 THEN GOTO pilotibis

  ' Pilota non disponibile

  IF pilost$(i) <> "A" THEN 
    POKE UINTEGER indir,@pilono
    stampa()
    PRINT AT 21,4; FLASH 1; plt$
    premitasto()
    GOTO chepilota
  END IF

  ' Il numero del pilota è caricato in x

  x = i

cheadd:

  CLS

  POKE UINTEGER indir,@abiaddes: stampa()

  PRINT AT 19,1; ind$; AT 0,1; INK naz; pilo$(x)

  ' Mostra il ritratto del pilota

  pilota = x - 1

  ritratto()

cheadd2:

  inp()

  ' Numero non valido

  IF i > 5 THEN GOTO cheadd2

  ' Torna indietro

  IF i = 0 THEN GOTO addestramento

  ' Addestramento non disponibile per mancanza della struttura

  IF i < 4 AND stru(1,4) <> 1 THEN GOTO noaddavanz
  IF i > 3 AND stru(1,5) <> 1 THEN GOTO noaddavanz

  ' L'abilità da addestrare è caricata in abi(7, pilota)

  abi(7,x) = i

  ' Se l'abilità è già al massimo torna indietro

  IF abi(i,x) = 9 THEN POKE UINTEGER indir,@abimax: stampa(): premitasto: GOTO cheadd2

  ' Il pilota viene indicato come "in addestramento"

  pilost$(x) = "T"

  ' Sottrae 5 dai fondi

  fondi = fondi - 5

  ' Numero di turni per l'addestramento (6, pilota): 3 = normale ; 5 = avanzato

  IF i < 4 THEN
    abi(6,x) = 3
  ELSE
    abi(6,x) = 5
  END IF

  premitasto()

  GOTO addestramento

elencopiloti:

  elenpilo()

  ' Non ripete la pausa se viene da nopiloti() (k = 255)

  IF k <> 255 THEN premitasto()

  GOTO pilotibis

  ' Struttura necessaria (addestramento avanzato)

noaddavanz:

  CLS : POKE UINTEGER indir,@strunec : stampa()

  premitasto()

  GOTO cheadd

  ' ----------------------------------------
  ' ---------- GESTIONE STRUTTURE ----------
  ' ----------------------------------------

strutture:

  POKE @segue, 4 : GOTO backup

  ' ---------------------------------------------
  ' ---------- PIANIFICAZIONE MISSIONI ----------
  ' ---------------------------------------------

missioni:

  POKE @segue, 3 : GOTO backup

  ' ---------------------------------------------
  ' ---------- SALVATAGGIO/CARICAMENTO ----------
  ' ---------------------------------------------

salvacarica:

  bip()

  #INCLUDE "_salvacar.bas"

fineturno: 

  ' Controlla se c'è almeno una missione programmata verificando se almeno una rampa è occupata
  ' (stru(1,n)=2)

  k = 0
  n = 1
  DO
    IF stru(1,n) = 2 THEN k = 1
    n = n + 1
  LOOP UNTIL n = 4

  IF k = 1 THEN
    POKE @segue, 5
  ELSE
    POKE @segue, 6
  END IF

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

  ' Vengono salvate solo le variabili modificate dal programma

backup:

  POKE UINTEGER @memo + 1, fondi
  POKE UINTEGER @memo + 3, prestigio
  POKE UINTEGER @memo + 5, prestprec
  POKE UINTEGER @memo + 7, diffpres
  POKE @memo + 8, anno
  POKE @memo + 9, turno
  POKE @memo + 10, modif

  x = 1
  DO
    POKE @memo + 37 + x, abi(1,x)
    POKE @memo + 47 + x, abi(2,x)
    POKE @memo + 57 + x, abi(3,x)
    POKE @memo + 67 + x, abi(4,x)
    POKE @memo + 77 + x, abi(5,x)
    POKE @memo + 87 + x, abi(6,x)
    POKE @memo + 97 + x, abi(7,x)
    POKE @memo + 107 + x, abi(8,x)
    x = x + 1
  LOOP UNTIL x = 11

  x = 1
  DO
    POKE @memo + 230 + x, qt(x)
    POKE @memo + 287 + x, progrs(x)
    POKE @memo + 306 + x, ordini(x)
    x = x + 1
  LOOP UNTIL x = 20

  x = 1
  DO
    POKE @memo + 415 + x, CODE pilost$(x)
    x = x + 1
  LOOP UNTIL x = 11

  POKE UINTEGER @memo + 411, punti

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------

fineprog:

  bip()

  END

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Mostra il messaggio "premi un tasto" e mette il gioco in pausa finché non si preme un tasto

SUB premitasto()

  FLASH 0: PRINT AT 22,8; "\{p3}\{i7}\{b1} PRESS ANY KEY ": INK 0: PAUSE 0
  bip()

END SUB

  ' Stampa una lista di numeri per le opzioni.
  ' Parametri: lin,col = coordinate iniziali; pun = numero di punti

SUB lista(lin AS UBYTE, col AS UBYTE, pun AS UBYTE)

  n = 1
  DO
    PRINT at lin,col; PAPER naz; BRIGHT 1; INK 7; " ";n;" "
	lin = lin + 2
	n = n + 1
  LOOP UNTIL n > pun

  PRINT AT lin+1,col+4; "BACK"; AT lin+1,col; PAPER naz; "\{i7}\{b1} 0 "

END SUB

  ' Inserisce un valore numerico. Il valore è conservato in i

SUB inp()

   v$=""
   cancerig()
   PRINT AT 21,2; "CHOICE: "; "\{f1} "; "\{f0}  "

10 PAUSE 0
   
   IF CODE INKEY$ = 13 THEN GOTO 20
   IF CODE INKEY$ = 12 AND LEN v$ > 0 THEN v$ = v$(TO LEN (v$)-1) :	 GOTO 15
   IF CODE INKEY$ < 48 OR CODE INKEY$ > 57 THEN GOTO 10
   IF LEN v$ < 2 THEN v$ = v$+INKEY$
   
15 PRINT AT 21,10; v$; "\{f1} "; "\{f0} "
   GOTO 10

20 IF v$ = "" THEN GOTO 10

   cancerig()
   i = VAL(v$) 

END SUB

  ' Conferma/annulla

SUB conferma()

  PRINT AT 21,8; "CONFIRM"; AT 23,8; "CANCEL"; AT 21,4; PAPER naz; sce1$; AT 23,4; sce0$

attendiconf:

  PAUSE 0

  IF INKEY$ = "1" THEN LET k = 1: GOTO esci
  IF INKEY$ = "0" THEN LET k = 0: GOTO esci
 
  GOTO attendiconf

esci:

  bip()

  cancerig()

END SUB

  ' Cancella le ultime tre righe dello schermo

SUB cancerig()

  n = 21
  DO
    PRINT AT n,0; rigav$
    n = n + 1
 LOOP UNTIL n = 24

END SUB

  ' Stampa l'avviso "fondi insufficienti"

SUB nofondi()

  CLS
  POKE UINTEGER indir,@nofond
  stampa()
  premitasto()

END SUB

  ' Stampa l'avviso "non ci sono piloti"

SUB nopiloti()

  CLS
  POKE UINTEGER indir,@noncisono
  stampa()
  PRINT AT 11,16; FLASH 1; plt$
  k = 255
  premitasto()
  cancerig()

END SUB

  ' Stampa l'elenco dei piloti

SUB elenpilo()

  CLS
  
  k = 2
  n = 1

  DO 
    IF pilost$(n) = "N" OR pilost$(n) = "X" THEN GOTO nessuno
    PRINT AT k,1; n; "."; pilo$(n); AT k,15; abi(1,n); AT k,18; abi(2,n); AT k,21; abi(3,n); AT k,24; abi(4,n); AT k,27; abi(5,n); AT k,30; pilost$(n)
    k = k + 1
nessuno:
    n = n + 1
  LOOP UNTIL n = 11

  ' Se k rimane invariato non ci sono piloti

  IF k = 2 THEN CLS: nopiloti(): GOTO esci2

  PRINT INK naz; AT 0,15;"BP EV DO AP EN ST"

esci2:

END SUB

  ' Mostra i ritratti dei piloti

SUB ritratto()

  ' Aumenta pilota di 10 se URSS (naz = 2)

  IF naz = 2 THEN pilota = pilota + 10

  ' Crea lo sfondo

  n = 0
  DO
    PRINT AT n,18; "\{b1}      "
    n = n + 1
  LOOP UNTIL n = 8

  ' Richiama i pixel

  qq = 16384+18

  ' Controlla quale ritratto dobbiamo mostrare (0 = Shepard)

  temp = @ritr + 384*pilota

PIXEL:
 
  zz = qq
  FOR m = 0 TO 7
    FOR nn = zz TO zz + 5
      POKE nn, PEEK temp
      temp = temp + 1
    NEXT nn
    zz = zz + 256
  NEXT m

  qq = qq + 32

  ' 16608 = 16384 + 32*8 (8 righe)

  IF qq <= 16608+18 THEN GOTO PIXEL

END SUB

  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

menuprin:
ASM
  DEFB 22, 5, 3
  DEFM "INFO"
  DEFB 22, 5, 14
  DEFM "R&D"
  DEFB 22, 5, 22
  DEFM "STORES"
  DEFB 22, 12, 8
  DEFM "ONAUTS"
  DEFB 22, 12, 18
  DEFM "FACILITIES"
  DEFB 22, 19, 1
  DEFM "MISSIONS  SAVE/LOAD  END TURN"
  DEFB 255
END ASM

cifre:
ASM
  DEFB 22, 0, 8
  DEFM "1"
  DEFB 22, 0, 18
  DEFM "2"
  DEFB 22, 0, 28
  DEFM "3"
  DEFB 22, 7, 11
  DEFM "4"
  DEFB 22, 7, 25
  DEFM "5"
  DEFB 22, 14, 8
  DEFM "6"
  DEFB 22, 14, 18
  DEFM "7"
  DEFB 22, 14, 28
  DEFM "8"
  DEFB 255
END ASM

salvacar:
ASM
  DEFB 22, 3, 4
  DEFM 248
  DEFB 22, 5, 5
  DEFM 239
  DEFB 255
END ASM

infobase:
ASM
  DEFB 22, 3, 1
  DEFM "FUNDS:"
  DEFB 22, 5, 1
  DEFM "PRESTIGE:"
  DEFB 22, 7, 1
  DEFM "TOTAL MISS.:"
  DEFB 22, 8, 2
  DEFM "ACCOMPL.:"
  DEFB 22, 9, 2
  DEFM "PARTIAL:"
  DEFB 22, 10, 2
  DEFM "FAILED:"
  DEFB 22, 12, 1
  DEFM "MILESTONES:"
  DEFB 255
END ASM

menuordini:
ASM
  DEFB 22, 3, 5
  DEFM "VISUALIZE/ORDER"
  DEFB 22, 5, 5
  DEFM "CURRENT ORDERS"
  DEFB 255
END ASM

nessunord:
ASM
  DEFB 22, 11, 6
  DEFB 18, 1
  DEFM " NO ONGOING ORDERS "
  DEFB 255
END ASM

nonavviato:
ASM
  DEFB 22, 11, 5
  DEFB 18, 1
  DEFM " PROJECT "
  DEFB 195
  DEFM "STARTED "
  DEFB 255
END ASM

nofond:
ASM
  DEFB 22, 11, 7
  DEFB 18, 1
  DEFB 32, 195
  DEFM "ENOUGH FUNDS "
  DEFB 255
END ASM

menupilo:
ASM
  DEFB 22, 3, 5
  DEFM "RECRUITING"
  DEFB 22, 5, 5
  DEFM "TRAINING"
  DEFB 22, 7, 4
  DEFB 240
  DEFB 255
END ASM

abiaddes:
ASM
  DEFB 22, 2, 1
  DEFM  "1.BASE PILOTING"
  DEFB 22, 4, 1
  DEFM "2.EVA"
  DEFB 22, 6, 1
  DEFM "3.DOCKING"
  DEFB 22, 8, 1
  DEFM "4.ADV.PILOTING"
  DEFB 22, 10, 1
  DEFM "5.ENDURANCE"
  DEFB 22, 18, 1
  DEFM "ABILITY?"
  DEFB 255
END ASM

reclupilo:
ASM
  DEFB 22, 18, 1
  DEFM "RECRUIT 5"
  DEFB 22, 18, 15
  DEFM "ONAUTS?"
  DEFB 13
  DEFM " COST: 25"
  DEFB 255
END ASM

qualepilo:
ASM
  DEFB 22, 16, 5
  DEFM "ONAUT TO TRAIN?"
  DEFB 13
  DEFM " (0 = BACK)"
  DEFB 22, 19, 1
  DEFM "COST: 5"
  DEFB 255
END ASM

strunec:
ASM
  DEFB 22, 11, 7
  DEFB 18, 1
  DEFM " FACILITY NEEDED "
  DEFB 255
END ASM

nondisp:
ASM
  DEFB 22, 11, 5
  DEFB 18, 1
  DEFM " NOBODY IS AVAILABLE "
  DEFB 255
END ASM

pilono:
ASM
  DEFB 22, 21, 9
  DEFB 18, 1
  DEFM "ONAUT UNAVAILABLE "
  DEFB 255
END ASM

noncisono:
ASM
  DEFB 22, 11, 3
  DEFB 18, 1
  DEFM " THERE ARE NO"
  DEFB 22, 11, 21
  DEFM "ONAUTS "
  DEFB 255
END ASM

abimax:
ASM
  DEFB 22, 21, 4
  DEFB 18, 0
  DEFM " ABILITY ALREADY AT MAX. LEVEL "
  DEFB 255
END ASM

  ' ------------------------------
  ' ---------- IMMAGINI ----------
  ' ------------------------------

  ' Ritratti (non compressi)

ritr:
ASM
  INCBIN "ritratti.bin"
END ASM

menuimg:
ASM
  INCBIN "Menuprin-ZX7.bin"              ; 1321
END ASM