  ' AD LUNAM PLUS
  ' di Alessandro Grussu, 2020

  #INCLUDE "_intestazione.bas"

  CONST adfont AS UINTEGER = 25044

  ' Carica in memoria il set di caratteri personalizzato

  POKE UINTEGER 23606,@adfont-256

  ' Disabilita ripetizione tasti

  POKE 23561,0

  BORDER 7: PAPER 7: INK 0: BRIGHT 0: CLS

  ' Controlla se stiamo arrivando da una vittoria o da una sconfitta e dirige il flusso di conseguenza

  DIM x AS UBYTE

  x = PEEK(@segue)
  IF x = 8 THEN GOTO mostrapunti

  ' Mostra numero di versione

  POKE UINTEGER indir,@numver: stampa()

  PAUSE 200

adlunam:

  INK 7: CLS

  #INCLUDE "_defvarb.bas"

  ' Status del pilota
  ' -----------------
  ' N : Non arruolato
  ' D : Disponibile
  ' A : In addestramento
  ' M : In missione
  ' I : Infortunato/ammalato
  ' X : Deceduto

  DIM pilost$(10)

  ' Inizializzazione variabili

  anno = 56
  turno = 1
  punti = 0
  ia = 0

  FOR n = 1 TO 8
    FOR q = 1 TO 10
      abi(n,q) = 0
    NEXT q
  NEXT n

  FOR n = 1 TO 3
    totalmis(n) = 0
  NEXT n

  n = 1
  DO
    pm(n) = 0
	n = n + 1
  LOOP UNTIL n = 7

  n = 1
  DO
    pilost$(n) = "N"
	n = n + 1
  LOOP UNTIL n = 11

  DIM stru(3,9) AS UBYTE
  stru = struCopia

  ' Azzera i parametri della missione
  
  i = 1
  DO
  n = 1
  DO
    mpr(n) = 0
	miss(n,i) = 0
    n = n + 1
  LOOP UNTIL n = 17
    i = i + 1
  LOOP UNTIL i = 4

  somma = 0

  ' ------------------------------------------
  ' ---------- SCELTA DELLA NAZIONE ----------
  ' ------------------------------------------

sceltanaz:

  dzx7AgileRCS(@schermonaz,16384)

  POKE UINTEGER indir,@nazione: stampa()
  
attesa01:

  PAUSE 0

  IF INKEY$="1" THEN naz = 1: POKE UINTEGER indir,@evidusa: RESTORE datausa: GOTO defvars
  IF INKEY$="2" THEN naz = 2: POKE UINTEGER indir,@evidurss: RESTORE dataurss: GOTO defvars
  
  GOTO attesa01

  ' ------------------------------------------------------
  ' ---------- DEFINIZIONE VARIABILI SPECIFICHE ----------
  ' ------------------------------------------------------

defvars:

  ' Evidenzia il nome della nazione scelta

  stampa()

  ' Memorizza il valore di naz per l'esecuzione dell'inno

  POKE @memo, naz

  ' Caratteristiche di veicoli ed equipaggiamenti

  n = 1
  DO
    READ costoini(n),costo(n),costors(n),rsmax(n),effmax(n),massa(n),qt(n),rsatt(n),effatt(n),progrs(n)
    n = n + 1
  LOOP UNTIL n = 20

  ' Carico utile
  ' ------------
  ' cu(1) = razzo leggero (13)
  ' cu(2) = razzo medio (14)
  ' cu(3) = razzo pesante (15)
  ' cu(4) = razzo super (16)
  ' cu(5) = booster (17)
  ' Es. il CU di un razzo medio potenziato è cu(2)+cu(5)

  n = 1
  DO
    READ cu(n)
    n = n + 1
  LOOP UNTIL n = 6

  inno()

  ' ----------------------------------------
  ' ---------- SCELTA DEL LIVELLO ----------
  ' ----------------------------------------

  INK 7

  n = 3
  DO
    PRINT AT n,0; "                                "
	n = n + 1
  LOOP UNTIL n = 18

  IF naz = 1 THEN
    buffer = @diffusa
  ELSE
    buffer = @diffurss
  END IF

  dzx7AgileRCS(buffer,16384)

  POKE UINTEGER indir,@diff: stampa()

attesa0:

  PAUSE 0

  IF INKEY$="1" THEN fondi = 170: prestigio = 105: prestprec = 105: cf = 1.3: modif = 0: pen = 4: GOTO backup
  IF INKEY$="2" THEN fondi = 135: prestigio = 90: prestprec = 90: cf = 1.2: modif = 1: pen = 6: GOTO backup
  IF INKEY$="3" THEN fondi = 100: prestigio = 75: prestprec = 75: cf = 1.1: modif = 2: pen = 8: GOTO backup

  GOTO attesa0

  ' -------------------------------------------
  ' ---------- SALVATAGGIO VARIABILI ----------
  ' -------------------------------------------

  ' Il programma di inizializzazione salva ogni volta tutte le variabili, perché alcune di esse sono
  ' state azzerate o riportate al valore iniziale dopo la fine di una partita (es. abi, miss, pm)

backup:

  POKE UINTEGER @memo + 1, fondi
  POKE UINTEGER @memo + 3, prestigio
  POKE UINTEGER @memo + 5, prestprec
  POKE UINTEGER @memo + 7, diffpres
  POKE @memo + 8, anno
  POKE @memo + 9, turno
  POKE @memo + 10, modif

  x = 1
  DO
    POKE @memo + 10 + x, stru(1,x)
    POKE @memo + 19 + x, stru(2,x)
    POKE @memo + 28 + x, stru(3,x)
    x = x + 1
  LOOP UNTIL x = 10

  x = 1
  DO
    POKE @memo + 37 + x, abi(1,x)
    POKE @memo + 47 + x, abi(2,x)
    POKE @memo + 57 + x, abi(3,x)
    POKE @memo + 67 + x, abi(4,x)
    POKE @memo + 77 + x, abi(5,x)
    POKE @memo + 87 + x, abi(6,x)
    POKE @memo + 97 + x, abi(7,x)
    POKE @memo + 107 + x, abi(8,x)
    x = x + 1
  LOOP UNTIL x = 11

  x = 1
  DO
    POKE @memo + 116 + x, costoini(x)
    POKE @memo + 135 + x, costo(x)
    POKE @memo + 154 + x, costors(x)
    POKE @memo + 173 + x, rsmax(x)
    POKE @memo + 192 + x, effmax(x)
    POKE @memo + 211 + x, massa(x)
    POKE @memo + 230 + x, qt(x)
    POKE @memo + 249 + x, rsatt(x)
    POKE @memo + 268 + x, effatt(x)
    POKE @memo + 287 + x, progrs(x)
    POKE @memo + 306 + x, ordini(x)
    x = x + 1
  LOOP UNTIL x = 20

  x = 1
  DO
    POKE @memo + 325 + x, cu(x)
    x = x + 1
  LOOP UNTIL x = 6

  x = 1
  DO
    POKE @memo + 330 + x, miss(1,x)
    POKE @memo + 333 + x, miss(2,x)
    POKE @memo + 336 + x, miss(3,x)
    POKE @memo + 339 + x, miss(4,x)
    POKE @memo + 342 + x, miss(5,x)
    POKE @memo + 345 + x, miss(6,x)
    POKE @memo + 348 + x, miss(7,x)
    POKE @memo + 351 + x, miss(8,x)
    POKE @memo + 354 + x, miss(9,x)
    POKE @memo + 357 + x, miss(10,x)
    POKE @memo + 360 + x, miss(11,x)
    POKE @memo + 363 + x, miss(12,x)
    POKE @memo + 366 + x, miss(13,x)
    POKE @memo + 369 + x, miss(14,x)
    POKE @memo + 372 + x, miss(15,x)
    POKE @memo + 375 + x, miss(16,x)
    POKE @memo + 378 + x, effmis(x)
    POKE @memo + 381 + x, totalmis(x)
    x = x + 1
  LOOP UNTIL x = 4

  x = 1
  DO
    POKE @memo + 384 + x, mpr(x)
    x = x + 1
  LOOP UNTIL x = 17

  x = 1
  DO
    POKE @memo + 400 + x, pm(x)
    x = x + 1
  LOOP UNTIL x = 7

  POKE @memo + 407, bonuspre
  POKE UINTEGER @memo + 408, somma
  POKE @memo + 410, bonabi
  POKE UINTEGER @memo + 411, punti
  POKE UINTEGER @memo + 413, ia
  POKE @memo + 415, pen
 
  x = 1
  DO
    POKE @memo + 415 + x, CODE pilost$(x)
    x = x + 1
  LOOP UNTIL x = 11

  cfCopia = cf

  ' ------------------------------------
  ' ---------- FINE PROGRAMMA ----------
  ' ------------------------------------

  POKE @segue,1

  END

  ' -------------------------------
  ' ---------- PUNTEGGIO ----------
  ' -------------------------------

  ' Il punteggio si calcola come segue:
  ' 30 per missione riuscita (il doppio se pietra miliare)
  ' 15 per missione parziale
  ' -10 per pilota morto

mostrapunti:

  naz = PEEK(@memo)

  ' Recupera i dati per il calcolo del punteggio

  prestigio = PEEK(UINTEGER, @memo + 3)

  x = 1
  DO
    totalmis(x) = PEEK(@memo + 381 + x)
    x = x + 1
  LOOP UNTIL x = 4

  punti = prestigio + 30*totalmis(1) + 15*totalmis(2)

  x = 1
  DO
    pilost$(x) = CHR$(PEEK(@memo + 415 + x))
    IF pilost$(n) = "X" THEN punti = punti - 10
    x = x + 1
  LOOP UNTIL x = 11

  x = 1
  DO
    pm(x) = PEEK (@memo + 400 + x)
    IF pm(x) = 1 THEN punti = punti + 30
    x = x + 1
  LOOP UNTIL x = 7

  IF punti < 0 THEN punti = 0

  ' Mostra il punteggio e le relative scritte

  INK 0

  POKE UINTEGER indir,@puntfin
  stampa()

  PRINT AT 11,18; punti

  ' Torna all'inizio

  POKE @segue,0

  PAUSE 100

  PAUSE 0 : GOTO adlunam

  ' ------------------------------------
  ' ---------- DATI SPECIFICI ----------
  ' ------------------------------------

datausa:

  ' costoini(n),costo(n),costors(n),rsmax(n),effmax(n),massa(n),qt(n),rsatt(n),effatt(n),progrs(n)

  DATA 6,1,1,95,98,2,0,0,0,0
  DATA 24,5,3,90,93,7,0,0,0,0
  DATA 30,7,4,85,88,12,0,0,0,0
  DATA 20,3,1,82,92,5,0,0,0,0
  DATA 30,7,2,86,94,12,0,0,0,0
  DATA 40,14,5,89,94,17,0,0,0,0
  DATA 55,30,7,91,94,14,0,0,0,0
  ' DATA 65,30,8,89,94,46,0,0,0,0
  DATA 80,42,9,88,94,46,0,0,0,0
  DATA 42,9,4,89,94,11,0,0,0,0
  DATA 30,8,2,92,95,15,0,0,0,0
  DATA 18,3,2,92,94,3,0,0,0,0
  DATA 18,0,1,91,94,0,0,0,0,0
  DATA 26,3,2,87,98,0,0,0,0,0
  DATA 60,12,4,91,98,0,0,0,0,0
  ' DATA 90,18,6,95,98,0,0,0,0,0
  DATA 90,30,7,95,98,0,0,0,0,0
  ' DATA 150,30,8,94,98,0,0,0,0,0
  DATA 165,58,10,94,98,0,0,0,0,0
  DATA 18,4,2,85,98,0,0,0,0,0
  DATA 12,3,1,92,97,3,0,0,0,0
  DATA 18,6,2,94,97,7,0,0,0,0

  ' cu(n)

  DATA 5,14,40,52,10

dataurss:

  ' costoini(n),costo(n),costors(n),rsmax(n),effmax(n),massa(n),qt(n),rsatt(n),effatt(n),progrs(n)

  DATA 6,1,1,95,98,4,0,0,0,0
  DATA 20,3,3,88,93,10,0,0,0,0
  DATA 26,6,4,85,88,15,0,0,0,0
  DATA 18,3,1,81,92,7,0,0,0,0
  DATA 24,6,2,80,92,14,0,0,0,0
  DATA 36,12,5,86,94,19,0,0,0,0
  ' DATA 65,30,7,87,94,18,0,0,0,0
  DATA 60,28,7,89,94,18,0,0,0,0
  ' DATA 60,30,9,89,94,53,0,0,0,0
  DATA 78,40,9,87,94,53,0,0,0,0
  DATA 48,9,4,90,93,15,0,0,0,0
  DATA 35,8,2,91,94,17,0,0,0,0
  DATA 15,3,2,89,93,3,0,0,0,0
  DATA 18,0,1,91,94,0,0,0,0,0
  DATA 20,3,2,85,98,0,0,0,0,0
  ' DATA 60,12,4,90,98,0,0,0,0,0
  DATA 52,12,4,94,98,0,0,0,0,0
  ' DATA 84,18,7,93,98,0,0,0,0,0
  DATA 85,26,7,93,98,0,0,0,0,0
  ' DATA 150,30,8,94,98,0,0,0,0,0
  DATA 158,50,10,94,98,0,0,0,0,0
  DATA 15,4,2,87,98,0,0,0,0,0
  DATA 12,3,1,91,95,5,0,0,0,0
  DATA 18,6,2,91,95,7,0,0,0,0

  ' cu(n)

  DATA 8,22,45,58,14

  ' ------------------------------------
  ' ---------- SOTTOPROGRAMMI ----------
  ' ------------------------------------

  #INCLUDE "_comuni.bas"

  ' Inni nazionali

SUB FASTCALL inno()
ASM

  PUSH BC
  POP BC
  CALL 37114

END ASM
END SUB

  ' ------------------------------
  ' ---------- STRINGHE ----------
  ' ------------------------------

numver:
ASM
  DEFB 22, 11, 10
  DEFM "VERSIoN 1.1"
  DEFB 255
END ASM

nazione:
ASM
  DEFB 16, 0
  DEFB 22, 17, 6
  DEFM "1.USA"
  DEFB 22, 17, 21
  DEFM "2.URSS"
  DEFB 16, 7, 17, 0
  DEFB 22, 5, 8
  DEFM " ELIJA SU PAlS "
  DEFB 255
END ASM

evidusa:
ASM
  DEFB 16,0, 20, 1, 21, 1
  DEFB 22, 17, 5
  DEFM "       "
  DEFB 20, 0, 21, 0
  DEFB 255
END ASM

evidurss:
ASM
  DEFB 16, 0, 20, 1, 21, 1
  DEFB 22, 17, 20
  DEFM "        "
  DEFB 20, 0, 21, 0
  DEFB 255
END ASM

diff:
ASM
  DEFB 16, 0
  DEFB 22, 17, 1
  DEFM "1.FbCIL"
  DEFB 22, 17, 12
  DEFM "2.MEDIA"
  DEFB 22, 17, 22
  DEFM "3.DIFlCIL"
  DEFB 22, 5, 10
  DEFB 16, 7, 17, 0
  DEFM " DIFICULTAD "
  DEFB 255
END ASM

puntfin:
ASM
  DEFB 22, 11, 0
  DEFM "PUNTUACIoN FINAL:"
  DEFB 20, 1
  DEFB 22, 21, 0
  DEFM " PULSE UNA TECLA PARA REINICIAR "
  DEFB 20, 0
  DEFB 255
END ASM

  ' -----------------------------------------
  ' ---------- SCHERMATE COMPRESSE ----------
  ' -----------------------------------------

schermonaz:
ASM
  INCBIN "nazione-ZX7.bin"
END ASM

diffusa:
ASM
  INCBIN "difficolta_usa-ZX7.bin"
END ASM

diffurss:
ASM
  INCBIN "difficolta_urss-ZX7.bin"
END ASM